/* NaturalTime.c generated by valac 0.32.1, the Vala compiler
 * generated from NaturalTime.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_NATURAL_TIME (natural_time_get_type ())
#define NATURAL_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NATURAL_TIME, NaturalTime))
#define NATURAL_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NATURAL_TIME, NaturalTimeClass))
#define IS_NATURAL_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NATURAL_TIME))
#define IS_NATURAL_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NATURAL_TIME))
#define NATURAL_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NATURAL_TIME, NaturalTimeClass))

typedef struct _NaturalTime NaturalTime;
typedef struct _NaturalTimeClass NaturalTimeClass;
typedef struct _NaturalTimePrivate NaturalTimePrivate;

#define NATURAL_TIME_TYPE_TIME_UNIT (natural_time_time_unit_get_type ())
typedef struct _NaturalTimeTimeUnit NaturalTimeTimeUnit;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NaturalTime {
	GObject parent_instance;
	NaturalTimePrivate * priv;
};

struct _NaturalTimeClass {
	GObjectClass parent_class;
};

typedef gchar* (*NaturalTimeFormatTimeCb) (gint seconds, void* user_data);
struct _NaturalTimeTimeUnit {
	gint seconds;
	NaturalTimeFormatTimeCb format_time;
	gpointer format_time_target;
	GDestroyNotify format_time_target_destroy_notify;
};

struct _NaturalTimePrivate {
	NaturalTimeTimeUnit* _units;
	gint _units_length1;
	gint __units_size_;
};


static gpointer natural_time_parent_class = NULL;
static NaturalTime* natural_time__instance;
static NaturalTime* natural_time__instance = NULL;

GType natural_time_get_type (void) G_GNUC_CONST;
static GType natural_time_time_unit_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static NaturalTimeTimeUnit* natural_time_time_unit_dup (const NaturalTimeTimeUnit* self);
static void natural_time_time_unit_free (NaturalTimeTimeUnit* self);
static void natural_time_time_unit_copy (const NaturalTimeTimeUnit* self, NaturalTimeTimeUnit* dest);
static void natural_time_time_unit_destroy (NaturalTimeTimeUnit* self);
#define NATURAL_TIME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NATURAL_TIME, NaturalTimePrivate))
enum  {
	NATURAL_TIME_DUMMY_PROPERTY
};
static void _vala_NaturalTimeTimeUnit_array_free (NaturalTimeTimeUnit* array, gint array_length);
static NaturalTime* natural_time_new (void);
static NaturalTime* natural_time_construct (GType object_type);
static gchar* __lambda4_ (NaturalTime* self, gint time);
static gchar* ___lambda4__natural_time_format_time_cb (gint seconds, gpointer self);
static void natural_time_time_unit_init (NaturalTimeTimeUnit *self, gint seconds, NaturalTimeFormatTimeCb format_time, void* format_time_target);
static gchar* __lambda5_ (NaturalTime* self, gint time);
static gchar* ___lambda5__natural_time_format_time_cb (gint seconds, gpointer self);
static gchar* __lambda6_ (NaturalTime* self, gint time);
static gchar* ___lambda6__natural_time_format_time_cb (gint seconds, gpointer self);
static void natural_time_set_units (NaturalTime* self, NaturalTimeTimeUnit* value, int value_length1);
gchar* natural_time_get_label_for_seconds (NaturalTime* self, gint seconds, gint* output_value);
static NaturalTimeTimeUnit* natural_time_get_units (NaturalTime* self, int* result_length1);
static gchar* natural_time_time_unit_format_seconds (NaturalTimeTimeUnit *self, gint seconds, gint* output_value);
gchar* natural_time_get_simplest_label_for_seconds (NaturalTime* self, gint seconds, gint* output_value);
gchar* natural_time_get_countdown_for_seconds (NaturalTime* self, gint seconds, gint* output_value);
static gint natural_time_soften_seconds_for_countdown (NaturalTime* self, gint seconds);
gchar* natural_time_get_countdown_for_seconds_with_start (NaturalTime* self, gint seconds, gint start, gint* output_value);
static NaturalTimeTimeUnit* _vala_array_dup1 (NaturalTimeTimeUnit* self, int length);
NaturalTime* natural_time_get_instance (void);
static void natural_time_finalize (GObject* obj);
static void _vala_natural_time_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_natural_time_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _vala_NaturalTimeTimeUnit_array_free (NaturalTimeTimeUnit* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			natural_time_time_unit_destroy (&array[i]);
		}
	}
	g_free (array);
}


static gchar* __lambda4_ (NaturalTime* self, gint time) {
	gchar* result = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	_tmp0_ = time;
	_tmp1_ = ngettext ("%d second", "%d seconds", (gulong) _tmp0_);
	_tmp2_ = time;
	_tmp3_ = g_strdup_printf (_tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


static gchar* ___lambda4__natural_time_format_time_cb (gint seconds, gpointer self) {
	gchar* result;
	result = __lambda4_ ((NaturalTime*) self, seconds);
	return result;
}


static gchar* __lambda5_ (NaturalTime* self, gint time) {
	gchar* result = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	_tmp0_ = time;
	_tmp1_ = ngettext ("%d minute", "%d minutes", (gulong) _tmp0_);
	_tmp2_ = time;
	_tmp3_ = g_strdup_printf (_tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


static gchar* ___lambda5__natural_time_format_time_cb (gint seconds, gpointer self) {
	gchar* result;
	result = __lambda5_ ((NaturalTime*) self, seconds);
	return result;
}


static gchar* __lambda6_ (NaturalTime* self, gint time) {
	gchar* result = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	_tmp0_ = time;
	_tmp1_ = ngettext ("%d hour", "%d hours", (gulong) _tmp0_);
	_tmp2_ = time;
	_tmp3_ = g_strdup_printf (_tmp1_, _tmp2_);
	result = _tmp3_;
	return result;
}


static gchar* ___lambda6__natural_time_format_time_cb (gint seconds, gpointer self) {
	gchar* result;
	result = __lambda6_ ((NaturalTime*) self, seconds);
	return result;
}


static NaturalTime* natural_time_construct (GType object_type) {
	NaturalTime * self = NULL;
	NaturalTimeTimeUnit _tmp0_ = {0};
	NaturalTimeTimeUnit _tmp1_ = {0};
	NaturalTimeTimeUnit _tmp2_ = {0};
	NaturalTimeTimeUnit* _tmp3_ = NULL;
	NaturalTimeTimeUnit* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	self = (NaturalTime*) g_object_new (object_type, NULL);
	natural_time_time_unit_init (&_tmp0_, 1, ___lambda4__natural_time_format_time_cb, self);
	natural_time_time_unit_init (&_tmp1_, 60, ___lambda5__natural_time_format_time_cb, self);
	natural_time_time_unit_init (&_tmp2_, 3600, ___lambda6__natural_time_format_time_cb, self);
	_tmp3_ = g_new0 (NaturalTimeTimeUnit, 3);
	_tmp3_[0] = _tmp0_;
	_tmp3_[1] = _tmp1_;
	_tmp3_[2] = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp4__length1 = 3;
	natural_time_set_units (self, _tmp4_, 3);
	_tmp4_ = (_vala_NaturalTimeTimeUnit_array_free (_tmp4_, _tmp4__length1), NULL);
	return self;
}


static NaturalTime* natural_time_new (void) {
	return natural_time_construct (TYPE_NATURAL_TIME);
}


/**
 * Get a natural label for the given time in seconds. Converts seconds
 * to a unit that will represent the time as accurately as possible,
 * favouring precision over unit selection.
 * So, an input of 60 will return "1 minute", but 61 will return
 * "61 seconds".
 * @param seconds time in seconds.
 * @param output_value set to the numerical value of the output.
 * @return a string with a natural and accurate representation of the time.
 */
gchar* natural_time_get_label_for_seconds (NaturalTime* self, gint seconds, gint* output_value) {
	gint _vala_output_value = 0;
	gchar* result = NULL;
	NaturalTimeTimeUnit label_unit = {0};
	NaturalTimeTimeUnit* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	NaturalTimeTimeUnit* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	NaturalTimeTimeUnit _tmp2_ = {0};
	NaturalTimeTimeUnit _tmp3_ = {0};
	NaturalTimeTimeUnit* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	NaturalTimeTimeUnit* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gchar* _tmp15_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = natural_time_get_units (self, &_tmp0__length1);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	_tmp2_ = _tmp1_[0];
	natural_time_time_unit_copy (&_tmp2_, &_tmp3_);
	label_unit = _tmp3_;
	_tmp4_ = natural_time_get_units (self, &_tmp4__length1);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	{
		NaturalTimeTimeUnit* unit_collection = NULL;
		gint unit_collection_length1 = 0;
		gint _unit_collection_size_ = 0;
		gint unit_it = 0;
		unit_collection = _tmp5_;
		unit_collection_length1 = _tmp5__length1;
		for (unit_it = 0; unit_it < _tmp5__length1; unit_it = unit_it + 1) {
			NaturalTimeTimeUnit _tmp6_ = {0};
			NaturalTimeTimeUnit unit = {0};
			natural_time_time_unit_copy (&unit_collection[unit_it], &_tmp6_);
			unit = _tmp6_;
			{
				gint _tmp7_ = 0;
				NaturalTimeTimeUnit _tmp8_ = {0};
				gint _tmp9_ = 0;
				_tmp7_ = seconds;
				_tmp8_ = unit;
				_tmp9_ = _tmp8_.seconds;
				if ((_tmp7_ % _tmp9_) == 0) {
					NaturalTimeTimeUnit _tmp10_ = {0};
					NaturalTimeTimeUnit _tmp11_ = {0};
					gint _tmp12_ = 0;
					_tmp10_ = unit;
					natural_time_time_unit_copy (&_tmp10_, &_tmp11_);
					natural_time_time_unit_destroy (&label_unit);
					label_unit = _tmp11_;
					_tmp12_ = seconds;
					if (_tmp12_ == 0) {
						natural_time_time_unit_destroy (&unit);
						break;
					}
				}
				natural_time_time_unit_destroy (&unit);
			}
		}
	}
	_tmp13_ = seconds;
	_tmp15_ = natural_time_time_unit_format_seconds (&label_unit, _tmp13_, &_tmp14_);
	_vala_output_value = _tmp14_;
	result = _tmp15_;
	natural_time_time_unit_destroy (&label_unit);
	if (output_value) {
		*output_value = _vala_output_value;
	}
	return result;
}


/**
 * Get a natural label for the given time in seconds. Converts seconds
 * to a unit that will represent the time as cleanly as possible,
 * favouring the simplest possible unit over precision.
 * So, an input of 60 will return "1 minute", and 61 will return the
 * same.
 * @param seconds time in seconds.
 * @param output_value set to the numerical value of the output.
 * @return a string with a natural and accurate representation of the time.
 */
gchar* natural_time_get_simplest_label_for_seconds (NaturalTime* self, gint seconds, gint* output_value) {
	gint _vala_output_value = 0;
	gchar* result = NULL;
	NaturalTimeTimeUnit label_unit = {0};
	NaturalTimeTimeUnit* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	NaturalTimeTimeUnit* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	NaturalTimeTimeUnit _tmp2_ = {0};
	NaturalTimeTimeUnit _tmp3_ = {0};
	NaturalTimeTimeUnit* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	NaturalTimeTimeUnit* _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gchar* _tmp14_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = natural_time_get_units (self, &_tmp0__length1);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	_tmp2_ = _tmp1_[0];
	natural_time_time_unit_copy (&_tmp2_, &_tmp3_);
	label_unit = _tmp3_;
	_tmp4_ = natural_time_get_units (self, &_tmp4__length1);
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	{
		NaturalTimeTimeUnit* unit_collection = NULL;
		gint unit_collection_length1 = 0;
		gint _unit_collection_size_ = 0;
		gint unit_it = 0;
		unit_collection = _tmp5_;
		unit_collection_length1 = _tmp5__length1;
		for (unit_it = 0; unit_it < _tmp5__length1; unit_it = unit_it + 1) {
			NaturalTimeTimeUnit _tmp6_ = {0};
			NaturalTimeTimeUnit unit = {0};
			natural_time_time_unit_copy (&unit_collection[unit_it], &_tmp6_);
			unit = _tmp6_;
			{
				gint _tmp7_ = 0;
				NaturalTimeTimeUnit _tmp8_ = {0};
				gint _tmp9_ = 0;
				_tmp7_ = seconds;
				_tmp8_ = unit;
				_tmp9_ = _tmp8_.seconds;
				if (_tmp7_ >= _tmp9_) {
					NaturalTimeTimeUnit _tmp10_ = {0};
					NaturalTimeTimeUnit _tmp11_ = {0};
					_tmp10_ = unit;
					natural_time_time_unit_copy (&_tmp10_, &_tmp11_);
					natural_time_time_unit_destroy (&label_unit);
					label_unit = _tmp11_;
				}
				natural_time_time_unit_destroy (&unit);
			}
		}
	}
	_tmp12_ = seconds;
	_tmp14_ = natural_time_time_unit_format_seconds (&label_unit, _tmp12_, &_tmp13_);
	_vala_output_value = _tmp13_;
	result = _tmp14_;
	natural_time_time_unit_destroy (&label_unit);
	if (output_value) {
		*output_value = _vala_output_value;
	}
	return result;
}


/**
 * Get a natural label for the given time in seconds, in an imprecise
 * format intented for a countdown. Precision is unimportant, so this
 * function softens the time by a gradually smaller interval as seconds
 * reaches 0.
 * @param seconds number of seconds remaining in the countdown.
 * @param output_value set to the numerical value of the output.
 * @return a string representing the time remaining.
 */
gchar* natural_time_get_countdown_for_seconds (NaturalTime* self, gint seconds, gint* output_value) {
	gint _vala_output_value = 0;
	gchar* result = NULL;
	gint seconds_softened = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = seconds;
	_tmp1_ = natural_time_soften_seconds_for_countdown (self, _tmp0_);
	seconds_softened = _tmp1_;
	_tmp3_ = natural_time_get_simplest_label_for_seconds (self, seconds_softened, &_tmp2_);
	_vala_output_value = _tmp2_;
	result = _tmp3_;
	if (output_value) {
		*output_value = _vala_output_value;
	}
	return result;
}


/**
 * Get a natural label for the given time in seconds, in an imprecise
 * format intented for a countdown. Precision is unimportant, so this
 * function softens the time by a gradually smaller interval as seconds
 * reaches 0.
 * When the remaining time is near the given start time, the start time
 * is shown instead, without being softened.
 * @param seconds number of seconds remaining in the countdown.
 * @param start countdown start time, in seconds, which will be shown exactly.
 * @param output_value set to the numerical value of the output.
 * @return a string representing the time remaining.
 */
gchar* natural_time_get_countdown_for_seconds_with_start (NaturalTime* self, gint seconds, gint start, gint* output_value) {
	gint _vala_output_value = 0;
	gchar* result = NULL;
	gint seconds_softened = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gchar* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = seconds;
	_tmp1_ = natural_time_soften_seconds_for_countdown (self, _tmp0_);
	seconds_softened = _tmp1_;
	_tmp2_ = seconds_softened;
	_tmp3_ = start;
	if (_tmp2_ > _tmp3_) {
		gint _tmp4_ = 0;
		_tmp4_ = start;
		seconds_softened = _tmp4_;
	}
	_tmp5_ = seconds_softened;
	_tmp7_ = natural_time_get_simplest_label_for_seconds (self, _tmp5_, &_tmp6_);
	_vala_output_value = _tmp6_;
	result = _tmp7_;
	if (output_value) {
		*output_value = _vala_output_value;
	}
	return result;
}


static gint natural_time_soften_seconds_for_countdown (NaturalTime* self, gint seconds) {
	gint result = 0;
	gint interval = 0;
	gint _tmp0_ = 0;
	gint time_softened = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	interval = 1;
	_tmp0_ = seconds;
	if (_tmp0_ <= 10) {
		interval = 1;
	} else {
		gint _tmp1_ = 0;
		_tmp1_ = seconds;
		if (_tmp1_ <= 60) {
			interval = 10;
		} else {
			interval = 60;
		}
	}
	_tmp2_ = seconds;
	_tmp3_ = interval;
	time_softened = ((_tmp2_ - 1) / _tmp3_) + 1;
	_tmp4_ = interval;
	result = time_softened * _tmp4_;
	return result;
}


static NaturalTimeTimeUnit* natural_time_get_units (NaturalTime* self, int* result_length1) {
	NaturalTimeTimeUnit* result;
	NaturalTimeTimeUnit* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	NaturalTimeTimeUnit* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_units;
	_tmp0__length1 = self->priv->_units_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static NaturalTimeTimeUnit* _vala_array_dup1 (NaturalTimeTimeUnit* self, int length) {
	NaturalTimeTimeUnit* result;
	int i;
	result = g_new0 (NaturalTimeTimeUnit, length);
	for (i = 0; i < length; i++) {
		NaturalTimeTimeUnit _tmp0_ = {0};
		natural_time_time_unit_copy (&self[i], &_tmp0_);
		result[i] = _tmp0_;
	}
	return result;
}


static void natural_time_set_units (NaturalTime* self, NaturalTimeTimeUnit* value, int value_length1) {
	NaturalTimeTimeUnit* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	NaturalTimeTimeUnit* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__length1 = value_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	self->priv->_units = (_vala_NaturalTimeTimeUnit_array_free (self->priv->_units, self->priv->_units_length1), NULL);
	self->priv->_units = _tmp1_;
	self->priv->_units_length1 = _tmp1__length1;
	self->priv->__units_size_ = self->priv->_units_length1;
}


NaturalTime* natural_time_get_instance (void) {
	NaturalTime* result;
	NaturalTime* _tmp0_ = NULL;
	NaturalTime* _tmp2_ = NULL;
	_tmp0_ = natural_time__instance;
	if (_tmp0_ == NULL) {
		NaturalTime* _tmp1_ = NULL;
		_tmp1_ = natural_time_new ();
		_g_object_unref0 (natural_time__instance);
		natural_time__instance = _tmp1_;
	}
	_tmp2_ = natural_time__instance;
	result = _tmp2_;
	return result;
}


static void natural_time_time_unit_init (NaturalTimeTimeUnit *self, gint seconds, NaturalTimeFormatTimeCb format_time, void* format_time_target) {
	gint _tmp0_ = 0;
	NaturalTimeFormatTimeCb _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	memset (self, 0, sizeof (NaturalTimeTimeUnit));
	_tmp0_ = seconds;
	(*self).seconds = _tmp0_;
	_tmp1_ = format_time;
	_tmp1__target = format_time_target;
	((*self).format_time_target_destroy_notify == NULL) ? NULL : ((*self).format_time_target_destroy_notify ((*self).format_time_target), NULL);
	(*self).format_time = NULL;
	(*self).format_time_target = NULL;
	(*self).format_time_target_destroy_notify = NULL;
	(*self).format_time = _tmp1_;
	(*self).format_time_target = _tmp1__target;
	(*self).format_time_target_destroy_notify = NULL;
}


static gchar* natural_time_time_unit_format_seconds (NaturalTimeTimeUnit *self, gint seconds, gint* output_value) {
	gint _vala_output_value = 0;
	gchar* result = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	NaturalTimeFormatTimeCb _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = seconds;
	_tmp1_ = (*self).seconds;
	_vala_output_value = _tmp0_ / _tmp1_;
	_tmp2_ = (*self).format_time;
	_tmp2__target = (*self).format_time_target;
	_tmp3_ = _tmp2_ (_vala_output_value, _tmp2__target);
	result = _tmp3_;
	if (output_value) {
		*output_value = _vala_output_value;
	}
	return result;
}


static void natural_time_time_unit_copy (const NaturalTimeTimeUnit* self, NaturalTimeTimeUnit* dest) {
	gint _tmp0_ = 0;
	NaturalTimeFormatTimeCb _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	_tmp0_ = (*self).seconds;
	(*dest).seconds = _tmp0_;
	_tmp1_ = (*self).format_time;
	_tmp1__target = (*self).format_time_target;
	((*dest).format_time_target_destroy_notify == NULL) ? NULL : ((*dest).format_time_target_destroy_notify ((*dest).format_time_target), NULL);
	(*dest).format_time = NULL;
	(*dest).format_time_target = NULL;
	(*dest).format_time_target_destroy_notify = NULL;
	(*dest).format_time = _tmp1_;
	(*dest).format_time_target = _tmp1__target;
	(*dest).format_time_target_destroy_notify = NULL;
}


static void natural_time_time_unit_destroy (NaturalTimeTimeUnit* self) {
	((*self).format_time_target_destroy_notify == NULL) ? NULL : ((*self).format_time_target_destroy_notify ((*self).format_time_target), NULL);
	(*self).format_time = NULL;
	(*self).format_time_target = NULL;
	(*self).format_time_target_destroy_notify = NULL;
}


static NaturalTimeTimeUnit* natural_time_time_unit_dup (const NaturalTimeTimeUnit* self) {
	NaturalTimeTimeUnit* dup;
	dup = g_new0 (NaturalTimeTimeUnit, 1);
	natural_time_time_unit_copy (self, dup);
	return dup;
}


static void natural_time_time_unit_free (NaturalTimeTimeUnit* self) {
	natural_time_time_unit_destroy (self);
	g_free (self);
}


static GType natural_time_time_unit_get_type (void) {
	static volatile gsize natural_time_time_unit_type_id__volatile = 0;
	if (g_once_init_enter (&natural_time_time_unit_type_id__volatile)) {
		GType natural_time_time_unit_type_id;
		natural_time_time_unit_type_id = g_boxed_type_register_static ("NaturalTimeTimeUnit", (GBoxedCopyFunc) natural_time_time_unit_dup, (GBoxedFreeFunc) natural_time_time_unit_free);
		g_once_init_leave (&natural_time_time_unit_type_id__volatile, natural_time_time_unit_type_id);
	}
	return natural_time_time_unit_type_id__volatile;
}


static void natural_time_class_init (NaturalTimeClass * klass) {
	natural_time_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NaturalTimePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_natural_time_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_natural_time_set_property;
	G_OBJECT_CLASS (klass)->finalize = natural_time_finalize;
}


static void natural_time_instance_init (NaturalTime * self) {
	self->priv = NATURAL_TIME_GET_PRIVATE (self);
}


static void natural_time_finalize (GObject* obj) {
	NaturalTime * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NATURAL_TIME, NaturalTime);
	self->priv->_units = (_vala_NaturalTimeTimeUnit_array_free (self->priv->_units, self->priv->_units_length1), NULL);
	G_OBJECT_CLASS (natural_time_parent_class)->finalize (obj);
}


GType natural_time_get_type (void) {
	static volatile gsize natural_time_type_id__volatile = 0;
	if (g_once_init_enter (&natural_time_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NaturalTimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) natural_time_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NaturalTime), 0, (GInstanceInitFunc) natural_time_instance_init, NULL };
		GType natural_time_type_id;
		natural_time_type_id = g_type_register_static (G_TYPE_OBJECT, "NaturalTime", &g_define_type_info, 0);
		g_once_init_leave (&natural_time_type_id__volatile, natural_time_type_id);
	}
	return natural_time_type_id__volatile;
}


static void _vala_natural_time_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NaturalTime * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NATURAL_TIME, NaturalTime);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_natural_time_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NaturalTime * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NATURAL_TIME, NaturalTime);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



