/* ScreenOverlay.c generated by valac 0.32.1, the Vala compiler
 * generated from ScreenOverlay.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */
/* FIXME: Do another overlay widget and kill the set_format junk :) */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define TYPE_ISCREEN_OVERLAY_CONTENT (iscreen_overlay_content_get_type ())
#define ISCREEN_OVERLAY_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ISCREEN_OVERLAY_CONTENT, IScreenOverlayContent))
#define IS_ISCREEN_OVERLAY_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ISCREEN_OVERLAY_CONTENT))
#define ISCREEN_OVERLAY_CONTENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ISCREEN_OVERLAY_CONTENT, IScreenOverlayContentIface))

typedef struct _IScreenOverlayContent IScreenOverlayContent;
typedef struct _IScreenOverlayContentIface IScreenOverlayContentIface;

#define TYPE_SCREEN_OVERLAY (screen_overlay_get_type ())
#define SCREEN_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCREEN_OVERLAY, ScreenOverlay))
#define SCREEN_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCREEN_OVERLAY, ScreenOverlayClass))
#define IS_SCREEN_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCREEN_OVERLAY))
#define IS_SCREEN_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCREEN_OVERLAY))
#define SCREEN_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCREEN_OVERLAY, ScreenOverlayClass))

typedef struct _ScreenOverlay ScreenOverlay;
typedef struct _ScreenOverlayClass ScreenOverlayClass;
typedef struct _ScreenOverlayPrivate ScreenOverlayPrivate;

#define SCREEN_OVERLAY_TYPE_FORMAT (screen_overlay_format_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _IScreenOverlayContentIface {
	GTypeInterface parent_iface;
	void (*added_to_overlay) (IScreenOverlayContent* self);
	void (*removed_from_overlay) (IScreenOverlayContent* self);
	void (*before_fade_in) (IScreenOverlayContent* self);
	void (*before_fade_out) (IScreenOverlayContent* self);
};

struct _ScreenOverlay {
	GtkWindow parent_instance;
	ScreenOverlayPrivate * priv;
};

struct _ScreenOverlayClass {
	GtkWindowClass parent_class;
};

typedef enum  {
	SCREEN_OVERLAY_FORMAT_SILENT,
	SCREEN_OVERLAY_FORMAT_MINI,
	SCREEN_OVERLAY_FORMAT_FULL
} ScreenOverlayFormat;

struct _ScreenOverlayPrivate {
	ScreenOverlayFormat format;
	GtkGrid* wrapper_grid;
	IScreenOverlayContent* custom_content;
	guint fade_timeout;
};

typedef void (*ScreenOverlayFadeCompleteCb) (void* user_data);
struct _Block1Data {
	int _ref_count_;
	ScreenOverlay* self;
	gdouble from;
	gdouble fade_direction;
	GTimer* fade_timer;
	gdouble duration_ms;
	ScreenOverlayFadeCompleteCb complete_cb;
	gpointer complete_cb_target;
};

struct _Block2Data {
	int _ref_count_;
	ScreenOverlay* self;
	gint start_x;
	gint start_y;
	gint shake_count;
	gdouble velocity_x;
	gdouble velocity_y;
	gdouble move_x;
	gdouble move_y;
};


static gpointer screen_overlay_parent_class = NULL;

GType iscreen_overlay_content_get_type (void) G_GNUC_CONST;
void iscreen_overlay_content_added_to_overlay (IScreenOverlayContent* self);
void iscreen_overlay_content_removed_from_overlay (IScreenOverlayContent* self);
void iscreen_overlay_content_before_fade_in (IScreenOverlayContent* self);
void iscreen_overlay_content_before_fade_out (IScreenOverlayContent* self);
GType screen_overlay_get_type (void) G_GNUC_CONST;
GType screen_overlay_format_get_type (void) G_GNUC_CONST;
#define SCREEN_OVERLAY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SCREEN_OVERLAY, ScreenOverlayPrivate))
enum  {
	SCREEN_OVERLAY_DUMMY_PROPERTY
};
ScreenOverlay* screen_overlay_new (void);
ScreenOverlay* screen_overlay_construct (GType object_type);
static void screen_overlay_on_screen_composited_changed (ScreenOverlay* self, GdkScreen* screen);
static void _screen_overlay_on_screen_composited_changed_gdk_screen_composited_changed (GdkScreen* _sender, gpointer self);
static void screen_overlay_on_realize (ScreenOverlay* self);
static void _screen_overlay_on_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self);
static void screen_overlay_apply_format (ScreenOverlay* self, ScreenOverlayFormat format);
void screen_overlay_fade_out (ScreenOverlay* self);
void screen_overlay_fade_in (ScreenOverlay* self);
void screen_overlay_set_format (ScreenOverlay* self, ScreenOverlayFormat format);
static gdouble screen_overlay_ease_swing (gdouble p);
static void screen_overlay_fade_opacity (ScreenOverlay* self, gdouble duration_ms, gdouble to, ScreenOverlayFadeCompleteCb complete_cb, void* complete_cb_target);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block1Data* _data1_);
static gboolean ___lambda4__gsource_func (gpointer self);
static void ___lambda5_ (ScreenOverlay* self);
static void ____lambda5__screen_overlay_fade_complete_cb (gpointer self);
static void screen_overlay_fade_out_and_remove (ScreenOverlay* self);
static void ___lambda6_ (ScreenOverlay* self);
void screen_overlay_set_content (ScreenOverlay* self, IScreenOverlayContent* widget);
static void ____lambda6__screen_overlay_fade_complete_cb (gpointer self);
void screen_overlay_shake (ScreenOverlay* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block2Data* _data2_);
static gboolean ___lambda7__gsource_func (gpointer self);
void screen_overlay_request_attention (ScreenOverlay* self);
void screen_overlay_reveal_content (ScreenOverlay* self, IScreenOverlayContent* widget);
void screen_overlay_disappear_content (ScreenOverlay* self, IScreenOverlayContent* widget);
gboolean screen_overlay_is_showing_content (ScreenOverlay* self, IScreenOverlayContent* widget);
static void screen_overlay_finalize (GObject* obj);


void iscreen_overlay_content_added_to_overlay (IScreenOverlayContent* self) {
	g_return_if_fail (self != NULL);
	ISCREEN_OVERLAY_CONTENT_GET_INTERFACE (self)->added_to_overlay (self);
}


void iscreen_overlay_content_removed_from_overlay (IScreenOverlayContent* self) {
	g_return_if_fail (self != NULL);
	ISCREEN_OVERLAY_CONTENT_GET_INTERFACE (self)->removed_from_overlay (self);
}


void iscreen_overlay_content_before_fade_in (IScreenOverlayContent* self) {
	g_return_if_fail (self != NULL);
	ISCREEN_OVERLAY_CONTENT_GET_INTERFACE (self)->before_fade_in (self);
}


void iscreen_overlay_content_before_fade_out (IScreenOverlayContent* self) {
	g_return_if_fail (self != NULL);
	ISCREEN_OVERLAY_CONTENT_GET_INTERFACE (self)->before_fade_out (self);
}


static void iscreen_overlay_content_base_init (IScreenOverlayContentIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType iscreen_overlay_content_get_type (void) {
	static volatile gsize iscreen_overlay_content_type_id__volatile = 0;
	if (g_once_init_enter (&iscreen_overlay_content_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IScreenOverlayContentIface), (GBaseInitFunc) iscreen_overlay_content_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType iscreen_overlay_content_type_id;
		iscreen_overlay_content_type_id = g_type_register_static (G_TYPE_INTERFACE, "IScreenOverlayContent", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (iscreen_overlay_content_type_id, gtk_widget_get_type ());
		g_once_init_leave (&iscreen_overlay_content_type_id__volatile, iscreen_overlay_content_type_id);
	}
	return iscreen_overlay_content_type_id__volatile;
}


GType screen_overlay_format_get_type (void) {
	static volatile gsize screen_overlay_format_type_id__volatile = 0;
	if (g_once_init_enter (&screen_overlay_format_type_id__volatile)) {
		static const GEnumValue values[] = {{SCREEN_OVERLAY_FORMAT_SILENT, "SCREEN_OVERLAY_FORMAT_SILENT", "silent"}, {SCREEN_OVERLAY_FORMAT_MINI, "SCREEN_OVERLAY_FORMAT_MINI", "mini"}, {SCREEN_OVERLAY_FORMAT_FULL, "SCREEN_OVERLAY_FORMAT_FULL", "full"}, {0, NULL, NULL}};
		GType screen_overlay_format_type_id;
		screen_overlay_format_type_id = g_enum_register_static ("ScreenOverlayFormat", values);
		g_once_init_leave (&screen_overlay_format_type_id__volatile, screen_overlay_format_type_id);
	}
	return screen_overlay_format_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _screen_overlay_on_screen_composited_changed_gdk_screen_composited_changed (GdkScreen* _sender, gpointer self) {
	screen_overlay_on_screen_composited_changed ((ScreenOverlay*) self, _sender);
}


static void _screen_overlay_on_realize_gtk_widget_realize (GtkWidget* _sender, gpointer self) {
	screen_overlay_on_realize ((ScreenOverlay*) self);
}


ScreenOverlay* screen_overlay_construct (GType object_type) {
	ScreenOverlay * self = NULL;
	GtkGrid* _tmp0_ = NULL;
	GtkGrid* _tmp1_ = NULL;
	GtkGrid* _tmp2_ = NULL;
	GtkGrid* _tmp3_ = NULL;
	GtkGrid* _tmp4_ = NULL;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp5_ = NULL;
	GdkScreen* _tmp6_ = NULL;
	GtkStyleContext* style = NULL;
	GtkStyleContext* _tmp7_ = NULL;
	GtkStyleContext* _tmp8_ = NULL;
	self = (ScreenOverlay*) g_object_new (object_type, "type", GTK_WINDOW_POPUP, NULL);
	self->priv->format = SCREEN_OVERLAY_FORMAT_FULL;
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->wrapper_grid);
	self->priv->wrapper_grid = _tmp0_;
	_tmp1_ = self->priv->wrapper_grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->wrapper_grid;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	_tmp3_ = self->priv->wrapper_grid;
	gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	_tmp4_ = self->priv->wrapper_grid;
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
	_tmp5_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp6_ = _g_object_ref0 (_tmp5_);
	screen = _tmp6_;
	g_signal_connect_object (screen, "composited-changed", (GCallback) _screen_overlay_on_screen_composited_changed_gdk_screen_composited_changed, self, 0);
	screen_overlay_on_screen_composited_changed (self, screen);
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp8_ = _g_object_ref0 (_tmp7_);
	style = _tmp8_;
	gtk_style_context_add_class (style, "_screen-overlay");
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) _screen_overlay_on_realize_gtk_widget_realize, self, 0);
	gtk_widget_realize ((GtkWidget*) self);
	_g_object_unref0 (style);
	_g_object_unref0 (screen);
	return self;
}


ScreenOverlay* screen_overlay_new (void) {
	return screen_overlay_construct (TYPE_SCREEN_OVERLAY);
}


static void screen_overlay_on_screen_composited_changed (ScreenOverlay* self, GdkScreen* screen) {
	GdkVisual* screen_visual = NULL;
	GdkScreen* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GdkVisual* _tmp5_ = NULL;
	GdkVisual* _tmp9_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	screen_visual = NULL;
	_tmp0_ = screen;
	_tmp1_ = gdk_screen_is_composited (_tmp0_);
	if (_tmp1_) {
		GdkScreen* _tmp2_ = NULL;
		GdkVisual* _tmp3_ = NULL;
		GdkVisual* _tmp4_ = NULL;
		_tmp2_ = screen;
		_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (screen_visual);
		screen_visual = _tmp4_;
	}
	_tmp5_ = screen_visual;
	if (_tmp5_ == NULL) {
		GdkScreen* _tmp6_ = NULL;
		GdkVisual* _tmp7_ = NULL;
		GdkVisual* _tmp8_ = NULL;
		_tmp6_ = screen;
		_tmp7_ = gdk_screen_get_system_visual (_tmp6_);
		_tmp8_ = _g_object_ref0 (_tmp7_);
		_g_object_unref0 (screen_visual);
		screen_visual = _tmp8_;
	}
	_tmp9_ = screen_visual;
	gtk_widget_set_visual ((GtkWidget*) self, _tmp9_);
	_g_object_unref0 (screen_visual);
}


static void screen_overlay_on_realize (ScreenOverlay* self) {
	ScreenOverlayFormat _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->format;
	screen_overlay_apply_format (self, _tmp0_);
}


static void screen_overlay_apply_format (ScreenOverlay* self, ScreenOverlayFormat format) {
	ScreenOverlayFormat _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = format;
	switch (_tmp0_) {
		case SCREEN_OVERLAY_FORMAT_SILENT:
		{
			screen_overlay_fade_out (self);
			break;
		}
		case SCREEN_OVERLAY_FORMAT_MINI:
		{
			gtk_widget_input_shape_combine_region ((GtkWidget*) self, (cairo_region_t*) NULL);
			gtk_widget_set_size_request ((GtkWidget*) self, -1, -1);
			gtk_window_resize ((GtkWindow*) self, 1, 1);
			screen_overlay_fade_in (self);
			break;
		}
		case SCREEN_OVERLAY_FORMAT_FULL:
		{
			cairo_region_t* _tmp1_ = NULL;
			cairo_region_t* _tmp2_ = NULL;
			GdkScreen* screen = NULL;
			GdkScreen* _tmp3_ = NULL;
			GdkScreen* _tmp4_ = NULL;
			gint monitor = 0;
			GdkScreen* _tmp5_ = NULL;
			GdkWindow* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			GdkRectangle geom = {0};
			GdkScreen* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			GdkRectangle _tmp10_ = {0};
			gchar* session = NULL;
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			_tmp1_ = cairo_region_create ();
			_tmp2_ = _tmp1_;
			gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp2_);
			_cairo_region_destroy0 (_tmp2_);
			_tmp3_ = gtk_window_get_screen ((GtkWindow*) self);
			_tmp4_ = _g_object_ref0 (_tmp3_);
			screen = _tmp4_;
			_tmp5_ = screen;
			_tmp6_ = gtk_widget_get_window ((GtkWidget*) self);
			_tmp7_ = gdk_screen_get_monitor_at_window (_tmp5_, _tmp6_);
			monitor = _tmp7_;
			_tmp8_ = screen;
			_tmp9_ = monitor;
			gdk_screen_get_monitor_geometry (_tmp8_, _tmp9_, &_tmp10_);
			geom = _tmp10_;
			_tmp11_ = g_getenv ("DESKTOP_SESSION");
			_tmp12_ = g_strdup (_tmp11_);
			session = _tmp12_;
			_tmp13_ = session;
			if (g_strcmp0 (_tmp13_, "gnome-shell") == 0) {
				GdkRectangle _tmp14_ = {0};
				gint _tmp15_ = 0;
				GdkRectangle _tmp16_ = {0};
				gint _tmp17_ = 0;
				_tmp14_ = geom;
				_tmp15_ = _tmp14_.width;
				_tmp16_ = geom;
				_tmp17_ = _tmp16_.height;
				gtk_widget_set_size_request ((GtkWidget*) self, _tmp15_, _tmp17_ - 1);
				gtk_window_move ((GtkWindow*) self, 0, 1);
			} else {
				GdkRectangle _tmp18_ = {0};
				gint _tmp19_ = 0;
				GdkRectangle _tmp20_ = {0};
				gint _tmp21_ = 0;
				_tmp18_ = geom;
				_tmp19_ = _tmp18_.width;
				_tmp20_ = geom;
				_tmp21_ = _tmp20_.height;
				gtk_widget_set_size_request ((GtkWidget*) self, _tmp19_, _tmp21_);
			}
			screen_overlay_fade_in (self);
			_g_free0 (session);
			_g_object_unref0 (screen);
			break;
		}
		default:
		break;
	}
}


void screen_overlay_set_format (ScreenOverlay* self, ScreenOverlayFormat format) {
	ScreenOverlayFormat _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = format;
	self->priv->format = _tmp0_;
	_tmp1_ = gtk_widget_get_realized ((GtkWidget*) self);
	if (_tmp1_) {
		ScreenOverlayFormat _tmp2_ = 0;
		_tmp2_ = format;
		screen_overlay_apply_format (self, _tmp2_);
	}
}


static gdouble screen_overlay_ease_swing (gdouble p) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp0_ = p;
	_tmp1_ = cos (_tmp0_ * G_PI);
	result = 0.5 - (_tmp1_ / 2.0);
	return result;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		ScreenOverlay* self;
		self = _data1_->self;
		_g_timer_destroy0 (_data1_->fade_timer);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean __lambda4_ (Block1Data* _data1_) {
	ScreenOverlay* self;
	gboolean result = FALSE;
	gdouble elapsed_ms = 0.0;
	GTimer* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble percent = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble opacity = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gboolean do_continue = FALSE;
	gdouble _tmp11_ = 0.0;
	gboolean _tmp12_ = FALSE;
	self = _data1_->self;
	_tmp0_ = _data1_->fade_timer;
	_tmp1_ = g_timer_elapsed (_tmp0_, NULL);
	elapsed_ms = _tmp1_ * 1000.0;
	_tmp2_ = elapsed_ms;
	_tmp3_ = _data1_->duration_ms;
	percent = _tmp2_ / _tmp3_;
	_tmp4_ = percent;
	_tmp5_ = CLAMP (_tmp4_, (gdouble) 0, (gdouble) 1);
	percent = _tmp5_;
	_tmp6_ = _data1_->from;
	_tmp7_ = _data1_->fade_direction;
	_tmp8_ = percent;
	_tmp9_ = screen_overlay_ease_swing (_tmp8_);
	opacity = _tmp6_ + (_tmp7_ * _tmp9_);
	_tmp10_ = opacity;
	gtk_window_set_opacity ((GtkWindow*) self, _tmp10_);
	_tmp11_ = percent;
	do_continue = _tmp11_ < 1.0;
	_tmp12_ = do_continue;
	if (!_tmp12_) {
		ScreenOverlayFadeCompleteCb _tmp13_ = NULL;
		void* _tmp13__target = NULL;
		_tmp13_ = _data1_->complete_cb;
		_tmp13__target = _data1_->complete_cb_target;
		if (_tmp13_ != NULL) {
			ScreenOverlayFadeCompleteCb _tmp14_ = NULL;
			void* _tmp14__target = NULL;
			_tmp14_ = _data1_->complete_cb;
			_tmp14__target = _data1_->complete_cb_target;
			_tmp14_ (_tmp14__target);
		}
	}
	result = do_continue;
	return result;
}


static gboolean ___lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda4_ (self);
	return result;
}


static void screen_overlay_fade_opacity (ScreenOverlay* self, gdouble duration_ms, gdouble to, ScreenOverlayFadeCompleteCb complete_cb, void* complete_cb_target) {
	Block1Data* _data1_;
	gdouble _tmp0_ = 0.0;
	ScreenOverlayFadeCompleteCb _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	gboolean _tmp2_ = FALSE;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	GTimer* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	guint _tmp10_ = 0U;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = duration_ms;
	_data1_->duration_ms = _tmp0_;
	_tmp1_ = complete_cb;
	_tmp1__target = complete_cb_target;
	_data1_->complete_cb = _tmp1_;
	_data1_->complete_cb_target = _tmp1__target;
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) self);
	if (_tmp2_) {
		gdouble _tmp3_ = 0.0;
		_tmp3_ = gtk_window_get_opacity ((GtkWindow*) self);
		_data1_->from = _tmp3_;
	} else {
		gdouble _tmp4_ = 0.0;
		_data1_->from = 0.0;
		_tmp4_ = _data1_->from;
		gtk_window_set_opacity ((GtkWindow*) self, _tmp4_);
		gtk_widget_show ((GtkWidget*) self);
	}
	_tmp5_ = to;
	_tmp6_ = _data1_->from;
	_data1_->fade_direction = (gdouble) (_tmp5_ - _tmp6_);
	_tmp7_ = g_timer_new ();
	_data1_->fade_timer = _tmp7_;
	_tmp8_ = self->priv->fade_timeout;
	if (_tmp8_ > ((guint) 0)) {
		guint _tmp9_ = 0U;
		_tmp9_ = self->priv->fade_timeout;
		g_source_remove (_tmp9_);
	}
	_tmp10_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 20, ___lambda4__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	self->priv->fade_timeout = _tmp10_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


void screen_overlay_fade_in (ScreenOverlay* self) {
	ScreenOverlayFormat _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->format;
	if (_tmp0_ != SCREEN_OVERLAY_FORMAT_SILENT) {
		IScreenOverlayContent* _tmp1_ = NULL;
		_tmp1_ = self->priv->custom_content;
		if (_tmp1_ != NULL) {
			IScreenOverlayContent* _tmp2_ = NULL;
			_tmp2_ = self->priv->custom_content;
			iscreen_overlay_content_before_fade_in (_tmp2_);
			screen_overlay_fade_opacity (self, (gdouble) 2000, (gdouble) 1, NULL, NULL);
		}
	}
}


static void ___lambda5_ (ScreenOverlay* self) {
	gtk_widget_hide ((GtkWidget*) self);
}


static void ____lambda5__screen_overlay_fade_complete_cb (gpointer self) {
	___lambda5_ ((ScreenOverlay*) self);
}


void screen_overlay_fade_out (ScreenOverlay* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
	if (_tmp0_) {
		IScreenOverlayContent* _tmp1_ = NULL;
		_tmp1_ = self->priv->custom_content;
		if (_tmp1_ != NULL) {
			IScreenOverlayContent* _tmp2_ = NULL;
			_tmp2_ = self->priv->custom_content;
			iscreen_overlay_content_before_fade_out (_tmp2_);
		}
		screen_overlay_fade_opacity (self, (gdouble) 1500, (gdouble) 0, ____lambda5__screen_overlay_fade_complete_cb, self);
	}
}


static void ___lambda6_ (ScreenOverlay* self) {
	gtk_widget_hide ((GtkWidget*) self);
	screen_overlay_set_content (self, NULL);
}


static void ____lambda6__screen_overlay_fade_complete_cb (gpointer self) {
	___lambda6_ ((ScreenOverlay*) self);
}


static void screen_overlay_fade_out_and_remove (ScreenOverlay* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
	if (_tmp0_) {
		IScreenOverlayContent* _tmp1_ = NULL;
		_tmp1_ = self->priv->custom_content;
		if (_tmp1_ != NULL) {
			IScreenOverlayContent* _tmp2_ = NULL;
			_tmp2_ = self->priv->custom_content;
			iscreen_overlay_content_before_fade_out (_tmp2_);
		}
		screen_overlay_fade_opacity (self, (gdouble) 1500, (gdouble) 0, ____lambda6__screen_overlay_fade_complete_cb, self);
	} else {
		screen_overlay_set_content (self, NULL);
	}
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		ScreenOverlay* self;
		self = _data2_->self;
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean __lambda7_ (Block2Data* _data2_) {
	ScreenOverlay* self;
	gboolean result = FALSE;
	self = _data2_->self;
	if (_data2_->shake_count < 42) {
		gboolean _tmp0_ = FALSE;
		if ((_data2_->move_x - _data2_->start_x) > ((gdouble) 6)) {
			_tmp0_ = TRUE;
		} else {
			_tmp0_ = (_data2_->move_x - _data2_->start_x) < ((gdouble) -6);
		}
		if (_tmp0_) {
			_data2_->velocity_x = -_data2_->velocity_x;
		}
		_data2_->move_x = _data2_->move_x + _data2_->velocity_x;
		_data2_->move_y = _data2_->move_y + _data2_->velocity_y;
		gtk_window_move ((GtkWindow*) self, (gint) _data2_->move_x, (gint) _data2_->move_y);
		_data2_->shake_count = _data2_->shake_count + 1;
		result = TRUE;
		return result;
	} else {
		gtk_window_move ((GtkWindow*) self, _data2_->start_x, _data2_->start_y);
		result = FALSE;
		return result;
	}
}


static gboolean ___lambda7__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda7_ (self);
	return result;
}


void screen_overlay_shake (ScreenOverlay* self) {
	Block2Data* _data2_;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	_data2_->start_x = _tmp0_;
	_data2_->start_y = _tmp1_;
	_data2_->shake_count = 0;
	_data2_->velocity_x = 1.5;
	_data2_->velocity_y = (gdouble) 0;
	_data2_->move_x = (gdouble) _data2_->start_x;
	_data2_->move_y = (gdouble) _data2_->start_y;
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 15, ___lambda7__gsource_func, block2_data_ref (_data2_), block2_data_unref);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}


void screen_overlay_request_attention (ScreenOverlay* self) {
	GdkWindow* gdk_window = NULL;
	GdkWindow* _tmp0_ = NULL;
	GdkWindow* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	screen_overlay_shake (self);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	gdk_window = _tmp1_;
	gdk_window_beep (gdk_window);
	_g_object_unref0 (gdk_window);
}


void screen_overlay_set_content (ScreenOverlay* self, IScreenOverlayContent* widget) {
	IScreenOverlayContent* _tmp0_ = NULL;
	IScreenOverlayContent* _tmp4_ = NULL;
	IScreenOverlayContent* _tmp8_ = NULL;
	IScreenOverlayContent* _tmp9_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->custom_content;
	if (_tmp0_ != NULL) {
		IScreenOverlayContent* _tmp1_ = NULL;
		GtkGrid* _tmp2_ = NULL;
		IScreenOverlayContent* _tmp3_ = NULL;
		_tmp1_ = self->priv->custom_content;
		iscreen_overlay_content_removed_from_overlay (_tmp1_);
		_tmp2_ = self->priv->wrapper_grid;
		_tmp3_ = self->priv->custom_content;
		gtk_container_remove ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp3_);
	}
	_tmp4_ = widget;
	if (_tmp4_ != NULL) {
		IScreenOverlayContent* _tmp5_ = NULL;
		GtkGrid* _tmp6_ = NULL;
		IScreenOverlayContent* _tmp7_ = NULL;
		_tmp5_ = widget;
		iscreen_overlay_content_added_to_overlay (_tmp5_);
		_tmp6_ = self->priv->wrapper_grid;
		_tmp7_ = widget;
		gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	}
	_tmp8_ = widget;
	_tmp9_ = _g_object_ref0 (_tmp8_);
	_g_object_unref0 (self->priv->custom_content);
	self->priv->custom_content = _tmp9_;
}


void screen_overlay_reveal_content (ScreenOverlay* self, IScreenOverlayContent* widget) {
	IScreenOverlayContent* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = widget;
	screen_overlay_set_content (self, _tmp0_);
	screen_overlay_fade_in (self);
}


void screen_overlay_disappear_content (ScreenOverlay* self, IScreenOverlayContent* widget) {
	IScreenOverlayContent* _tmp0_ = NULL;
	IScreenOverlayContent* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->custom_content;
	_tmp1_ = widget;
	if (_tmp0_ == _tmp1_) {
		screen_overlay_fade_out_and_remove (self);
	}
}


gboolean screen_overlay_is_showing_content (ScreenOverlay* self, IScreenOverlayContent* widget) {
	gboolean result = FALSE;
	IScreenOverlayContent* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = widget;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		_tmp2_ = gtk_widget_get_visible ((GtkWidget*) self);
		if (_tmp2_) {
			IScreenOverlayContent* _tmp3_ = NULL;
			IScreenOverlayContent* _tmp4_ = NULL;
			_tmp3_ = self->priv->custom_content;
			_tmp4_ = widget;
			_tmp1_ = _tmp3_ == _tmp4_;
		} else {
			_tmp1_ = FALSE;
		}
		result = _tmp1_;
		return result;
	}
}


static void screen_overlay_class_init (ScreenOverlayClass * klass) {
	screen_overlay_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ScreenOverlayPrivate));
	G_OBJECT_CLASS (klass)->finalize = screen_overlay_finalize;
}


static void screen_overlay_instance_init (ScreenOverlay * self) {
	self->priv = SCREEN_OVERLAY_GET_PRIVATE (self);
}


static void screen_overlay_finalize (GObject* obj) {
	ScreenOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SCREEN_OVERLAY, ScreenOverlay);
	_g_object_unref0 (self->priv->wrapper_grid);
	_g_object_unref0 (self->priv->custom_content);
	G_OBJECT_CLASS (screen_overlay_parent_class)->finalize (obj);
}


GType screen_overlay_get_type (void) {
	static volatile gsize screen_overlay_type_id__volatile = 0;
	if (g_once_init_enter (&screen_overlay_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ScreenOverlayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) screen_overlay_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ScreenOverlay), 0, (GInstanceInitFunc) screen_overlay_instance_init, NULL };
		GType screen_overlay_type_id;
		screen_overlay_type_id = g_type_register_static (gtk_window_get_type (), "ScreenOverlay", &g_define_type_info, 0);
		g_once_init_leave (&screen_overlay_type_id__volatile, screen_overlay_type_id);
	}
	return screen_overlay_type_id__volatile;
}



