/* SessionStatus.c generated by valac 0.32.1, the Vala compiler
 * generated from SessionStatus.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>
#include <common.h>
#include <gtk/gtk.h>
#include <stdlib.h>


#define TYPE_ISCREEN_SAVER (iscreen_saver_get_type ())
#define ISCREEN_SAVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ISCREEN_SAVER, IScreenSaver))
#define IS_ISCREEN_SAVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ISCREEN_SAVER))
#define ISCREEN_SAVER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ISCREEN_SAVER, IScreenSaverIface))

typedef struct _IScreenSaver IScreenSaver;
typedef struct _IScreenSaverIface IScreenSaverIface;

#define TYPE_ISCREEN_SAVER_PROXY (iscreen_saver_proxy_get_type ())
typedef GDBusProxy IScreenSaverProxy;
typedef GDBusProxyClass IScreenSaverProxyClass;

#define TYPE_SESSION_STATUS (session_status_get_type ())
#define SESSION_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SESSION_STATUS, SessionStatus))
#define SESSION_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SESSION_STATUS, SessionStatusClass))
#define IS_SESSION_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SESSION_STATUS))
#define IS_SESSION_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SESSION_STATUS))
#define SESSION_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SESSION_STATUS, SessionStatusClass))

typedef struct _SessionStatus SessionStatus;
typedef struct _SessionStatusClass SessionStatusClass;
typedef struct _SessionStatusPrivate SessionStatusPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _IScreenSaverIface {
	GTypeInterface parent_iface;
	gboolean (*get_active) (IScreenSaver* self, GError** error);
	guint32 (*get_active_time) (IScreenSaver* self, GError** error);
	void (*lock) (IScreenSaver* self, GError** error);
	void (*set_active) (IScreenSaver* self, gboolean active, GError** error);
};

struct _SessionStatus {
	GObject parent_instance;
	SessionStatusPrivate * priv;
};

struct _SessionStatusClass {
	GObjectClass parent_class;
};

struct _SessionStatusPrivate {
	GtkApplication* application;
	IScreenSaver* screensaver;
	gboolean screensaver_is_active;
};


static gpointer session_status_parent_class = NULL;
static ISessionStatusIface* session_status_isession_status_parent_iface = NULL;

GType iscreen_saver_proxy_get_type (void) G_GNUC_CONST;
guint iscreen_saver_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType iscreen_saver_get_type (void) G_GNUC_CONST;
gboolean iscreen_saver_get_active (IScreenSaver* self, GError** error);
guint32 iscreen_saver_get_active_time (IScreenSaver* self, GError** error);
void iscreen_saver_lock (IScreenSaver* self, GError** error);
void iscreen_saver_set_active (IScreenSaver* self, gboolean active, GError** error);
static void iscreen_saver_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_iscreen_saver_active_changed (IScreenSaver* self, GVariant* parameters);
static gboolean iscreen_saver_proxy_get_active (IScreenSaver* self, GError** error);
static guint32 iscreen_saver_proxy_get_active_time (IScreenSaver* self, GError** error);
static void iscreen_saver_proxy_lock (IScreenSaver* self, GError** error);
static void iscreen_saver_proxy_set_active (IScreenSaver* self, gboolean active, GError** error);
static void iscreen_saver_proxy_iscreen_saver_interface_init (IScreenSaverIface* iface);
static void _dbus_iscreen_saver_get_active (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_iscreen_saver_get_active_time (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_iscreen_saver_lock (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void _dbus_iscreen_saver_set_active (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation);
static void iscreen_saver_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* iscreen_saver_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean iscreen_saver_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_iscreen_saver_active_changed (GObject* _sender, gboolean active, gpointer* _data);
static void _iscreen_saver_unregister_object (gpointer user_data);
GType session_status_get_type (void) G_GNUC_CONST;
#define SESSION_STATUS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SESSION_STATUS, SessionStatusPrivate))
enum  {
	SESSION_STATUS_DUMMY_PROPERTY
};
SessionStatus* session_status_new (GtkApplication* application);
SessionStatus* session_status_construct (GType object_type, GtkApplication* application);
static void session_status_screensaver_appeared (SessionStatus* self);
static void _session_status_screensaver_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self);
static void session_status_screensaver_disappeared (SessionStatus* self);
static void _session_status_screensaver_disappeared_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self);
static void session_status_screensaver_active_changed_cb (SessionStatus* self, gboolean active);
static void _session_status_screensaver_active_changed_cb_iscreen_saver_active_changed (IScreenSaver* _sender, gboolean active, gpointer self);
static gboolean session_status_real_is_locked (ISessionStatus* base);
static void session_status_real_lock_screen (ISessionStatus* base);
static void session_status_real_blank_screen (ISessionStatus* base);
static void session_status_real_unblank_screen (ISessionStatus* base);
static void session_status_finalize (GObject* obj);

static const GDBusArgInfo _iscreen_saver_dbus_arg_info_get_active_result = {-1, "result", "b"};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_get_active_in[] = {NULL};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_get_active_out[] = {&_iscreen_saver_dbus_arg_info_get_active_result, NULL};
static const GDBusMethodInfo _iscreen_saver_dbus_method_info_get_active = {-1, "GetActive", (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_get_active_in), (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_get_active_out)};
static const GDBusArgInfo _iscreen_saver_dbus_arg_info_get_active_time_result = {-1, "result", "u"};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_get_active_time_in[] = {NULL};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_get_active_time_out[] = {&_iscreen_saver_dbus_arg_info_get_active_time_result, NULL};
static const GDBusMethodInfo _iscreen_saver_dbus_method_info_get_active_time = {-1, "GetActiveTime", (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_get_active_time_in), (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_get_active_time_out)};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_lock_in[] = {NULL};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_lock_out[] = {NULL};
static const GDBusMethodInfo _iscreen_saver_dbus_method_info_lock = {-1, "Lock", (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_lock_in), (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_lock_out)};
static const GDBusArgInfo _iscreen_saver_dbus_arg_info_set_active_active = {-1, "active", "b"};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_set_active_in[] = {&_iscreen_saver_dbus_arg_info_set_active_active, NULL};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_set_active_out[] = {NULL};
static const GDBusMethodInfo _iscreen_saver_dbus_method_info_set_active = {-1, "SetActive", (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_set_active_in), (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_set_active_out)};
static const GDBusMethodInfo * const _iscreen_saver_dbus_method_info[] = {&_iscreen_saver_dbus_method_info_get_active, &_iscreen_saver_dbus_method_info_get_active_time, &_iscreen_saver_dbus_method_info_lock, &_iscreen_saver_dbus_method_info_set_active, NULL};
static const GDBusArgInfo _iscreen_saver_dbus_arg_info_active_changed_active = {-1, "active", "b"};
static const GDBusArgInfo * const _iscreen_saver_dbus_arg_info_active_changed[] = {&_iscreen_saver_dbus_arg_info_active_changed_active, NULL};
static const GDBusSignalInfo _iscreen_saver_dbus_signal_info_active_changed = {-1, "ActiveChanged", (GDBusArgInfo **) (&_iscreen_saver_dbus_arg_info_active_changed)};
static const GDBusSignalInfo * const _iscreen_saver_dbus_signal_info[] = {&_iscreen_saver_dbus_signal_info_active_changed, NULL};
static const GDBusPropertyInfo * const _iscreen_saver_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _iscreen_saver_dbus_interface_info = {-1, "org.gnome.ScreenSaver", (GDBusMethodInfo **) (&_iscreen_saver_dbus_method_info), (GDBusSignalInfo **) (&_iscreen_saver_dbus_signal_info), (GDBusPropertyInfo **) (&_iscreen_saver_dbus_property_info)};
static const GDBusInterfaceVTable _iscreen_saver_dbus_interface_vtable = {iscreen_saver_dbus_interface_method_call, iscreen_saver_dbus_interface_get_property, iscreen_saver_dbus_interface_set_property};

gboolean iscreen_saver_get_active (IScreenSaver* self, GError** error) {
	g_return_val_if_fail (self != NULL, FALSE);
	return ISCREEN_SAVER_GET_INTERFACE (self)->get_active (self, error);
}


guint32 iscreen_saver_get_active_time (IScreenSaver* self, GError** error) {
	g_return_val_if_fail (self != NULL, 0U);
	return ISCREEN_SAVER_GET_INTERFACE (self)->get_active_time (self, error);
}


void iscreen_saver_lock (IScreenSaver* self, GError** error) {
	g_return_if_fail (self != NULL);
	ISCREEN_SAVER_GET_INTERFACE (self)->lock (self, error);
}


void iscreen_saver_set_active (IScreenSaver* self, gboolean active, GError** error) {
	g_return_if_fail (self != NULL);
	ISCREEN_SAVER_GET_INTERFACE (self)->set_active (self, active, error);
}


static void iscreen_saver_base_init (IScreenSaverIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("active_changed", TYPE_ISCREEN_SAVER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	}
}


GType iscreen_saver_get_type (void) {
	static volatile gsize iscreen_saver_type_id__volatile = 0;
	if (g_once_init_enter (&iscreen_saver_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IScreenSaverIface), (GBaseInitFunc) iscreen_saver_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType iscreen_saver_type_id;
		iscreen_saver_type_id = g_type_register_static (G_TYPE_INTERFACE, "IScreenSaver", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (iscreen_saver_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (iscreen_saver_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) iscreen_saver_proxy_get_type);
		g_type_set_qdata (iscreen_saver_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.ScreenSaver");
		g_type_set_qdata (iscreen_saver_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_iscreen_saver_dbus_interface_info));
		g_type_set_qdata (iscreen_saver_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) iscreen_saver_register_object);
		g_once_init_leave (&iscreen_saver_type_id__volatile, iscreen_saver_type_id);
	}
	return iscreen_saver_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (IScreenSaverProxy, iscreen_saver_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_ISCREEN_SAVER, iscreen_saver_proxy_iscreen_saver_interface_init) )
static void iscreen_saver_proxy_class_init (IScreenSaverProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = iscreen_saver_proxy_g_signal;
}


static void _dbus_handle_iscreen_saver_active_changed (IScreenSaver* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gboolean active = FALSE;
	GVariant* _tmp8_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	active = g_variant_get_boolean (_tmp8_);
	g_variant_unref (_tmp8_);
	g_signal_emit_by_name (self, "active-changed", active);
}


static void iscreen_saver_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "ActiveChanged") == 0) {
		_dbus_handle_iscreen_saver_active_changed ((IScreenSaver*) proxy, parameters);
	}
}


static void iscreen_saver_proxy_init (IScreenSaverProxy* self) {
}


static gboolean iscreen_saver_proxy_get_active (IScreenSaver* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result;
	GVariant* _tmp9_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ScreenSaver", "GetActive");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return FALSE;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return FALSE;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp9_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp9_);
	g_variant_unref (_tmp9_);
	g_object_unref (_reply_message);
	return _result;
}


static guint32 iscreen_saver_proxy_get_active_time (IScreenSaver* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result;
	GVariant* _tmp10_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ScreenSaver", "GetActiveTime");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return 0U;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return 0U;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp10_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp10_);
	g_variant_unref (_tmp10_);
	g_object_unref (_reply_message);
	return _result;
}


static void iscreen_saver_proxy_lock (IScreenSaver* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ScreenSaver", "Lock");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void iscreen_saver_proxy_set_active (IScreenSaver* self, gboolean active, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.ScreenSaver", "SetActive");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (active));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void iscreen_saver_proxy_iscreen_saver_interface_init (IScreenSaverIface* iface) {
	iface->get_active = iscreen_saver_proxy_get_active;
	iface->get_active_time = iscreen_saver_proxy_get_active_time;
	iface->lock = iscreen_saver_proxy_lock;
	iface->set_active = iscreen_saver_proxy_set_active;
}


static void _dbus_iscreen_saver_get_active (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = iscreen_saver_get_active (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_iscreen_saver_get_active_time (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = iscreen_saver_get_active_time (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_iscreen_saver_lock (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	iscreen_saver_lock (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_iscreen_saver_set_active (IScreenSaver* self, GVariant* _parameters_, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gboolean active = FALSE;
	GVariant* _tmp11_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	active = g_variant_get_boolean (_tmp11_);
	g_variant_unref (_tmp11_);
	iscreen_saver_set_active (self, active, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void iscreen_saver_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetActive") == 0) {
		_dbus_iscreen_saver_get_active (object, parameters, invocation);
	} else if (strcmp (method_name, "GetActiveTime") == 0) {
		_dbus_iscreen_saver_get_active_time (object, parameters, invocation);
	} else if (strcmp (method_name, "Lock") == 0) {
		_dbus_iscreen_saver_lock (object, parameters, invocation);
	} else if (strcmp (method_name, "SetActive") == 0) {
		_dbus_iscreen_saver_set_active (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* iscreen_saver_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean iscreen_saver_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_iscreen_saver_active_changed (GObject* _sender, gboolean active, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (active));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.ScreenSaver", "ActiveChanged", _arguments, NULL);
}


guint iscreen_saver_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_iscreen_saver_dbus_interface_info), &_iscreen_saver_dbus_interface_vtable, data, _iscreen_saver_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "active-changed", (GCallback) _dbus_iscreen_saver_active_changed, data);
	return result;
}


static void _iscreen_saver_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_iscreen_saver_active_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _session_status_screensaver_appeared_gbus_name_appeared_callback (GDBusConnection* connection, const gchar* name, const gchar* name_owner, gpointer self) {
	session_status_screensaver_appeared ((SessionStatus*) self);
}


static void _session_status_screensaver_disappeared_gbus_name_vanished_callback (GDBusConnection* connection, const gchar* name, gpointer self) {
	session_status_screensaver_disappeared ((SessionStatus*) self);
}


SessionStatus* session_status_construct (GType object_type, GtkApplication* application) {
	SessionStatus * self = NULL;
	GtkApplication* _tmp0_ = NULL;
	GtkApplication* _tmp1_ = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (SessionStatus*) g_object_new (object_type, NULL);
	_tmp0_ = application;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->application);
	self->priv->application = _tmp1_;
	g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, "org.gnome.ScreenSaver", G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_session_status_screensaver_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _session_status_screensaver_appeared_gbus_name_appeared_callback, g_object_ref (self), g_object_unref)), (GClosure*) ((_session_status_screensaver_disappeared_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _session_status_screensaver_disappeared_gbus_name_vanished_callback, g_object_ref (self), g_object_unref)));
	return self;
}


SessionStatus* session_status_new (GtkApplication* application) {
	return session_status_construct (TYPE_SESSION_STATUS, application);
}


static void _session_status_screensaver_active_changed_cb_iscreen_saver_active_changed (IScreenSaver* _sender, gboolean active, gpointer self) {
	session_status_screensaver_active_changed_cb ((SessionStatus*) self, active);
}


static void session_status_screensaver_appeared (SessionStatus* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		IScreenSaver* _tmp0_ = NULL;
		IScreenSaver* _tmp1_ = NULL;
		IScreenSaver* _tmp2_ = NULL;
		IScreenSaver* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		IScreenSaver* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		_tmp1_ = g_initable_new (TYPE_ISCREEN_SAVER_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", "org.gnome.ScreenSaver", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/gnome/ScreenSaver", "g-interface-name", "org.gnome.ScreenSaver", "g-interface-info", g_type_get_qdata (TYPE_ISCREEN_SAVER, g_quark_from_static_string ("vala-dbus-interface-info")), NULL);
		_tmp0_ = (IScreenSaver*) _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch8_g_io_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->screensaver);
		self->priv->screensaver = _tmp2_;
		_tmp3_ = self->priv->screensaver;
		g_signal_connect_object (_tmp3_, "active-changed", (GCallback) _session_status_screensaver_active_changed_cb_iscreen_saver_active_changed, self, 0);
		_tmp5_ = self->priv->screensaver;
		_tmp6_ = iscreen_saver_get_active (_tmp5_, &_inner_error_);
		_tmp4_ = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (_tmp0_);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch8_g_io_error;
			}
			_g_object_unref0 (_tmp0_);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		self->priv->screensaver_is_active = _tmp4_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally8;
	__catch8_g_io_error:
	{
		GError* _error_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_g_object_unref0 (self->priv->screensaver);
		self->priv->screensaver = NULL;
		_tmp7_ = _error_;
		_tmp8_ = _tmp7_->message;
		g_warning ("SessionStatus.vala:55: Error connecting to screensaver service: %s", _tmp8_);
		_g_error_free0 (_error_);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void session_status_screensaver_disappeared (SessionStatus* self) {
	IScreenSaver* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->screensaver;
	g_signal_parse_name ("active-changed", TYPE_ISCREEN_SAVER, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _session_status_screensaver_active_changed_cb_iscreen_saver_active_changed, self);
	_g_object_unref0 (self->priv->screensaver);
	self->priv->screensaver = NULL;
}


static void session_status_screensaver_active_changed_cb (SessionStatus* self, gboolean active) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = active;
	self->priv->screensaver_is_active = _tmp0_;
	_tmp1_ = active;
	if (_tmp1_) {
		g_signal_emit_by_name ((ISessionStatus*) self, "locked");
	} else {
		g_signal_emit_by_name ((ISessionStatus*) self, "unlocked");
	}
}


static gboolean session_status_real_is_locked (ISessionStatus* base) {
	SessionStatus * self;
	gboolean result = FALSE;
	IScreenSaver* _tmp0_ = NULL;
	self = (SessionStatus*) base;
	_tmp0_ = self->priv->screensaver;
	if (_tmp0_ != NULL) {
		gboolean _tmp1_ = FALSE;
		_tmp1_ = self->priv->screensaver_is_active;
		result = _tmp1_;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


static void session_status_real_lock_screen (ISessionStatus* base) {
	SessionStatus * self;
	IScreenSaver* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (SessionStatus*) base;
	_tmp0_ = self->priv->screensaver;
	if (_tmp0_ != NULL) {
		{
			IScreenSaver* _tmp1_ = NULL;
			_tmp1_ = self->priv->screensaver;
			iscreen_saver_lock (_tmp1_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch9_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally9;
		__catch9_g_io_error:
		{
			GError* _error_ = NULL;
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = _error_;
			_tmp3_ = _tmp2_->message;
			g_warning ("SessionStatus.vala:86: Error locking screen: %s", _tmp3_);
			_g_error_free0 (_error_);
		}
		__finally9:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void session_status_real_blank_screen (ISessionStatus* base) {
	SessionStatus * self;
	IScreenSaver* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (SessionStatus*) base;
	_tmp0_ = self->priv->screensaver;
	if (_tmp0_ != NULL) {
		{
			IScreenSaver* _tmp1_ = NULL;
			_tmp1_ = self->priv->screensaver;
			iscreen_saver_set_active (_tmp1_, TRUE, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch10_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally10;
		__catch10_g_io_error:
		{
			GError* _error_ = NULL;
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = _error_;
			_tmp3_ = _tmp2_->message;
			g_warning ("SessionStatus.vala:96: Error blanking screeen: %s", _tmp3_);
			_g_error_free0 (_error_);
		}
		__finally10:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void session_status_real_unblank_screen (ISessionStatus* base) {
	SessionStatus * self;
	IScreenSaver* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (SessionStatus*) base;
	_tmp0_ = self->priv->screensaver;
	if (_tmp0_ != NULL) {
		{
			IScreenSaver* _tmp1_ = NULL;
			_tmp1_ = self->priv->screensaver;
			iscreen_saver_set_active (_tmp1_, FALSE, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_IO_ERROR) {
					goto __catch11_g_io_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally11;
		__catch11_g_io_error:
		{
			GError* _error_ = NULL;
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = _error_;
			_tmp3_ = _tmp2_->message;
			g_warning ("SessionStatus.vala:106: Error unblanking screeen: %s", _tmp3_);
			_g_error_free0 (_error_);
		}
		__finally11:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void session_status_class_init (SessionStatusClass * klass) {
	session_status_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SessionStatusPrivate));
	G_OBJECT_CLASS (klass)->finalize = session_status_finalize;
}


static void session_status_isession_status_interface_init (ISessionStatusIface * iface) {
	session_status_isession_status_parent_iface = g_type_interface_peek_parent (iface);
	iface->is_locked = (gboolean (*)(ISessionStatus*)) session_status_real_is_locked;
	iface->lock_screen = (void (*)(ISessionStatus*)) session_status_real_lock_screen;
	iface->blank_screen = (void (*)(ISessionStatus*)) session_status_real_blank_screen;
	iface->unblank_screen = (void (*)(ISessionStatus*)) session_status_real_unblank_screen;
}


static void session_status_instance_init (SessionStatus * self) {
	self->priv = SESSION_STATUS_GET_PRIVATE (self);
	self->priv->screensaver_is_active = FALSE;
}


static void session_status_finalize (GObject* obj) {
	SessionStatus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SESSION_STATUS, SessionStatus);
	_g_object_unref0 (self->priv->application);
	_g_object_unref0 (self->priv->screensaver);
	G_OBJECT_CLASS (session_status_parent_class)->finalize (obj);
}


/**
 * Abstraction of GNOME Screensaver's dbus interface with gentle defaults in
 * case we are unable to connect.
 */
GType session_status_get_type (void) {
	static volatile gsize session_status_type_id__volatile = 0;
	if (g_once_init_enter (&session_status_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SessionStatusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) session_status_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SessionStatus), 0, (GInstanceInitFunc) session_status_instance_init, NULL };
		static const GInterfaceInfo isession_status_info = { (GInterfaceInitFunc) session_status_isession_status_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType session_status_type_id;
		session_status_type_id = g_type_register_static (G_TYPE_OBJECT, "SessionStatus", &g_define_type_info, 0);
		g_type_add_interface_static (session_status_type_id, TYPE_ISESSION_STATUS, &isession_status_info);
		g_once_init_leave (&session_status_type_id__volatile, session_status_type_id);
	}
	return session_status_type_id__volatile;
}



