/* UIManager.c generated by valac 0.32.1, the Vala compiler
 * generated from UIManager.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <util.h>
#include <gtk/gtk.h>
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <common.h>
#include <config.h>
#include <gio/gio.h>
#include <canberra.h>
#include <canberra-gtk.h>


#define TYPE_UI_MANAGER (ui_manager_get_type ())
#define UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UI_MANAGER, UIManager))
#define UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UI_MANAGER, UIManagerClass))
#define IS_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UI_MANAGER))
#define IS_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UI_MANAGER))
#define UI_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UI_MANAGER, UIManagerClass))

typedef struct _UIManager UIManager;
typedef struct _UIManagerClass UIManagerClass;
typedef struct _UIManagerPrivate UIManagerPrivate;

#define TYPE_SCREEN_OVERLAY (screen_overlay_get_type ())
#define SCREEN_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SCREEN_OVERLAY, ScreenOverlay))
#define SCREEN_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SCREEN_OVERLAY, ScreenOverlayClass))
#define IS_SCREEN_OVERLAY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SCREEN_OVERLAY))
#define IS_SCREEN_OVERLAY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SCREEN_OVERLAY))
#define SCREEN_OVERLAY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SCREEN_OVERLAY, ScreenOverlayClass))

typedef struct _ScreenOverlay ScreenOverlay;
typedef struct _ScreenOverlayClass ScreenOverlayClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))

#define SCREEN_OVERLAY_TYPE_FORMAT (screen_overlay_format_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define UI_MANAGER_TYPE_UI_FRAGMENT (ui_manager_ui_fragment_get_type ())
#define UI_MANAGER_UI_FRAGMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UI_MANAGER_TYPE_UI_FRAGMENT, UIManagerUIFragment))
#define UI_MANAGER_UI_FRAGMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UI_MANAGER_TYPE_UI_FRAGMENT, UIManagerUIFragmentClass))
#define UI_MANAGER_IS_UI_FRAGMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UI_MANAGER_TYPE_UI_FRAGMENT))
#define UI_MANAGER_IS_UI_FRAGMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UI_MANAGER_TYPE_UI_FRAGMENT))
#define UI_MANAGER_UI_FRAGMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UI_MANAGER_TYPE_UI_FRAGMENT, UIManagerUIFragmentClass))

typedef struct _UIManagerUIFragment UIManagerUIFragment;
typedef struct _UIManagerUIFragmentClass UIManagerUIFragmentClass;

#define TYPE_BREAK_VIEW (break_view_get_type ())
#define BREAK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BREAK_VIEW, BreakView))
#define BREAK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BREAK_VIEW, BreakViewClass))
#define IS_BREAK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BREAK_VIEW))
#define IS_BREAK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BREAK_VIEW))
#define BREAK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BREAK_VIEW, BreakViewClass))

typedef struct _BreakView BreakView;
typedef struct _BreakViewClass BreakViewClass;
typedef struct _UIManagerUIFragmentPrivate UIManagerUIFragmentPrivate;

#define TYPE_ISCREEN_OVERLAY_CONTENT (iscreen_overlay_content_get_type ())
#define ISCREEN_OVERLAY_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ISCREEN_OVERLAY_CONTENT, IScreenOverlayContent))
#define IS_ISCREEN_OVERLAY_CONTENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ISCREEN_OVERLAY_CONTENT))
#define ISCREEN_OVERLAY_CONTENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ISCREEN_OVERLAY_CONTENT, IScreenOverlayContentIface))

typedef struct _IScreenOverlayContent IScreenOverlayContent;
typedef struct _IScreenOverlayContentIface IScreenOverlayContentIface;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UIManager {
	SimpleFocusManager parent_instance;
	UIManagerPrivate * priv;
	ScreenOverlay* screen_overlay;
	NotifyNotification* notification;
	GList* notify_capabilities;
};

struct _UIManagerClass {
	SimpleFocusManagerClass parent_class;
};

struct _UIManagerPrivate {
	GtkApplication* application;
	ISessionStatus* session_status;
	gboolean _quiet_mode;
	gint64 _quiet_mode_expire_time;
	PausableTimeout* quiet_mode_timeout;
	NotifyNotification* lock_notification;
};

typedef enum  {
	SCREEN_OVERLAY_FORMAT_SILENT,
	SCREEN_OVERLAY_FORMAT_MINI,
	SCREEN_OVERLAY_FORMAT_FULL
} ScreenOverlayFormat;

struct _IScreenOverlayContentIface {
	GTypeInterface parent_iface;
	void (*added_to_overlay) (IScreenOverlayContent* self);
	void (*removed_from_overlay) (IScreenOverlayContent* self);
	void (*before_fade_in) (IScreenOverlayContent* self);
	void (*before_fade_out) (IScreenOverlayContent* self);
};

struct _UIManagerUIFragment {
	GObject parent_instance;
	UIManagerUIFragmentPrivate * priv;
	UIManager* ui_manager;
	IScreenOverlayContent* overlay_content;
	NotifyNotification* notification;
	FocusPriority focus_priority;
};

struct _UIManagerUIFragmentClass {
	GObjectClass parent_class;
	void (*focus_started) (UIManagerUIFragment* self);
	void (*focus_stopped) (UIManagerUIFragment* self);
};


static gpointer ui_manager_parent_class = NULL;
static gchar* ui_manager_DESKTOP_ENTRY_BASENAME;
static gchar* ui_manager_DESKTOP_ENTRY_BASENAME = NULL;
static gpointer ui_manager_ui_fragment_parent_class = NULL;
static IFocusableIface* ui_manager_ui_fragment_ifocusable_parent_iface = NULL;

GType ui_manager_get_type (void) G_GNUC_CONST;
GType screen_overlay_get_type (void) G_GNUC_CONST;
#define UI_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_UI_MANAGER, UIManagerPrivate))
enum  {
	UI_MANAGER_DUMMY_PROPERTY,
	UI_MANAGER_QUIET_MODE,
	UI_MANAGER_QUIET_MODE_EXPIRE_TIME
};
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
UIManager* ui_manager_new (GtkApplication* application, ISessionStatus* session_status, gboolean with_overlay);
UIManager* ui_manager_construct (GType object_type, GtkApplication* application, ISessionStatus* session_status, gboolean with_overlay);
ScreenOverlay* screen_overlay_new (void);
ScreenOverlay* screen_overlay_construct (GType object_type);
static void ui_manager_quiet_mode_timeout_cb (UIManager* self, PausableTimeout* timeout, gint delta_millisecs);
static void _ui_manager_quiet_mode_timeout_cb_pausable_timeout_timeout_cb (PausableTimeout* timeout, gint delta_millisecs, gpointer self);
static void __lambda8_ (UIManager* self, GObject* s, GParamSpec* p);
static void ui_manager_update_overlay_format (UIManager* self);
static void ___lambda8__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void ui_manager_hide_lock_notification_cb (UIManager* self);
static void _ui_manager_hide_lock_notification_cb_isession_status_unlocked (ISessionStatus* _sender, gpointer self);
gboolean ui_manager_get_quiet_mode (UIManager* self);
gint64 ui_manager_get_quiet_mode_expire_time (UIManager* self);
void ui_manager_set_quiet_mode (UIManager* self, gboolean value);
void ui_manager_set_quiet_mode_expire_time (UIManager* self, gint64 value);
GType screen_overlay_format_get_type (void) G_GNUC_CONST;
void screen_overlay_set_format (ScreenOverlay* self, ScreenOverlayFormat format);
void ui_manager_show_notification (UIManager* self, NotifyNotification* notification);
void ui_manager_hide_notification (UIManager* self, NotifyNotification* notification, gboolean immediate);
static GVariant* _variant_new4 (const gchar* value);
void ui_manager_show_lock_notification (UIManager* self, NotifyNotification* notification);
static GVariant* _variant_new5 (gboolean value);
static GVariant* _variant_new6 (gboolean value);
GType ui_manager_ui_fragment_get_type (void) G_GNUC_CONST;
GType break_view_get_type (void) G_GNUC_CONST;
void ui_manager_add_break (UIManager* self, BreakView* break_view);
void ui_manager_remove_break (UIManager* self, BreakView* break_view);
GType iscreen_overlay_content_get_type (void) G_GNUC_CONST;
enum  {
	UI_MANAGER_UI_FRAGMENT_DUMMY_PROPERTY
};
gboolean ui_manager_ui_fragment_has_ui_focus (UIManagerUIFragment* self);
void ui_manager_ui_fragment_request_ui_focus (UIManagerUIFragment* self);
void ui_manager_ui_fragment_focus_started (UIManagerUIFragment* self);
void ui_manager_ui_fragment_release_ui_focus (UIManagerUIFragment* self);
void ui_manager_ui_fragment_play_sound_from_id (UIManagerUIFragment* self, const gchar* event_id);
gboolean ui_manager_ui_fragment_can_lock_screen (UIManagerUIFragment* self);
void ui_manager_ui_fragment_lock_screen (UIManagerUIFragment* self);
gboolean ui_manager_ui_fragment_notifications_can_do (UIManagerUIFragment* self, const gchar* capability);
void ui_manager_ui_fragment_show_notification (UIManagerUIFragment* self, NotifyNotification* notification);
void ui_manager_ui_fragment_show_lock_notification (UIManagerUIFragment* self, NotifyNotification* notification);
void ui_manager_ui_fragment_hide_notification (UIManagerUIFragment* self);
void ui_manager_ui_fragment_set_overlay (UIManagerUIFragment* self, IScreenOverlayContent* overlay_content);
void screen_overlay_set_content (ScreenOverlay* self, IScreenOverlayContent* widget);
void ui_manager_ui_fragment_reveal_overlay (UIManagerUIFragment* self);
void screen_overlay_reveal_content (ScreenOverlay* self, IScreenOverlayContent* widget);
void ui_manager_ui_fragment_shake_overlay (UIManagerUIFragment* self);
gboolean ui_manager_ui_fragment_overlay_is_visible (UIManagerUIFragment* self);
void screen_overlay_request_attention (ScreenOverlay* self);
gboolean screen_overlay_is_showing_content (ScreenOverlay* self, IScreenOverlayContent* widget);
void ui_manager_ui_fragment_hide_overlay (UIManagerUIFragment* self);
void screen_overlay_disappear_content (ScreenOverlay* self, IScreenOverlayContent* widget);
static void ui_manager_ui_fragment_real_focus_started (UIManagerUIFragment* self);
void ui_manager_ui_fragment_focus_stopped (UIManagerUIFragment* self);
static void ui_manager_ui_fragment_real_focus_stopped (UIManagerUIFragment* self);
UIManagerUIFragment* ui_manager_ui_fragment_construct (GType object_type);
static void ui_manager_ui_fragment_finalize (GObject* obj);
static void ui_manager_finalize (GObject* obj);
static void _vala_ui_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_ui_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	_tmp2_ = start;
	if (_tmp2_ < ((glong) 0)) {
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		_tmp3_ = string_length;
		_tmp4_ = start;
		start = _tmp3_ + _tmp4_;
	}
	_tmp5_ = end;
	if (_tmp5_ < ((glong) 0)) {
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
		_tmp6_ = string_length;
		_tmp7_ = end;
		end = _tmp6_ + _tmp7_;
	}
	_tmp9_ = start;
	if (_tmp9_ >= ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		_tmp10_ = start;
		_tmp11_ = string_length;
		_tmp8_ = _tmp10_ <= _tmp11_;
	} else {
		_tmp8_ = FALSE;
	}
	g_return_val_if_fail (_tmp8_, NULL);
	_tmp13_ = end;
	if (_tmp13_ >= ((glong) 0)) {
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
		_tmp14_ = end;
		_tmp15_ = string_length;
		_tmp12_ = _tmp14_ <= _tmp15_;
	} else {
		_tmp12_ = FALSE;
	}
	g_return_val_if_fail (_tmp12_, NULL);
	_tmp16_ = start;
	_tmp17_ = end;
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
	_tmp18_ = start;
	_tmp19_ = end;
	_tmp20_ = start;
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
	result = _tmp21_;
	return result;
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = needle;
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _ui_manager_quiet_mode_timeout_cb_pausable_timeout_timeout_cb (PausableTimeout* timeout, gint delta_millisecs, gpointer self) {
	ui_manager_quiet_mode_timeout_cb ((UIManager*) self, timeout, delta_millisecs);
}


static void __lambda8_ (UIManager* self, GObject* s, GParamSpec* p) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	ui_manager_update_overlay_format (self);
}


static void ___lambda8__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda8_ ((UIManager*) self, _sender, pspec);
}


static void _ui_manager_hide_lock_notification_cb_isession_status_unlocked (ISessionStatus* _sender, gpointer self) {
	ui_manager_hide_lock_notification_cb ((UIManager*) self);
}


UIManager* ui_manager_construct (GType object_type, GtkApplication* application, ISessionStatus* session_status, gboolean with_overlay) {
	UIManager * self = NULL;
	GtkApplication* _tmp0_ = NULL;
	ISessionStatus* _tmp1_ = NULL;
	ISessionStatus* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GSettings* settings = NULL;
	GSettings* _tmp5_ = NULL;
	PausableTimeout* _tmp6_ = NULL;
	ISessionStatus* _tmp7_ = NULL;
	GList* _tmp8_ = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	g_return_val_if_fail (session_status != NULL, NULL);
	self = (UIManager*) simple_focus_manager_construct (object_type);
	_tmp0_ = application;
	self->priv->application = _tmp0_;
	_tmp1_ = session_status;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_g_object_unref0 (self->priv->session_status);
	self->priv->session_status = _tmp2_;
	_tmp3_ = with_overlay;
	if (_tmp3_) {
		ScreenOverlay* _tmp4_ = NULL;
		_tmp4_ = screen_overlay_new ();
		g_object_ref_sink (_tmp4_);
		_g_object_unref0 (self->screen_overlay);
		self->screen_overlay = _tmp4_;
	}
	_tmp5_ = g_settings_new ("org.gnome.break-timer");
	settings = _tmp5_;
	g_settings_bind (settings, "quiet-mode", (GObject*) self, "quiet-mode", G_SETTINGS_BIND_DEFAULT);
	g_settings_bind (settings, "quiet-mode-expire-time", (GObject*) self, "quiet-mode-expire-time", G_SETTINGS_BIND_DEFAULT);
	_tmp6_ = pausable_timeout_new (_ui_manager_quiet_mode_timeout_cb_pausable_timeout_timeout_cb, self, 30);
	_g_object_unref0 (self->priv->quiet_mode_timeout);
	self->priv->quiet_mode_timeout = _tmp6_;
	g_signal_connect_object ((GObject*) self, "notify::quiet-mode", (GCallback) ___lambda8__g_object_notify, self, 0);
	ui_manager_update_overlay_format (self);
	_tmp7_ = self->priv->session_status;
	g_signal_connect_object (_tmp7_, "unlocked", (GCallback) _ui_manager_hide_lock_notification_cb_isession_status_unlocked, self, 0);
	_tmp8_ = notify_get_server_caps ();
	__g_list_free__g_free0_0 (self->notify_capabilities);
	self->notify_capabilities = _tmp8_;
	_g_object_unref0 (settings);
	return self;
}


UIManager* ui_manager_new (GtkApplication* application, ISessionStatus* session_status, gboolean with_overlay) {
	return ui_manager_construct (TYPE_UI_MANAGER, application, session_status, with_overlay);
}


static void ui_manager_quiet_mode_timeout_cb (UIManager* self, PausableTimeout* timeout, gint delta_millisecs) {
	gint64 now = 0LL;
	gint64 _tmp0_ = 0LL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeout != NULL);
	_tmp0_ = util_get_real_time_seconds ();
	now = _tmp0_;
	_tmp2_ = self->priv->_quiet_mode;
	if (_tmp2_) {
		gint64 _tmp3_ = 0LL;
		gint64 _tmp4_ = 0LL;
		_tmp3_ = now;
		_tmp4_ = self->priv->_quiet_mode_expire_time;
		_tmp1_ = _tmp3_ > _tmp4_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		ui_manager_set_quiet_mode (self, FALSE);
		ui_manager_set_quiet_mode_expire_time (self, (gint64) 0);
		g_debug ("UIManager.vala:193: Automatically expiring quiet mode");
	}
}


static void ui_manager_update_overlay_format (UIManager* self) {
	ScreenOverlay* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->screen_overlay;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->_quiet_mode;
	if (_tmp1_) {
		ScreenOverlay* _tmp2_ = NULL;
		PausableTimeout* _tmp3_ = NULL;
		PausableTimeout* _tmp4_ = NULL;
		_tmp2_ = self->screen_overlay;
		screen_overlay_set_format (_tmp2_, SCREEN_OVERLAY_FORMAT_SILENT);
		_tmp3_ = self->priv->quiet_mode_timeout;
		pausable_timeout_start (_tmp3_);
		_tmp4_ = self->priv->quiet_mode_timeout;
		pausable_timeout_run_once (_tmp4_);
		g_debug ("UIManager.vala:204: Quiet mode enabled");
	} else {
		ScreenOverlay* _tmp5_ = NULL;
		PausableTimeout* _tmp6_ = NULL;
		_tmp5_ = self->screen_overlay;
		screen_overlay_set_format (_tmp5_, SCREEN_OVERLAY_FORMAT_FULL);
		_tmp6_ = self->priv->quiet_mode_timeout;
		pausable_timeout_stop (_tmp6_);
		g_debug ("UIManager.vala:208: Quiet mode disabled");
	}
}


/**
 * Show a notification, ensuring that the application is only showing one
 * notification at any time.
 */
static GVariant* _variant_new4 (const gchar* value) {
	return g_variant_ref_sink (g_variant_new_string (value));
}


void ui_manager_show_notification (UIManager* self, NotifyNotification* notification) {
	NotifyNotification* _tmp0_ = NULL;
	NotifyNotification* _tmp1_ = NULL;
	NotifyNotification* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GVariant* _tmp5_ = NULL;
	NotifyNotification* _tmp9_ = NULL;
	NotifyNotification* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_tmp0_ = notification;
	_tmp1_ = self->notification;
	if (_tmp0_ != _tmp1_) {
		NotifyNotification* _tmp2_ = NULL;
		_tmp2_ = self->notification;
		ui_manager_hide_notification (self, _tmp2_, TRUE);
	}
	_tmp3_ = notification;
	_tmp4_ = ui_manager_DESKTOP_ENTRY_BASENAME;
	_tmp5_ = _variant_new4 (_tmp4_);
	notify_notification_set_hint (_tmp3_, "desktop-entry", _tmp5_);
	_g_variant_unref0 (_tmp5_);
	{
		NotifyNotification* _tmp6_ = NULL;
		_tmp6_ = notification;
		notify_notification_show (_tmp6_, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch12_g_error;
		}
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = _error_;
		_tmp8_ = _tmp7_->message;
		g_warning ("UIManager.vala:224: Error showing notification: %s", _tmp8_);
		_g_error_free0 (_error_);
	}
	__finally12:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp9_ = notification;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	_g_object_unref0 (self->notification);
	self->notification = _tmp10_;
}


/**
 * Show a notification that will only appear in the lock screen. The
 * notification automatically hides when the screen is unlocked.
 */
static GVariant* _variant_new5 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void ui_manager_show_lock_notification (UIManager* self, NotifyNotification* notification) {
	ISessionStatus* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	NotifyNotification* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_tmp0_ = self->priv->session_status;
	_tmp1_ = isession_status_is_locked (_tmp0_);
	if (_tmp1_) {
		NotifyNotification* _tmp2_ = NULL;
		NotifyNotification* _tmp3_ = NULL;
		_tmp2_ = notification;
		_tmp3_ = _g_object_ref0 (_tmp2_);
		_g_object_unref0 (self->priv->lock_notification);
		self->priv->lock_notification = _tmp3_;
	} else {
		NotifyNotification* _tmp4_ = NULL;
		GVariant* _tmp5_ = NULL;
		_tmp4_ = notification;
		_tmp5_ = _variant_new5 (TRUE);
		notify_notification_set_hint (_tmp4_, "transient", _tmp5_);
		_g_variant_unref0 (_tmp5_);
	}
	_tmp6_ = notification;
	ui_manager_show_notification (self, _tmp6_);
}


static void ui_manager_hide_lock_notification_cb (UIManager* self) {
	NotifyNotification* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->lock_notification;
	ui_manager_hide_notification (self, _tmp0_, TRUE);
	_g_object_unref0 (self->priv->lock_notification);
	self->priv->lock_notification = NULL;
}


/**
 * Close a notification proactively, if it is still open.
 */
static GVariant* _variant_new6 (gboolean value) {
	return g_variant_ref_sink (g_variant_new_boolean (value));
}


void ui_manager_hide_notification (UIManager* self, NotifyNotification* notification, gboolean immediate) {
	gboolean _tmp0_ = FALSE;
	NotifyNotification* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp1_ = notification;
	if (_tmp1_ != NULL) {
		NotifyNotification* _tmp2_ = NULL;
		NotifyNotification* _tmp3_ = NULL;
		_tmp2_ = self->notification;
		_tmp3_ = notification;
		_tmp0_ = _tmp2_ == _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = immediate;
			if (_tmp4_) {
				NotifyNotification* _tmp5_ = NULL;
				_tmp5_ = self->notification;
				notify_notification_close (_tmp5_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch13_g_error;
				}
			} else {
				NotifyNotification* _tmp6_ = NULL;
				GVariant* _tmp7_ = NULL;
				NotifyNotification* _tmp8_ = NULL;
				_tmp6_ = self->notification;
				_tmp7_ = _variant_new6 (TRUE);
				notify_notification_set_hint (_tmp6_, "transient", _tmp7_);
				_g_variant_unref0 (_tmp7_);
				_tmp8_ = self->notification;
				notify_notification_show (_tmp8_, &_inner_error_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					goto __catch13_g_error;
				}
			}
		}
		goto __finally13;
		__catch13_g_error:
		{
			GError* _error_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (_error_);
		}
		__finally13:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (self->notification);
	self->notification = NULL;
}


void ui_manager_add_break (UIManager* self, BreakView* break_view) {
	GtkApplication* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (break_view != NULL);
	_tmp0_ = self->priv->application;
	g_application_hold ((GApplication*) _tmp0_);
}


void ui_manager_remove_break (UIManager* self, BreakView* break_view) {
	BreakView* _tmp0_ = NULL;
	GtkApplication* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (break_view != NULL);
	_tmp0_ = break_view;
	simple_focus_manager_release_focus ((SimpleFocusManager*) self, (IFocusable*) _tmp0_);
	_tmp1_ = self->priv->application;
	g_application_release ((GApplication*) _tmp1_);
}


gboolean ui_manager_get_quiet_mode (UIManager* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_quiet_mode;
	result = _tmp0_;
	return result;
}


void ui_manager_set_quiet_mode (UIManager* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_quiet_mode = _tmp0_;
	g_object_notify ((GObject *) self, "quiet-mode");
}


gint64 ui_manager_get_quiet_mode_expire_time (UIManager* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
	g_return_val_if_fail (self != NULL, 0LL);
	_tmp0_ = self->priv->_quiet_mode_expire_time;
	result = _tmp0_;
	return result;
}


void ui_manager_set_quiet_mode_expire_time (UIManager* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_quiet_mode_expire_time = _tmp0_;
	g_object_notify ((GObject *) self, "quiet-mode-expire-time");
}


gboolean ui_manager_ui_fragment_has_ui_focus (UIManagerUIFragment* self) {
	gboolean result = FALSE;
	UIManager* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->ui_manager;
	_tmp1_ = simple_focus_manager_is_focusing ((SimpleFocusManager*) _tmp0_, (IFocusable*) self);
	result = _tmp1_;
	return result;
}


void ui_manager_ui_fragment_request_ui_focus (UIManagerUIFragment* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp0_) {
		ui_manager_ui_fragment_focus_started (self);
	} else {
		UIManager* _tmp1_ = NULL;
		FocusPriority _tmp2_ = 0;
		_tmp1_ = self->ui_manager;
		_tmp2_ = self->focus_priority;
		simple_focus_manager_request_focus ((SimpleFocusManager*) _tmp1_, (IFocusable*) self, _tmp2_);
	}
}


void ui_manager_ui_fragment_release_ui_focus (UIManagerUIFragment* self) {
	UIManager* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->ui_manager;
	simple_focus_manager_release_focus ((SimpleFocusManager*) _tmp0_, (IFocusable*) self);
}


void ui_manager_ui_fragment_play_sound_from_id (UIManagerUIFragment* self, const gchar* event_id) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (event_id != NULL);
	_tmp0_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp0_) {
		ca_context* canberra = NULL;
		ca_context* _tmp1_ = NULL;
		ca_context* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		_tmp1_ = ca_gtk_context_get ();
		canberra = _tmp1_;
		_tmp2_ = canberra;
		_tmp3_ = event_id;
		ca_context_play (_tmp2_, (guint32) 0, CA_PROP_EVENT_ID, _tmp3_, NULL);
	}
}


gboolean ui_manager_ui_fragment_can_lock_screen (UIManagerUIFragment* self) {
	gboolean result = FALSE;
	UIManager* _tmp0_ = NULL;
	GtkApplication* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->priv->application;
	_tmp2_ = gtk_application_is_inhibited (_tmp1_, GTK_APPLICATION_INHIBIT_IDLE);
	result = !_tmp2_;
	return result;
}


void ui_manager_ui_fragment_lock_screen (UIManagerUIFragment* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp0_) {
		UIManager* _tmp1_ = NULL;
		ISessionStatus* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		_tmp1_ = self->ui_manager;
		_tmp2_ = _tmp1_->priv->session_status;
		_tmp3_ = isession_status_is_locked (_tmp2_);
		if (!_tmp3_) {
			UIManager* _tmp4_ = NULL;
			ISessionStatus* _tmp5_ = NULL;
			_tmp4_ = self->ui_manager;
			_tmp5_ = _tmp4_->priv->session_status;
			isession_status_lock_screen (_tmp5_);
		}
	}
}


gboolean ui_manager_ui_fragment_notifications_can_do (UIManagerUIFragment* self, const gchar* capability) {
	gboolean result = FALSE;
	UIManager* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (capability != NULL, FALSE);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->notify_capabilities;
	{
		GList* server_capability_collection = NULL;
		GList* server_capability_it = NULL;
		server_capability_collection = _tmp1_;
		for (server_capability_it = server_capability_collection; server_capability_it != NULL; server_capability_it = server_capability_it->next) {
			gchar* _tmp2_ = NULL;
			gchar* server_capability = NULL;
			_tmp2_ = g_strdup ((const gchar*) server_capability_it->data);
			server_capability = _tmp2_;
			{
				const gchar* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
				_tmp3_ = server_capability;
				_tmp4_ = capability;
				if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
					result = TRUE;
					_g_free0 (server_capability);
					return result;
				}
				_g_free0 (server_capability);
			}
		}
	}
	result = FALSE;
	return result;
}


void ui_manager_ui_fragment_show_notification (UIManagerUIFragment* self, NotifyNotification* notification) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_tmp0_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp0_) {
		UIManager* _tmp1_ = NULL;
		NotifyNotification* _tmp2_ = NULL;
		NotifyNotification* _tmp3_ = NULL;
		NotifyNotification* _tmp4_ = NULL;
		_tmp1_ = self->ui_manager;
		_tmp2_ = notification;
		ui_manager_show_notification (_tmp1_, _tmp2_);
		_tmp3_ = notification;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (self->notification);
		self->notification = _tmp4_;
	}
}


void ui_manager_ui_fragment_show_lock_notification (UIManagerUIFragment* self, NotifyNotification* notification) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_tmp0_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp0_) {
		UIManager* _tmp1_ = NULL;
		NotifyNotification* _tmp2_ = NULL;
		NotifyNotification* _tmp3_ = NULL;
		NotifyNotification* _tmp4_ = NULL;
		_tmp1_ = self->ui_manager;
		_tmp2_ = notification;
		ui_manager_show_lock_notification (_tmp1_, _tmp2_);
		_tmp3_ = notification;
		_tmp4_ = _g_object_ref0 (_tmp3_);
		_g_object_unref0 (self->notification);
		self->notification = _tmp4_;
	}
}


void ui_manager_ui_fragment_hide_notification (UIManagerUIFragment* self) {
	UIManager* _tmp0_ = NULL;
	NotifyNotification* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->ui_manager;
	_tmp1_ = self->notification;
	ui_manager_hide_notification (_tmp0_, _tmp1_, TRUE);
}


void ui_manager_ui_fragment_set_overlay (UIManagerUIFragment* self, IScreenOverlayContent* overlay_content) {
	UIManager* _tmp0_ = NULL;
	ScreenOverlay* _tmp1_ = NULL;
	IScreenOverlayContent* _tmp2_ = NULL;
	IScreenOverlayContent* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (overlay_content != NULL);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->screen_overlay;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = overlay_content;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->overlay_content);
	self->overlay_content = _tmp3_;
	_tmp4_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp4_) {
		UIManager* _tmp5_ = NULL;
		ScreenOverlay* _tmp6_ = NULL;
		IScreenOverlayContent* _tmp7_ = NULL;
		_tmp5_ = self->ui_manager;
		_tmp6_ = _tmp5_->screen_overlay;
		_tmp7_ = self->overlay_content;
		screen_overlay_set_content (_tmp6_, _tmp7_);
	}
}


void ui_manager_ui_fragment_reveal_overlay (UIManagerUIFragment* self) {
	UIManager* _tmp0_ = NULL;
	ScreenOverlay* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->screen_overlay;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = ui_manager_ui_fragment_has_ui_focus (self);
	if (_tmp2_) {
		UIManager* _tmp3_ = NULL;
		ScreenOverlay* _tmp4_ = NULL;
		IScreenOverlayContent* _tmp5_ = NULL;
		_tmp3_ = self->ui_manager;
		_tmp4_ = _tmp3_->screen_overlay;
		_tmp5_ = self->overlay_content;
		screen_overlay_reveal_content (_tmp4_, _tmp5_);
	}
}


void ui_manager_ui_fragment_shake_overlay (UIManagerUIFragment* self) {
	UIManager* _tmp0_ = NULL;
	ScreenOverlay* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->screen_overlay;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = ui_manager_ui_fragment_overlay_is_visible (self);
	if (_tmp2_) {
		UIManager* _tmp3_ = NULL;
		ScreenOverlay* _tmp4_ = NULL;
		_tmp3_ = self->ui_manager;
		_tmp4_ = _tmp3_->screen_overlay;
		screen_overlay_request_attention (_tmp4_);
	}
}


gboolean ui_manager_ui_fragment_overlay_is_visible (UIManagerUIFragment* self) {
	gboolean result = FALSE;
	UIManager* _tmp0_ = NULL;
	ScreenOverlay* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->screen_overlay;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	} else {
		UIManager* _tmp2_ = NULL;
		ScreenOverlay* _tmp3_ = NULL;
		IScreenOverlayContent* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		_tmp2_ = self->ui_manager;
		_tmp3_ = _tmp2_->screen_overlay;
		_tmp4_ = self->overlay_content;
		_tmp5_ = screen_overlay_is_showing_content (_tmp3_, _tmp4_);
		result = _tmp5_;
		return result;
	}
}


void ui_manager_ui_fragment_hide_overlay (UIManagerUIFragment* self) {
	UIManager* _tmp0_ = NULL;
	ScreenOverlay* _tmp1_ = NULL;
	UIManager* _tmp2_ = NULL;
	ScreenOverlay* _tmp3_ = NULL;
	IScreenOverlayContent* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->ui_manager;
	_tmp1_ = _tmp0_->screen_overlay;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = self->ui_manager;
	_tmp3_ = _tmp2_->screen_overlay;
	_tmp4_ = self->overlay_content;
	screen_overlay_disappear_content (_tmp3_, _tmp4_);
}


static void ui_manager_ui_fragment_real_focus_started (UIManagerUIFragment* self) {
	g_critical ("Type `%s' does not implement abstract method `ui_manager_ui_fragment_focus_started'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void ui_manager_ui_fragment_focus_started (UIManagerUIFragment* self) {
	g_return_if_fail (self != NULL);
	UI_MANAGER_UI_FRAGMENT_GET_CLASS (self)->focus_started (self);
}


static void ui_manager_ui_fragment_real_focus_stopped (UIManagerUIFragment* self) {
	g_critical ("Type `%s' does not implement abstract method `ui_manager_ui_fragment_focus_stopped'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void ui_manager_ui_fragment_focus_stopped (UIManagerUIFragment* self) {
	g_return_if_fail (self != NULL);
	UI_MANAGER_UI_FRAGMENT_GET_CLASS (self)->focus_stopped (self);
}


UIManagerUIFragment* ui_manager_ui_fragment_construct (GType object_type) {
	UIManagerUIFragment * self = NULL;
	self = (UIManagerUIFragment*) g_object_new (object_type, NULL);
	return self;
}


static void ui_manager_ui_fragment_class_init (UIManagerUIFragmentClass * klass) {
	ui_manager_ui_fragment_parent_class = g_type_class_peek_parent (klass);
	((UIManagerUIFragmentClass *) klass)->focus_started = ui_manager_ui_fragment_real_focus_started;
	((UIManagerUIFragmentClass *) klass)->focus_stopped = ui_manager_ui_fragment_real_focus_stopped;
	G_OBJECT_CLASS (klass)->finalize = ui_manager_ui_fragment_finalize;
}


static void ui_manager_ui_fragment_ifocusable_interface_init (IFocusableIface * iface) {
	ui_manager_ui_fragment_ifocusable_parent_iface = g_type_interface_peek_parent (iface);
	iface->focus_started = (void (*)(IFocusable*)) ui_manager_ui_fragment_focus_started;
	iface->focus_stopped = (void (*)(IFocusable*)) ui_manager_ui_fragment_focus_stopped;
}


static void ui_manager_ui_fragment_instance_init (UIManagerUIFragment * self) {
	self->focus_priority = FOCUS_PRIORITY_LOW;
}


static void ui_manager_ui_fragment_finalize (GObject* obj) {
	UIManagerUIFragment * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UI_MANAGER_TYPE_UI_FRAGMENT, UIManagerUIFragment);
	_g_object_unref0 (self->ui_manager);
	_g_object_unref0 (self->overlay_content);
	_g_object_unref0 (self->notification);
	G_OBJECT_CLASS (ui_manager_ui_fragment_parent_class)->finalize (obj);
}


GType ui_manager_ui_fragment_get_type (void) {
	static volatile gsize ui_manager_ui_fragment_type_id__volatile = 0;
	if (g_once_init_enter (&ui_manager_ui_fragment_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UIManagerUIFragmentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ui_manager_ui_fragment_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UIManagerUIFragment), 0, (GInstanceInitFunc) ui_manager_ui_fragment_instance_init, NULL };
		static const GInterfaceInfo ifocusable_info = { (GInterfaceInitFunc) ui_manager_ui_fragment_ifocusable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType ui_manager_ui_fragment_type_id;
		ui_manager_ui_fragment_type_id = g_type_register_static (G_TYPE_OBJECT, "UIManagerUIFragment", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (ui_manager_ui_fragment_type_id, TYPE_IFOCUSABLE, &ifocusable_info);
		g_once_init_leave (&ui_manager_ui_fragment_type_id__volatile, ui_manager_ui_fragment_type_id);
	}
	return ui_manager_ui_fragment_type_id__volatile;
}


static void ui_manager_class_init (UIManagerClass * klass) {
	gint _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	ui_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (UIManagerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_ui_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_ui_manager_set_property;
	G_OBJECT_CLASS (klass)->finalize = ui_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), UI_MANAGER_QUIET_MODE, g_param_spec_boolean ("quiet-mode", "quiet-mode", "quiet-mode", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), UI_MANAGER_QUIET_MODE_EXPIRE_TIME, g_param_spec_int64 ("quiet-mode-expire-time", "quiet-mode-expire-time", "quiet-mode-expire-time", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	_tmp0_ = string_last_index_of (HELPER_DESKTOP_ID, ".desktop", 0);
	_tmp1_ = string_slice (HELPER_DESKTOP_ID, (glong) 0, (glong) _tmp0_);
	ui_manager_DESKTOP_ENTRY_BASENAME = _tmp1_;
}


static void ui_manager_instance_init (UIManager * self) {
	self->priv = UI_MANAGER_GET_PRIVATE (self);
	self->priv->_quiet_mode = FALSE;
}


static void ui_manager_finalize (GObject* obj) {
	UIManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UI_MANAGER, UIManager);
	_g_object_unref0 (self->priv->session_status);
	_g_object_unref0 (self->priv->quiet_mode_timeout);
	_g_object_unref0 (self->screen_overlay);
	_g_object_unref0 (self->notification);
	__g_list_free__g_free0_0 (self->notify_capabilities);
	_g_object_unref0 (self->priv->lock_notification);
	G_OBJECT_CLASS (ui_manager_parent_class)->finalize (obj);
}


/**
 * Central place to manage UI throughout the application. We need this to
 * maintain a simple, modal structure. This uses SimpleFocusManager to make
 * sure only one break is affecting the UI at a time. This class also tries
 * to keep UI events nicely spaced so they don't turn into noise. Any object
 * which needs to provide a GUI implements UIFragment, which provides a simple
 * interface to create notifications and overlays.
 */
GType ui_manager_get_type (void) {
	static volatile gsize ui_manager_type_id__volatile = 0;
	if (g_once_init_enter (&ui_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UIManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ui_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UIManager), 0, (GInstanceInitFunc) ui_manager_instance_init, NULL };
		GType ui_manager_type_id;
		ui_manager_type_id = g_type_register_static (TYPE_SIMPLE_FOCUS_MANAGER, "UIManager", &g_define_type_info, 0);
		g_once_init_leave (&ui_manager_type_id__volatile, ui_manager_type_id);
	}
	return ui_manager_type_id__volatile;
}


static void _vala_ui_manager_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	UIManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UI_MANAGER, UIManager);
	switch (property_id) {
		case UI_MANAGER_QUIET_MODE:
		g_value_set_boolean (value, ui_manager_get_quiet_mode (self));
		break;
		case UI_MANAGER_QUIET_MODE_EXPIRE_TIME:
		g_value_set_int64 (value, ui_manager_get_quiet_mode_expire_time (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_ui_manager_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UIManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UI_MANAGER, UIManager);
	switch (property_id) {
		case UI_MANAGER_QUIET_MODE:
		ui_manager_set_quiet_mode (self, g_value_get_boolean (value));
		break;
		case UI_MANAGER_QUIET_MODE_EXPIRE_TIME:
		ui_manager_set_quiet_mode_expire_time (self, g_value_get_int64 (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



