/* ActivityMonitor.c generated by valac 0.32.1, the Vala compiler
 * generated from ActivityMonitor.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <util.h>
#include <common.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>


#define TYPE_ACTIVITY_MONITOR (activity_monitor_get_type ())
#define ACTIVITY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACTIVITY_MONITOR, ActivityMonitor))
#define ACTIVITY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACTIVITY_MONITOR, ActivityMonitorClass))
#define IS_ACTIVITY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACTIVITY_MONITOR))
#define IS_ACTIVITY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACTIVITY_MONITOR))
#define ACTIVITY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACTIVITY_MONITOR, ActivityMonitorClass))

typedef struct _ActivityMonitor ActivityMonitor;
typedef struct _ActivityMonitorClass ActivityMonitorClass;
typedef struct _ActivityMonitorPrivate ActivityMonitorPrivate;

#define ACTIVITY_MONITOR_TYPE_USER_ACTIVITY (activity_monitor_user_activity_get_type ())

#define ACTIVITY_MONITOR_TYPE_ACTIVITY_TYPE (activity_monitor_activity_type_get_type ())
typedef struct _ActivityMonitorUserActivity ActivityMonitorUserActivity;

#define TYPE_ACTIVITY_MONITOR_BACKEND (activity_monitor_backend_get_type ())
#define ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackend))
#define ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendClass))
#define IS_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACTIVITY_MONITOR_BACKEND))
#define IS_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACTIVITY_MONITOR_BACKEND))
#define ACTIVITY_MONITOR_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendClass))

typedef struct _ActivityMonitorBackend ActivityMonitorBackend;
typedef struct _ActivityMonitorBackendClass ActivityMonitorBackendClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
typedef struct _ActivityMonitorBackendPrivate ActivityMonitorBackendPrivate;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))

struct _ActivityMonitor {
	GObject parent_instance;
	ActivityMonitorPrivate * priv;
};

struct _ActivityMonitorClass {
	GObjectClass parent_class;
};

typedef enum  {
	ACTIVITY_MONITOR_ACTIVITY_TYPE_SLEEP,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_LOCKED,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_NONE,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_INPUT,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_UNLOCK
} ActivityMonitorActivityType;

struct _ActivityMonitorUserActivity {
	ActivityMonitorActivityType type;
	gint idle_time;
	gint time_since_active;
	gint time_correction;
};

struct _ActivityMonitorPrivate {
	PausableTimeout* poll_activity_timeout;
	ActivityMonitorUserActivity last_activity;
	gint64 last_active_timestamp;
	ISessionStatus* session_status;
	ActivityMonitorBackend* backend;
};

struct _ActivityMonitorBackend {
	GObject parent_instance;
	ActivityMonitorBackendPrivate * priv;
};

struct _ActivityMonitorBackendClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (ActivityMonitorBackend* self);
	void (*deserialize) (ActivityMonitorBackend* self, JsonObject** json_root);
	gint (*time_since_last_event) (ActivityMonitorBackend* self);
};

struct _ActivityMonitorBackendPrivate {
	gint64 last_real_time;
	gint64 last_monotonic_time;
	gint* last_idle_time;
};


static gpointer activity_monitor_parent_class = NULL;
static gpointer activity_monitor_backend_parent_class = NULL;

GType activity_monitor_get_type (void) G_GNUC_CONST;
GType activity_monitor_user_activity_get_type (void) G_GNUC_CONST;
GType activity_monitor_activity_type_get_type (void) G_GNUC_CONST;
ActivityMonitorUserActivity* activity_monitor_user_activity_dup (const ActivityMonitorUserActivity* self);
void activity_monitor_user_activity_free (ActivityMonitorUserActivity* self);
GType activity_monitor_backend_get_type (void) G_GNUC_CONST;
#define ACTIVITY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ACTIVITY_MONITOR, ActivityMonitorPrivate))
enum  {
	ACTIVITY_MONITOR_DUMMY_PROPERTY
};
ActivityMonitor* activity_monitor_new (ISessionStatus* session_status, ActivityMonitorBackend* backend);
ActivityMonitor* activity_monitor_construct (GType object_type, ISessionStatus* session_status, ActivityMonitorBackend* backend);
static void activity_monitor_poll_activity_cb (ActivityMonitor* self, PausableTimeout* timeout, gint delta_millisecs);
static void _activity_monitor_poll_activity_cb_pausable_timeout_timeout_cb (PausableTimeout* timeout, gint delta_millisecs, gpointer self);
static void activity_monitor_unlocked_cb (ActivityMonitor* self);
static void _activity_monitor_unlocked_cb_isession_status_unlocked (ISessionStatus* _sender, gpointer self);
JsonObject* activity_monitor_serialize (ActivityMonitor* self);
JsonObject* activity_monitor_user_activity_serialize (ActivityMonitorUserActivity *self);
void activity_monitor_deserialize (ActivityMonitor* self, JsonObject** json_root);
void activity_monitor_user_activity_deserialize (JsonObject** json_root, ActivityMonitorUserActivity* result);
void activity_monitor_start (ActivityMonitor* self);
void activity_monitor_stop (ActivityMonitor* self);
void activity_monitor_poll_activity (ActivityMonitor* self);
static void activity_monitor_collect_activity (ActivityMonitor* self, ActivityMonitorUserActivity* result);
static void activity_monitor_add_activity (ActivityMonitor* self, ActivityMonitorUserActivity* activity);
gboolean activity_monitor_user_activity_is_active (ActivityMonitorUserActivity *self);
gint activity_monitor_backend_pop_sleep_time (ActivityMonitorBackend* self);
gint activity_monitor_backend_get_idle_seconds (ActivityMonitorBackend* self);
static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void activity_monitor_finalize (GObject* obj);
#define ACTIVITY_MONITOR_BACKEND_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendPrivate))
enum  {
	ACTIVITY_MONITOR_BACKEND_DUMMY_PROPERTY
};
JsonObject* activity_monitor_backend_serialize (ActivityMonitorBackend* self);
static JsonObject* activity_monitor_backend_real_serialize (ActivityMonitorBackend* self);
void activity_monitor_backend_deserialize (ActivityMonitorBackend* self, JsonObject** json_root);
static void activity_monitor_backend_real_deserialize (ActivityMonitorBackend* self, JsonObject** json_root);
gint activity_monitor_backend_time_since_last_event (ActivityMonitorBackend* self);
static gint activity_monitor_backend_real_time_since_last_event (ActivityMonitorBackend* self);
ActivityMonitorBackend* activity_monitor_backend_construct (GType object_type);
static void activity_monitor_backend_finalize (GObject* obj);


GType activity_monitor_activity_type_get_type (void) {
	static volatile gsize activity_monitor_activity_type_type_id__volatile = 0;
	if (g_once_init_enter (&activity_monitor_activity_type_type_id__volatile)) {
		static const GEnumValue values[] = {{ACTIVITY_MONITOR_ACTIVITY_TYPE_SLEEP, "ACTIVITY_MONITOR_ACTIVITY_TYPE_SLEEP", "sleep"}, {ACTIVITY_MONITOR_ACTIVITY_TYPE_LOCKED, "ACTIVITY_MONITOR_ACTIVITY_TYPE_LOCKED", "locked"}, {ACTIVITY_MONITOR_ACTIVITY_TYPE_NONE, "ACTIVITY_MONITOR_ACTIVITY_TYPE_NONE", "none"}, {ACTIVITY_MONITOR_ACTIVITY_TYPE_INPUT, "ACTIVITY_MONITOR_ACTIVITY_TYPE_INPUT", "input"}, {ACTIVITY_MONITOR_ACTIVITY_TYPE_UNLOCK, "ACTIVITY_MONITOR_ACTIVITY_TYPE_UNLOCK", "unlock"}, {0, NULL, NULL}};
		GType activity_monitor_activity_type_type_id;
		activity_monitor_activity_type_type_id = g_enum_register_static ("ActivityMonitorActivityType", values);
		g_once_init_leave (&activity_monitor_activity_type_type_id__volatile, activity_monitor_activity_type_type_id);
	}
	return activity_monitor_activity_type_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _activity_monitor_poll_activity_cb_pausable_timeout_timeout_cb (PausableTimeout* timeout, gint delta_millisecs, gpointer self) {
	activity_monitor_poll_activity_cb ((ActivityMonitor*) self, timeout, delta_millisecs);
}


static void _activity_monitor_unlocked_cb_isession_status_unlocked (ISessionStatus* _sender, gpointer self) {
	activity_monitor_unlocked_cb ((ActivityMonitor*) self);
}


ActivityMonitor* activity_monitor_construct (GType object_type, ISessionStatus* session_status, ActivityMonitorBackend* backend) {
	ActivityMonitor * self = NULL;
	ISessionStatus* _tmp0_ = NULL;
	ISessionStatus* _tmp1_ = NULL;
	ActivityMonitorBackend* _tmp2_ = NULL;
	ActivityMonitorBackend* _tmp3_ = NULL;
	PausableTimeout* _tmp4_ = NULL;
	ISessionStatus* _tmp5_ = NULL;
	g_return_val_if_fail (session_status != NULL, NULL);
	g_return_val_if_fail (backend != NULL, NULL);
	self = (ActivityMonitor*) g_object_new (object_type, NULL);
	_tmp0_ = session_status;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->session_status);
	self->priv->session_status = _tmp1_;
	_tmp2_ = backend;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->backend);
	self->priv->backend = _tmp3_;
	_tmp4_ = pausable_timeout_new (_activity_monitor_poll_activity_cb_pausable_timeout_timeout_cb, self, 1);
	_g_object_unref0 (self->priv->poll_activity_timeout);
	self->priv->poll_activity_timeout = _tmp4_;
	_tmp5_ = session_status;
	g_signal_connect_object (_tmp5_, "unlocked", (GCallback) _activity_monitor_unlocked_cb_isession_status_unlocked, self, 0);
	memset (&self->priv->last_activity, 0, sizeof (ActivityMonitorUserActivity));
	return self;
}


ActivityMonitor* activity_monitor_new (ISessionStatus* session_status, ActivityMonitorBackend* backend) {
	return activity_monitor_construct (TYPE_ACTIVITY_MONITOR, session_status, backend);
}


JsonObject* activity_monitor_serialize (ActivityMonitor* self) {
	JsonObject* result = NULL;
	JsonObject* json_root = NULL;
	JsonObject* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	JsonObject* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = json_object_new ();
	json_root = _tmp0_;
	_tmp1_ = self->priv->last_active_timestamp;
	json_object_set_int_member (json_root, "last_active_timestamp", _tmp1_);
	_tmp2_ = activity_monitor_user_activity_serialize (&self->priv->last_activity);
	json_object_set_object_member (json_root, "last_activity", _tmp2_);
	result = json_root;
	return result;
}


static gpointer _json_object_ref0 (gpointer self) {
	return self ? json_object_ref (self) : NULL;
}


void activity_monitor_deserialize (ActivityMonitor* self, JsonObject** json_root) {
	JsonObject* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	JsonObject* last_activity_json = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonObject* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	ActivityMonitorUserActivity _tmp5_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (*json_root != NULL);
	_tmp0_ = *json_root;
	_tmp1_ = json_object_get_int_member (_tmp0_, "last_active_timestamp");
	self->priv->last_active_timestamp = _tmp1_;
	_tmp2_ = *json_root;
	_tmp3_ = json_object_get_object_member (_tmp2_, "last_activity");
	_tmp4_ = _json_object_ref0 (_tmp3_);
	last_activity_json = _tmp4_;
	activity_monitor_user_activity_deserialize (&last_activity_json, &_tmp5_);
	self->priv->last_activity = _tmp5_;
	_json_object_unref0 (last_activity_json);
}


void activity_monitor_start (ActivityMonitor* self) {
	PausableTimeout* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->poll_activity_timeout;
	pausable_timeout_start (_tmp0_);
}


void activity_monitor_stop (ActivityMonitor* self) {
	PausableTimeout* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->poll_activity_timeout;
	pausable_timeout_stop (_tmp0_);
}


void activity_monitor_poll_activity (ActivityMonitor* self) {
	ActivityMonitorUserActivity activity = {0};
	ActivityMonitorUserActivity _tmp0_ = {0};
	ActivityMonitorUserActivity _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	activity_monitor_collect_activity (self, &_tmp0_);
	activity = _tmp0_;
	_tmp1_ = activity;
	activity_monitor_add_activity (self, &_tmp1_);
}


static void activity_monitor_poll_activity_cb (ActivityMonitor* self, PausableTimeout* timeout, gint delta_millisecs) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeout != NULL);
	activity_monitor_poll_activity (self);
}


static void activity_monitor_unlocked_cb (ActivityMonitor* self) {
	ActivityMonitorUserActivity activity = {0};
	ActivityMonitorUserActivity _tmp0_ = {0};
	ActivityMonitorUserActivity _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	memset (&_tmp0_, 0, sizeof (ActivityMonitorUserActivity));
	_tmp0_.type = ACTIVITY_MONITOR_ACTIVITY_TYPE_UNLOCK;
	_tmp0_.idle_time = 0;
	_tmp0_.time_correction = 0;
	activity = _tmp0_;
	_tmp1_ = activity;
	activity_monitor_add_activity (self, &_tmp1_);
}


static void activity_monitor_add_activity (ActivityMonitor* self, ActivityMonitorUserActivity* activity) {
	ActivityMonitorUserActivity _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (activity != NULL);
	_tmp0_ = *activity;
	self->priv->last_activity = _tmp0_;
	_tmp1_ = activity_monitor_user_activity_is_active (activity);
	if (_tmp1_) {
		gint64 _tmp2_ = 0LL;
		ActivityMonitorUserActivity _tmp3_ = {0};
		_tmp2_ = util_get_real_time_seconds ();
		self->priv->last_active_timestamp = _tmp2_;
		_tmp3_ = *activity;
		g_signal_emit_by_name (self, "detected-activity", &_tmp3_);
	} else {
		ActivityMonitorUserActivity _tmp4_ = {0};
		_tmp4_ = *activity;
		g_signal_emit_by_name (self, "detected-idle", &_tmp4_);
	}
}


/**
 * Determines user activity level since the last call to this function.
 * This function is ugly and stateful, so it shouldn't be called from
 * more than one place.
 * @returns a struct with information about the user's current activity
 */
static void activity_monitor_collect_activity (ActivityMonitor* self, ActivityMonitorUserActivity* result) {
	ActivityMonitorUserActivity activity = {0};
	gint sleep_time = 0;
	ActivityMonitorBackend* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint idle_time = 0;
	ActivityMonitorBackend* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint time_since_active = 0;
	gint64 _tmp4_ = 0LL;
	gint64 _tmp5_ = 0LL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp28_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->backend;
	_tmp1_ = activity_monitor_backend_pop_sleep_time (_tmp0_);
	sleep_time = _tmp1_;
	_tmp2_ = self->priv->backend;
	_tmp3_ = activity_monitor_backend_get_idle_seconds (_tmp2_);
	idle_time = _tmp3_;
	_tmp4_ = util_get_real_time_seconds ();
	_tmp5_ = self->priv->last_active_timestamp;
	time_since_active = (gint) (_tmp4_ - _tmp5_);
	_tmp6_ = sleep_time;
	_tmp7_ = idle_time;
	if (_tmp6_ > (_tmp7_ + 5)) {
		gint _tmp8_ = 0;
		ActivityMonitorUserActivity _tmp9_ = {0};
		ActivityMonitorUserActivity _tmp10_ = {0};
		gint _tmp11_ = 0;
		_tmp8_ = sleep_time;
		memset (&_tmp9_, 0, sizeof (ActivityMonitorUserActivity));
		_tmp9_.type = ACTIVITY_MONITOR_ACTIVITY_TYPE_SLEEP;
		_tmp9_.idle_time = 0;
		_tmp9_.time_correction = _tmp8_;
		activity = _tmp9_;
		_tmp10_ = activity;
		_tmp11_ = sleep_time;
		g_debug ("ActivityMonitor.vala:149: Detected system sleep for %d seconds", _tmp11_);
	} else {
		ISessionStatus* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
		_tmp12_ = self->priv->session_status;
		_tmp13_ = isession_status_is_locked (_tmp12_);
		if (_tmp13_) {
			gint _tmp14_ = 0;
			ActivityMonitorUserActivity _tmp15_ = {0};
			ActivityMonitorUserActivity _tmp16_ = {0};
			_tmp14_ = idle_time;
			memset (&_tmp15_, 0, sizeof (ActivityMonitorUserActivity));
			_tmp15_.type = ACTIVITY_MONITOR_ACTIVITY_TYPE_LOCKED;
			_tmp15_.idle_time = _tmp14_;
			_tmp15_.time_correction = 0;
			activity = _tmp15_;
			_tmp16_ = activity;
		} else {
			gboolean _tmp17_ = FALSE;
			gint _tmp18_ = 0;
			_tmp18_ = idle_time;
			if (_tmp18_ == 0) {
				_tmp17_ = TRUE;
			} else {
				gint _tmp19_ = 0;
				ActivityMonitorUserActivity _tmp20_ = {0};
				gint _tmp21_ = 0;
				_tmp19_ = idle_time;
				_tmp20_ = self->priv->last_activity;
				_tmp21_ = _tmp20_.idle_time;
				_tmp17_ = _tmp19_ < _tmp21_;
			}
			if (_tmp17_) {
				gint _tmp22_ = 0;
				ActivityMonitorUserActivity _tmp23_ = {0};
				ActivityMonitorUserActivity _tmp24_ = {0};
				_tmp22_ = idle_time;
				memset (&_tmp23_, 0, sizeof (ActivityMonitorUserActivity));
				_tmp23_.type = ACTIVITY_MONITOR_ACTIVITY_TYPE_INPUT;
				_tmp23_.idle_time = _tmp22_;
				_tmp23_.time_correction = 0;
				activity = _tmp23_;
				_tmp24_ = activity;
			} else {
				gint _tmp25_ = 0;
				ActivityMonitorUserActivity _tmp26_ = {0};
				ActivityMonitorUserActivity _tmp27_ = {0};
				_tmp25_ = idle_time;
				memset (&_tmp26_, 0, sizeof (ActivityMonitorUserActivity));
				_tmp26_.type = ACTIVITY_MONITOR_ACTIVITY_TYPE_NONE;
				_tmp26_.idle_time = _tmp25_;
				_tmp26_.time_correction = 0;
				activity = _tmp26_;
				_tmp27_ = activity;
			}
		}
	}
	_tmp28_ = time_since_active;
	activity.time_since_active = _tmp28_;
	*result = activity;
	return;
}


static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__BOXED) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_boxed (param_values + 1), data2);
}


JsonObject* activity_monitor_user_activity_serialize (ActivityMonitorUserActivity *self) {
	JsonObject* result = NULL;
	JsonObject* json_root = NULL;
	JsonObject* _tmp0_ = NULL;
	ActivityMonitorActivityType _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	_tmp0_ = json_object_new ();
	json_root = _tmp0_;
	_tmp1_ = (*self).type;
	json_object_set_int_member (json_root, "type", (gint64) ((gint) _tmp1_));
	_tmp2_ = (*self).idle_time;
	json_object_set_int_member (json_root, "idle_time", (gint64) _tmp2_);
	_tmp3_ = (*self).time_since_active;
	json_object_set_int_member (json_root, "time_since_active", (gint64) _tmp3_);
	_tmp4_ = (*self).time_correction;
	json_object_set_int_member (json_root, "time_correction", (gint64) _tmp4_);
	result = json_root;
	return result;
}


void activity_monitor_user_activity_deserialize (JsonObject** json_root, ActivityMonitorUserActivity* result) {
	JsonObject* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	JsonObject* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	JsonObject* _tmp4_ = NULL;
	gint64 _tmp5_ = 0LL;
	JsonObject* _tmp6_ = NULL;
	gint64 _tmp7_ = 0LL;
	ActivityMonitorUserActivity _tmp8_ = {0};
	g_return_if_fail (*json_root != NULL);
	_tmp0_ = *json_root;
	_tmp1_ = json_object_get_int_member (_tmp0_, "type");
	_tmp2_ = *json_root;
	_tmp3_ = json_object_get_int_member (_tmp2_, "idle_time");
	_tmp4_ = *json_root;
	_tmp5_ = json_object_get_int_member (_tmp4_, "time_since_active");
	_tmp6_ = *json_root;
	_tmp7_ = json_object_get_int_member (_tmp6_, "time_correction");
	memset (&_tmp8_, 0, sizeof (ActivityMonitorUserActivity));
	_tmp8_.type = (ActivityMonitorActivityType) _tmp1_;
	_tmp8_.idle_time = (gint) _tmp3_;
	_tmp8_.time_since_active = (gint) _tmp5_;
	_tmp8_.time_correction = (gint) _tmp7_;
	*result = _tmp8_;
	return;
}


gboolean activity_monitor_user_activity_is_active (ActivityMonitorUserActivity *self) {
	gboolean result = FALSE;
	ActivityMonitorActivityType _tmp0_ = 0;
	_tmp0_ = (*self).type;
	result = _tmp0_ > ACTIVITY_MONITOR_ACTIVITY_TYPE_NONE;
	return result;
}


ActivityMonitorUserActivity* activity_monitor_user_activity_dup (const ActivityMonitorUserActivity* self) {
	ActivityMonitorUserActivity* dup;
	dup = g_new0 (ActivityMonitorUserActivity, 1);
	memcpy (dup, self, sizeof (ActivityMonitorUserActivity));
	return dup;
}


void activity_monitor_user_activity_free (ActivityMonitorUserActivity* self) {
	g_free (self);
}


GType activity_monitor_user_activity_get_type (void) {
	static volatile gsize activity_monitor_user_activity_type_id__volatile = 0;
	if (g_once_init_enter (&activity_monitor_user_activity_type_id__volatile)) {
		GType activity_monitor_user_activity_type_id;
		activity_monitor_user_activity_type_id = g_boxed_type_register_static ("ActivityMonitorUserActivity", (GBoxedCopyFunc) activity_monitor_user_activity_dup, (GBoxedFreeFunc) activity_monitor_user_activity_free);
		g_once_init_leave (&activity_monitor_user_activity_type_id__volatile, activity_monitor_user_activity_type_id);
	}
	return activity_monitor_user_activity_type_id__volatile;
}


static void activity_monitor_class_init (ActivityMonitorClass * klass) {
	activity_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ActivityMonitorPrivate));
	G_OBJECT_CLASS (klass)->finalize = activity_monitor_finalize;
	g_signal_new ("detected_idle", TYPE_ACTIVITY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, ACTIVITY_MONITOR_TYPE_USER_ACTIVITY);
	g_signal_new ("detected_activity", TYPE_ACTIVITY_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, ACTIVITY_MONITOR_TYPE_USER_ACTIVITY);
}


static void activity_monitor_instance_init (ActivityMonitor * self) {
	self->priv = ACTIVITY_MONITOR_GET_PRIVATE (self);
}


static void activity_monitor_finalize (GObject* obj) {
	ActivityMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACTIVITY_MONITOR, ActivityMonitor);
	_g_object_unref0 (self->priv->poll_activity_timeout);
	_g_object_unref0 (self->priv->session_status);
	_g_object_unref0 (self->priv->backend);
	G_OBJECT_CLASS (activity_monitor_parent_class)->finalize (obj);
}


GType activity_monitor_get_type (void) {
	static volatile gsize activity_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&activity_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ActivityMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) activity_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ActivityMonitor), 0, (GInstanceInitFunc) activity_monitor_instance_init, NULL };
		GType activity_monitor_type_id;
		activity_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "ActivityMonitor", &g_define_type_info, 0);
		g_once_init_leave (&activity_monitor_type_id__volatile, activity_monitor_type_id);
	}
	return activity_monitor_type_id__volatile;
}


static JsonObject* activity_monitor_backend_real_serialize (ActivityMonitorBackend* self) {
	JsonObject* result = NULL;
	JsonObject* json_root = NULL;
	JsonObject* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	gint64 _tmp2_ = 0LL;
	_tmp0_ = json_object_new ();
	json_root = _tmp0_;
	_tmp1_ = self->priv->last_real_time;
	json_object_set_int_member (json_root, "last_real_time", _tmp1_);
	_tmp2_ = self->priv->last_monotonic_time;
	json_object_set_int_member (json_root, "last_monotonic_time", _tmp2_);
	result = json_root;
	return result;
}


JsonObject* activity_monitor_backend_serialize (ActivityMonitorBackend* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return ACTIVITY_MONITOR_BACKEND_GET_CLASS (self)->serialize (self);
}


static void activity_monitor_backend_real_deserialize (ActivityMonitorBackend* self, JsonObject** json_root) {
	JsonObject* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	JsonObject* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	g_return_if_fail (*json_root != NULL);
	_tmp0_ = *json_root;
	_tmp1_ = json_object_get_int_member (_tmp0_, "last_real_time");
	self->priv->last_real_time = _tmp1_;
	_tmp2_ = *json_root;
	_tmp3_ = json_object_get_int_member (_tmp2_, "last_monotonic_time");
	self->priv->last_monotonic_time = _tmp3_;
}


void activity_monitor_backend_deserialize (ActivityMonitorBackend* self, JsonObject** json_root) {
	g_return_if_fail (self != NULL);
	ACTIVITY_MONITOR_BACKEND_GET_CLASS (self)->deserialize (self, json_root);
}


static gint activity_monitor_backend_real_time_since_last_event (ActivityMonitorBackend* self) {
	g_critical ("Type `%s' does not implement abstract method `activity_monitor_backend_time_since_last_event'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return 0;
}


gint activity_monitor_backend_time_since_last_event (ActivityMonitorBackend* self) {
	g_return_val_if_fail (self != NULL, 0);
	return ACTIVITY_MONITOR_BACKEND_GET_CLASS (self)->time_since_last_event (self);
}


gint activity_monitor_backend_get_idle_seconds (ActivityMonitorBackend* self) {
	gint result = 0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = activity_monitor_backend_time_since_last_event (self);
	result = _tmp0_;
	return result;
}


/** Detect if the device has been asleep using the difference between monotonic time and real time */
gint activity_monitor_backend_pop_sleep_time (ActivityMonitorBackend* self) {
	gint result = 0;
	gint sleep_time = 0;
	gint64 now_real = 0LL;
	gint64 _tmp0_ = 0LL;
	gint64 now_monotonic = 0LL;
	gint64 _tmp1_ = 0LL;
	gint real_time_delta = 0;
	gint64 _tmp2_ = 0LL;
	gint64 _tmp3_ = 0LL;
	gint monotonic_time_delta = 0;
	gint64 _tmp4_ = 0LL;
	gint64 _tmp5_ = 0LL;
	gint64 _tmp6_ = 0LL;
	gboolean _tmp7_ = FALSE;
	gint64 _tmp8_ = 0LL;
	gint64 _tmp15_ = 0LL;
	gint64 _tmp16_ = 0LL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = util_get_real_time_seconds ();
	now_real = _tmp0_;
	_tmp1_ = util_get_monotonic_time_seconds ();
	now_monotonic = _tmp1_;
	_tmp2_ = now_real;
	_tmp3_ = self->priv->last_real_time;
	real_time_delta = (gint) (_tmp2_ - _tmp3_);
	_tmp4_ = now_monotonic;
	_tmp5_ = self->priv->last_monotonic_time;
	_tmp6_ = llabs (_tmp4_ - _tmp5_);
	monotonic_time_delta = (gint) _tmp6_;
	_tmp8_ = self->priv->last_real_time;
	if (_tmp8_ > ((gint64) 0)) {
		gint64 _tmp9_ = 0LL;
		_tmp9_ = self->priv->last_monotonic_time;
		_tmp7_ = _tmp9_ > ((gint64) 0);
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		_tmp10_ = real_time_delta;
		_tmp11_ = monotonic_time_delta;
		if (_tmp10_ > _tmp11_) {
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			_tmp12_ = real_time_delta;
			_tmp13_ = monotonic_time_delta;
			sleep_time = (gint) (_tmp12_ - _tmp13_);
		} else {
			gint _tmp14_ = 0;
			_tmp14_ = real_time_delta;
			sleep_time = _tmp14_;
		}
	} else {
		sleep_time = 0;
	}
	_tmp15_ = now_real;
	self->priv->last_real_time = _tmp15_;
	_tmp16_ = now_monotonic;
	self->priv->last_monotonic_time = _tmp16_;
	result = sleep_time;
	return result;
}


ActivityMonitorBackend* activity_monitor_backend_construct (GType object_type) {
	ActivityMonitorBackend * self = NULL;
	self = (ActivityMonitorBackend*) g_object_new (object_type, NULL);
	return self;
}


static void activity_monitor_backend_class_init (ActivityMonitorBackendClass * klass) {
	activity_monitor_backend_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ActivityMonitorBackendPrivate));
	((ActivityMonitorBackendClass *) klass)->serialize = activity_monitor_backend_real_serialize;
	((ActivityMonitorBackendClass *) klass)->deserialize = activity_monitor_backend_real_deserialize;
	((ActivityMonitorBackendClass *) klass)->time_since_last_event = activity_monitor_backend_real_time_since_last_event;
	G_OBJECT_CLASS (klass)->finalize = activity_monitor_backend_finalize;
}


static void activity_monitor_backend_instance_init (ActivityMonitorBackend * self) {
	self->priv = ACTIVITY_MONITOR_BACKEND_GET_PRIVATE (self);
	self->priv->last_real_time = (gint64) 0;
	self->priv->last_monotonic_time = (gint64) 0;
}


static void activity_monitor_backend_finalize (GObject* obj) {
	ActivityMonitorBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackend);
	_g_free0 (self->priv->last_idle_time);
	G_OBJECT_CLASS (activity_monitor_backend_parent_class)->finalize (obj);
}


GType activity_monitor_backend_get_type (void) {
	static volatile gsize activity_monitor_backend_type_id__volatile = 0;
	if (g_once_init_enter (&activity_monitor_backend_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ActivityMonitorBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) activity_monitor_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ActivityMonitorBackend), 0, (GInstanceInitFunc) activity_monitor_backend_instance_init, NULL };
		GType activity_monitor_backend_type_id;
		activity_monitor_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "ActivityMonitorBackend", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&activity_monitor_backend_type_id__volatile, activity_monitor_backend_type_id);
	}
	return activity_monitor_backend_type_id__volatile;
}



