/* X11ActivityMonitorBackend.c generated by valac 0.32.1, the Vala compiler
 * generated from X11ActivityMonitorBackend.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gdk/gdk.h>
#include <string.h>
#include <gdk/gdkx.h>
#include <util.h>


#define TYPE_ACTIVITY_MONITOR_BACKEND (activity_monitor_backend_get_type ())
#define ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackend))
#define ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendClass))
#define IS_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACTIVITY_MONITOR_BACKEND))
#define IS_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACTIVITY_MONITOR_BACKEND))
#define ACTIVITY_MONITOR_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendClass))

typedef struct _ActivityMonitorBackend ActivityMonitorBackend;
typedef struct _ActivityMonitorBackendClass ActivityMonitorBackendClass;
typedef struct _ActivityMonitorBackendPrivate ActivityMonitorBackendPrivate;

#define TYPE_X11_ACTIVITY_MONITOR_BACKEND (x11_activity_monitor_backend_get_type ())
#define X11_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackend))
#define X11_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackendClass))
#define IS_X11_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_X11_ACTIVITY_MONITOR_BACKEND))
#define IS_X11_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_X11_ACTIVITY_MONITOR_BACKEND))
#define X11_ACTIVITY_MONITOR_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackendClass))

typedef struct _X11ActivityMonitorBackend X11ActivityMonitorBackend;
typedef struct _X11ActivityMonitorBackendClass X11ActivityMonitorBackendClass;
typedef struct _X11ActivityMonitorBackendPrivate X11ActivityMonitorBackendPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _ActivityMonitorBackend {
	GObject parent_instance;
	ActivityMonitorBackendPrivate * priv;
};

struct _ActivityMonitorBackendClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (ActivityMonitorBackend* self);
	void (*deserialize) (ActivityMonitorBackend* self, JsonObject** json_root);
	gint (*time_since_last_event) (ActivityMonitorBackend* self);
};

struct _X11ActivityMonitorBackend {
	ActivityMonitorBackend parent_instance;
	X11ActivityMonitorBackendPrivate * priv;
};

struct _X11ActivityMonitorBackendClass {
	ActivityMonitorBackendClass parent_class;
};

struct _X11ActivityMonitorBackendPrivate {
	GdkWindow* window;
	guint32 start_time;
	void* monitor_context;
	GThread* monitor_thread;
};


static gpointer x11_activity_monitor_backend_parent_class = NULL;

void* c_x11_activity_monitor_backend_create_context (void);
void c_x11_activity_monitor_backend_start (void* context);
void c_x11_activity_monitor_backend_stop (void* context);
guint32 c_x11_activity_monitor_backend_get_last_event_time (void* context);
GType activity_monitor_backend_get_type (void) G_GNUC_CONST;
GType x11_activity_monitor_backend_get_type (void) G_GNUC_CONST;
#define X11_ACTIVITY_MONITOR_BACKEND_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackendPrivate))
enum  {
	X11_ACTIVITY_MONITOR_BACKEND_DUMMY_PROPERTY
};
X11ActivityMonitorBackend* x11_activity_monitor_backend_new (GError** error);
X11ActivityMonitorBackend* x11_activity_monitor_backend_construct (GType object_type, GError** error);
ActivityMonitorBackend* activity_monitor_backend_construct (GType object_type);
static void* x11_activity_monitor_backend_thread_func (X11ActivityMonitorBackend* self);
static gpointer _x11_activity_monitor_backend_thread_func_gthread_func (gpointer self);
static gint x11_activity_monitor_backend_real_time_since_last_event (ActivityMonitorBackend* base);
static void x11_activity_monitor_backend_finalize (GObject* obj);


static gpointer _x11_activity_monitor_backend_thread_func_gthread_func (gpointer self) {
	gpointer result;
	result = x11_activity_monitor_backend_thread_func ((X11ActivityMonitorBackend*) self);
	g_object_unref (self);
	return result;
}


X11ActivityMonitorBackend* x11_activity_monitor_backend_construct (GType object_type, GError** error) {
	X11ActivityMonitorBackend * self = NULL;
	GdkWindowAttr attributes = {0};
	GdkWindowAttr _tmp0_ = {0};
	GdkWindowAttr _tmp1_ = {0};
	GdkWindow* _tmp2_ = NULL;
	GdkWindow* _tmp3_ = NULL;
	guint32 _tmp4_ = 0U;
	void* _tmp5_ = NULL;
	GThread* _tmp6_ = NULL;
	self = (X11ActivityMonitorBackend*) activity_monitor_backend_construct (object_type);
	memset (&_tmp0_, 0, sizeof (GdkWindowAttr));
	_tmp0_.window_type = GDK_WINDOW_TOPLEVEL;
	attributes = _tmp0_;
	_tmp1_ = attributes;
	_tmp2_ = gdk_window_new (NULL, &_tmp1_, GDK_WA_TYPE_HINT);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp2_;
	_tmp3_ = self->priv->window;
	_tmp4_ = gdk_x11_get_server_time (_tmp3_);
	self->priv->start_time = _tmp4_ - (10 * UTIL_MILLISECONDS_IN_SECONDS);
	_tmp5_ = c_x11_activity_monitor_backend_create_context ();
	self->priv->monitor_context = _tmp5_;
	_tmp6_ = g_thread_new ("activity-monitor", _x11_activity_monitor_backend_thread_func_gthread_func, g_object_ref (self));
	_g_thread_unref0 (self->priv->monitor_thread);
	self->priv->monitor_thread = _tmp6_;
	return self;
}


X11ActivityMonitorBackend* x11_activity_monitor_backend_new (GError** error) {
	return x11_activity_monitor_backend_construct (TYPE_X11_ACTIVITY_MONITOR_BACKEND, error);
}


static void* x11_activity_monitor_backend_thread_func (X11ActivityMonitorBackend* self) {
	void* result = NULL;
	void* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->monitor_context;
	c_x11_activity_monitor_backend_start (_tmp0_);
	result = NULL;
	return result;
}


static gint x11_activity_monitor_backend_real_time_since_last_event (ActivityMonitorBackend* base) {
	X11ActivityMonitorBackend * self;
	gint result = 0;
	guint32 now_x11 = 0U;
	GdkWindow* _tmp0_ = NULL;
	guint32 _tmp1_ = 0U;
	guint32 event_time = 0U;
	void* _tmp2_ = NULL;
	guint32 _tmp3_ = 0U;
	guint32 _tmp4_ = 0U;
	guint32 _tmp6_ = 0U;
	guint32 _tmp7_ = 0U;
	self = (X11ActivityMonitorBackend*) base;
	_tmp0_ = self->priv->window;
	_tmp1_ = gdk_x11_get_server_time (_tmp0_);
	now_x11 = _tmp1_;
	_tmp2_ = self->priv->monitor_context;
	_tmp3_ = c_x11_activity_monitor_backend_get_last_event_time (_tmp2_);
	event_time = _tmp3_;
	_tmp4_ = event_time;
	if (_tmp4_ == ((guint32) 0)) {
		guint32 _tmp5_ = 0U;
		_tmp5_ = self->priv->start_time;
		event_time = _tmp5_;
	}
	_tmp6_ = now_x11;
	_tmp7_ = event_time;
	result = (gint) ((_tmp6_ - _tmp7_) / UTIL_MILLISECONDS_IN_SECONDS);
	return result;
}


static void x11_activity_monitor_backend_class_init (X11ActivityMonitorBackendClass * klass) {
	x11_activity_monitor_backend_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (X11ActivityMonitorBackendPrivate));
	((ActivityMonitorBackendClass *) klass)->time_since_last_event = x11_activity_monitor_backend_real_time_since_last_event;
	G_OBJECT_CLASS (klass)->finalize = x11_activity_monitor_backend_finalize;
}


static void x11_activity_monitor_backend_instance_init (X11ActivityMonitorBackend * self) {
	self->priv = X11_ACTIVITY_MONITOR_BACKEND_GET_PRIVATE (self);
	self->priv->start_time = (guint32) 0;
}


static void x11_activity_monitor_backend_finalize (GObject* obj) {
	X11ActivityMonitorBackend * self;
	void* _tmp0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackend);
	_tmp0_ = self->priv->monitor_context;
	c_x11_activity_monitor_backend_stop (_tmp0_);
	_g_object_unref0 (self->priv->window);
	_g_thread_unref0 (self->priv->monitor_thread);
	G_OBJECT_CLASS (x11_activity_monitor_backend_parent_class)->finalize (obj);
}


GType x11_activity_monitor_backend_get_type (void) {
	static volatile gsize x11_activity_monitor_backend_type_id__volatile = 0;
	if (g_once_init_enter (&x11_activity_monitor_backend_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (X11ActivityMonitorBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) x11_activity_monitor_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (X11ActivityMonitorBackend), 0, (GInstanceInitFunc) x11_activity_monitor_backend_instance_init, NULL };
		GType x11_activity_monitor_backend_type_id;
		x11_activity_monitor_backend_type_id = g_type_register_static (TYPE_ACTIVITY_MONITOR_BACKEND, "X11ActivityMonitorBackend", &g_define_type_info, 0);
		g_once_init_leave (&x11_activity_monitor_backend_type_id__volatile, x11_activity_monitor_backend_type_id);
	}
	return x11_activity_monitor_backend_type_id__volatile;
}



