/* activity_monitor.h generated by valac 0.32.1, the Vala compiler, do not modify */


#ifndef __ACTIVITY_MONITOR_H__
#define __ACTIVITY_MONITOR_H__

#include <glib.h>
#include <glib-object.h>
#include <common.h>
#include <json-glib/json-glib.h>

G_BEGIN_DECLS


#define TYPE_ACTIVITY_MONITOR (activity_monitor_get_type ())
#define ACTIVITY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACTIVITY_MONITOR, ActivityMonitor))
#define ACTIVITY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACTIVITY_MONITOR, ActivityMonitorClass))
#define IS_ACTIVITY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACTIVITY_MONITOR))
#define IS_ACTIVITY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACTIVITY_MONITOR))
#define ACTIVITY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACTIVITY_MONITOR, ActivityMonitorClass))

typedef struct _ActivityMonitor ActivityMonitor;
typedef struct _ActivityMonitorClass ActivityMonitorClass;
typedef struct _ActivityMonitorPrivate ActivityMonitorPrivate;

#define ACTIVITY_MONITOR_TYPE_ACTIVITY_TYPE (activity_monitor_activity_type_get_type ())

#define TYPE_ACTIVITY_MONITOR_BACKEND (activity_monitor_backend_get_type ())
#define ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackend))
#define ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendClass))
#define IS_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACTIVITY_MONITOR_BACKEND))
#define IS_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACTIVITY_MONITOR_BACKEND))
#define ACTIVITY_MONITOR_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACTIVITY_MONITOR_BACKEND, ActivityMonitorBackendClass))

typedef struct _ActivityMonitorBackend ActivityMonitorBackend;
typedef struct _ActivityMonitorBackendClass ActivityMonitorBackendClass;

#define ACTIVITY_MONITOR_TYPE_USER_ACTIVITY (activity_monitor_user_activity_get_type ())
typedef struct _ActivityMonitorUserActivity ActivityMonitorUserActivity;
typedef struct _ActivityMonitorBackendPrivate ActivityMonitorBackendPrivate;

#define TYPE_X11_ACTIVITY_MONITOR_BACKEND (x11_activity_monitor_backend_get_type ())
#define X11_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackend))
#define X11_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackendClass))
#define IS_X11_ACTIVITY_MONITOR_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_X11_ACTIVITY_MONITOR_BACKEND))
#define IS_X11_ACTIVITY_MONITOR_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_X11_ACTIVITY_MONITOR_BACKEND))
#define X11_ACTIVITY_MONITOR_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_X11_ACTIVITY_MONITOR_BACKEND, X11ActivityMonitorBackendClass))

typedef struct _X11ActivityMonitorBackend X11ActivityMonitorBackend;
typedef struct _X11ActivityMonitorBackendClass X11ActivityMonitorBackendClass;
typedef struct _X11ActivityMonitorBackendPrivate X11ActivityMonitorBackendPrivate;

struct _ActivityMonitor {
	GObject parent_instance;
	ActivityMonitorPrivate * priv;
};

struct _ActivityMonitorClass {
	GObjectClass parent_class;
};

typedef enum  {
	ACTIVITY_MONITOR_ACTIVITY_TYPE_SLEEP,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_LOCKED,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_NONE,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_INPUT,
	ACTIVITY_MONITOR_ACTIVITY_TYPE_UNLOCK
} ActivityMonitorActivityType;

struct _ActivityMonitorUserActivity {
	ActivityMonitorActivityType type;
	gint idle_time;
	gint time_since_active;
	gint time_correction;
};

struct _ActivityMonitorBackend {
	GObject parent_instance;
	ActivityMonitorBackendPrivate * priv;
};

struct _ActivityMonitorBackendClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (ActivityMonitorBackend* self);
	void (*deserialize) (ActivityMonitorBackend* self, JsonObject** json_root);
	gint (*time_since_last_event) (ActivityMonitorBackend* self);
};

struct _X11ActivityMonitorBackend {
	ActivityMonitorBackend parent_instance;
	X11ActivityMonitorBackendPrivate * priv;
};

struct _X11ActivityMonitorBackendClass {
	ActivityMonitorBackendClass parent_class;
};


GType activity_monitor_get_type (void) G_GNUC_CONST;
GType activity_monitor_activity_type_get_type (void) G_GNUC_CONST;
GType activity_monitor_backend_get_type (void) G_GNUC_CONST;
ActivityMonitor* activity_monitor_new (ISessionStatus* session_status, ActivityMonitorBackend* backend);
ActivityMonitor* activity_monitor_construct (GType object_type, ISessionStatus* session_status, ActivityMonitorBackend* backend);
JsonObject* activity_monitor_serialize (ActivityMonitor* self);
void activity_monitor_deserialize (ActivityMonitor* self, JsonObject** json_root);
void activity_monitor_start (ActivityMonitor* self);
void activity_monitor_stop (ActivityMonitor* self);
void activity_monitor_poll_activity (ActivityMonitor* self);
GType activity_monitor_user_activity_get_type (void) G_GNUC_CONST;
ActivityMonitorUserActivity* activity_monitor_user_activity_dup (const ActivityMonitorUserActivity* self);
void activity_monitor_user_activity_free (ActivityMonitorUserActivity* self);
JsonObject* activity_monitor_user_activity_serialize (ActivityMonitorUserActivity *self);
void activity_monitor_user_activity_deserialize (JsonObject** json_root, ActivityMonitorUserActivity* result);
gboolean activity_monitor_user_activity_is_active (ActivityMonitorUserActivity *self);
JsonObject* activity_monitor_backend_serialize (ActivityMonitorBackend* self);
void activity_monitor_backend_deserialize (ActivityMonitorBackend* self, JsonObject** json_root);
gint activity_monitor_backend_time_since_last_event (ActivityMonitorBackend* self);
gint activity_monitor_backend_get_idle_seconds (ActivityMonitorBackend* self);
gint activity_monitor_backend_pop_sleep_time (ActivityMonitorBackend* self);
ActivityMonitorBackend* activity_monitor_backend_construct (GType object_type);
GType x11_activity_monitor_backend_get_type (void) G_GNUC_CONST;
X11ActivityMonitorBackend* x11_activity_monitor_backend_new (GError** error);
X11ActivityMonitorBackend* x11_activity_monitor_backend_construct (GType object_type, GError** error);


G_END_DECLS

#endif
