/* BreakController.c generated by valac 0.32.1, the Vala compiler
 * generated from BreakController.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <util.h>
#include <string.h>


#define TYPE_BREAK_CONTROLLER (break_controller_get_type ())
#define BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BREAK_CONTROLLER, BreakController))
#define BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BREAK_CONTROLLER, BreakControllerClass))
#define IS_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BREAK_CONTROLLER))
#define IS_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BREAK_CONTROLLER))
#define BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BREAK_CONTROLLER, BreakControllerClass))

typedef struct _BreakController BreakController;
typedef struct _BreakControllerClass BreakControllerClass;
typedef struct _BreakControllerPrivate BreakControllerPrivate;

#define BREAK_CONTROLLER_TYPE_STATE (break_controller_state_get_type ())

#define BREAK_CONTROLLER_TYPE_FINISHED_REASON (break_controller_finished_reason_get_type ())
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _BreakController {
	GObject parent_instance;
	BreakControllerPrivate * priv;
};

struct _BreakControllerClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (BreakController* self);
	void (*deserialize) (BreakController* self, JsonObject** json_root);
};

typedef enum  {
	BREAK_CONTROLLER_STATE_WAITING,
	BREAK_CONTROLLER_STATE_ACTIVE,
	BREAK_CONTROLLER_STATE_DISABLED
} BreakControllerState;

struct _BreakControllerPrivate {
	BreakControllerState _state;
	gint64* _activate_timestamp;
};

typedef enum  {
	BREAK_CONTROLLER_FINISHED_REASON_DISABLED,
	BREAK_CONTROLLER_FINISHED_REASON_SKIPPED,
	BREAK_CONTROLLER_FINISHED_REASON_SATISFIED
} BreakControllerFinishedReason;


static gpointer break_controller_parent_class = NULL;

GType break_controller_get_type (void) G_GNUC_CONST;
GType break_controller_state_get_type (void) G_GNUC_CONST;
#define BREAK_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_BREAK_CONTROLLER, BreakControllerPrivate))
enum  {
	BREAK_CONTROLLER_DUMMY_PROPERTY,
	BREAK_CONTROLLER_STATE
};
GType break_controller_finished_reason_get_type (void) G_GNUC_CONST;
BreakController* break_controller_construct (GType object_type);
static void break_controller_set_state (BreakController* self, BreakControllerState value);
static void break_controller_set_activate_timestamp (BreakController* self, gint64* value);
JsonObject* break_controller_serialize (BreakController* self);
static JsonObject* break_controller_real_serialize (BreakController* self);
BreakControllerState break_controller_get_state (BreakController* self);
static gint64* break_controller_get_activate_timestamp (BreakController* self);
void break_controller_deserialize (BreakController* self, JsonObject** json_root);
static void break_controller_real_deserialize (BreakController* self, JsonObject** json_root);
void break_controller_set_enabled (BreakController* self, gboolean enable);
gboolean break_controller_is_enabled (BreakController* self);
gboolean break_controller_is_active (BreakController* self);
gint break_controller_get_seconds_since_start (BreakController* self);
void break_controller_activate (BreakController* self);
void break_controller_finish (BreakController* self);
void break_controller_skip (BreakController* self, gboolean forget_start);
static gint64* _int64_dup (gint64* self);
static void g_cclosure_user_marshal_VOID__ENUM_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void break_controller_finalize (GObject* obj);
static void _vala_break_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_break_controller_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * ''WAITING'':  The break has not started yet. For example, it may be
 *               monitoring user activity in the background, waiting
 *               until the user has been working for a particular
 *               time.
 * ''ACTIVE'':   The break has started. For example, when a break
 *               becomes active, it might show a "Take a break"
 *               screen. Once the break has been satisfied, it should
 *               return to the WAITING state.
 * ''DISABLED'': The break is not in use, and should not be monitoring
 *               activity. This state is usually set explicitly by
 *               BreakManager.
*/
GType break_controller_state_get_type (void) {
	static volatile gsize break_controller_state_type_id__volatile = 0;
	if (g_once_init_enter (&break_controller_state_type_id__volatile)) {
		static const GEnumValue values[] = {{BREAK_CONTROLLER_STATE_WAITING, "BREAK_CONTROLLER_STATE_WAITING", "waiting"}, {BREAK_CONTROLLER_STATE_ACTIVE, "BREAK_CONTROLLER_STATE_ACTIVE", "active"}, {BREAK_CONTROLLER_STATE_DISABLED, "BREAK_CONTROLLER_STATE_DISABLED", "disabled"}, {0, NULL, NULL}};
		GType break_controller_state_type_id;
		break_controller_state_type_id = g_enum_register_static ("BreakControllerState", values);
		g_once_init_leave (&break_controller_state_type_id__volatile, break_controller_state_type_id);
	}
	return break_controller_state_type_id__volatile;
}


GType break_controller_finished_reason_get_type (void) {
	static volatile gsize break_controller_finished_reason_type_id__volatile = 0;
	if (g_once_init_enter (&break_controller_finished_reason_type_id__volatile)) {
		static const GEnumValue values[] = {{BREAK_CONTROLLER_FINISHED_REASON_DISABLED, "BREAK_CONTROLLER_FINISHED_REASON_DISABLED", "disabled"}, {BREAK_CONTROLLER_FINISHED_REASON_SKIPPED, "BREAK_CONTROLLER_FINISHED_REASON_SKIPPED", "skipped"}, {BREAK_CONTROLLER_FINISHED_REASON_SATISFIED, "BREAK_CONTROLLER_FINISHED_REASON_SATISFIED", "satisfied"}, {0, NULL, NULL}};
		GType break_controller_finished_reason_type_id;
		break_controller_finished_reason_type_id = g_enum_register_static ("BreakControllerFinishedReason", values);
		g_once_init_leave (&break_controller_finished_reason_type_id__volatile, break_controller_finished_reason_type_id);
	}
	return break_controller_finished_reason_type_id__volatile;
}


BreakController* break_controller_construct (GType object_type) {
	BreakController * self = NULL;
	self = (BreakController*) g_object_new (object_type, NULL);
	break_controller_set_state (self, BREAK_CONTROLLER_STATE_DISABLED);
	break_controller_set_activate_timestamp (self, NULL);
	return self;
}


static JsonObject* break_controller_real_serialize (BreakController* self) {
	JsonObject* result = NULL;
	JsonObject* json_root = NULL;
	JsonObject* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	BreakControllerState _tmp2_ = 0;
	gint64* _tmp3_ = NULL;
	_tmp0_ = json_object_new ();
	json_root = _tmp0_;
	_tmp1_ = json_root;
	_tmp2_ = self->priv->_state;
	json_object_set_int_member (_tmp1_, "state", (gint64) ((gint) _tmp2_));
	_tmp3_ = self->priv->_activate_timestamp;
	if (_tmp3_ == NULL) {
		JsonObject* _tmp4_ = NULL;
		_tmp4_ = json_root;
		json_object_set_null_member (_tmp4_, "activate_timestamp");
	} else {
		JsonObject* _tmp5_ = NULL;
		gint64* _tmp6_ = NULL;
		_tmp5_ = json_root;
		_tmp6_ = self->priv->_activate_timestamp;
		json_object_set_int_member (_tmp5_, "activate_timestamp", *_tmp6_);
	}
	result = json_root;
	return result;
}


JsonObject* break_controller_serialize (BreakController* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return BREAK_CONTROLLER_GET_CLASS (self)->serialize (self);
}


static void break_controller_real_deserialize (BreakController* self, JsonObject** json_root) {
	JsonObject* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (*json_root != NULL);
	_tmp0_ = *json_root;
	_tmp1_ = json_object_get_null_member (_tmp0_, "activate_timestamp");
	if (_tmp1_) {
		break_controller_set_activate_timestamp (self, NULL);
	} else {
		JsonObject* _tmp2_ = NULL;
		gint64 _tmp3_ = 0LL;
		_tmp2_ = *json_root;
		_tmp3_ = json_object_get_int_member (_tmp2_, "activate_timestamp");
		break_controller_set_activate_timestamp (self, &_tmp3_);
	}
}


void break_controller_deserialize (BreakController* self, JsonObject** json_root) {
	g_return_if_fail (self != NULL);
	BREAK_CONTROLLER_GET_CLASS (self)->deserialize (self, json_root);
}


/**
 * Set whether the break is enabled or disabled. If it is enabled,
 * it will periodically update in the background, and if it is
 * disabled it will do nothing (and consume fewer resources).
 * This will also emit the enabled () or disabled () signal.
 * @param enable True to enable the break, false to disable it
 */
void break_controller_set_enabled (BreakController* self, gboolean enable) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp1_ = enable;
	if (_tmp1_) {
		gboolean _tmp2_ = FALSE;
		_tmp2_ = break_controller_is_enabled (self);
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		break_controller_set_state (self, BREAK_CONTROLLER_STATE_WAITING);
		g_signal_emit_by_name (self, "enabled");
	} else {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		_tmp4_ = enable;
		if (!_tmp4_) {
			gboolean _tmp5_ = FALSE;
			_tmp5_ = break_controller_is_enabled (self);
			_tmp3_ = _tmp5_;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			gboolean was_active = FALSE;
			BreakControllerState _tmp6_ = 0;
			gboolean _tmp7_ = FALSE;
			_tmp6_ = self->priv->_state;
			was_active = _tmp6_ == BREAK_CONTROLLER_STATE_ACTIVE;
			break_controller_set_state (self, BREAK_CONTROLLER_STATE_DISABLED);
			_tmp7_ = was_active;
			g_signal_emit_by_name (self, "finished", BREAK_CONTROLLER_FINISHED_REASON_DISABLED, _tmp7_);
			g_signal_emit_by_name (self, "disabled");
		}
	}
}


/**
 * @return True if the break is enabled and waiting to start automatically
 */
gboolean break_controller_is_enabled (BreakController* self) {
	gboolean result = FALSE;
	BreakControllerState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	result = _tmp0_ != BREAK_CONTROLLER_STATE_DISABLED;
	return result;
}


/**
 * @return True if the break has been activated, is in focus, and expects to be satisfied
 */
gboolean break_controller_is_active (BreakController* self) {
	gboolean result = FALSE;
	BreakControllerState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	result = _tmp0_ == BREAK_CONTROLLER_STATE_ACTIVE;
	return result;
}


/**
 * @return The real time, in seconds, since the break was activated.
 */
gint break_controller_get_seconds_since_start (BreakController* self) {
	gint result = 0;
	gint64* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_activate_timestamp;
	if (_tmp0_ != NULL) {
		gint64 _tmp1_ = 0LL;
		gint64* _tmp2_ = NULL;
		_tmp1_ = util_get_real_time_seconds ();
		_tmp2_ = self->priv->_activate_timestamp;
		result = (gint) (_tmp1_ - (*_tmp2_));
		return result;
	} else {
		result = 0;
		return result;
	}
}


/**
 * Start a break. This is usually triggered automatically by the break
 * controller itself, but it may be triggered externally as well.
 */
void break_controller_activate (BreakController* self) {
	BreakControllerState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_state;
	if (_tmp0_ < BREAK_CONTROLLER_STATE_ACTIVE) {
		gint64* _tmp1_ = NULL;
		_tmp1_ = self->priv->_activate_timestamp;
		if (_tmp1_ == NULL) {
			gint64 _tmp2_ = 0LL;
			_tmp2_ = util_get_real_time_seconds ();
			break_controller_set_activate_timestamp (self, &_tmp2_);
		}
		break_controller_set_state (self, BREAK_CONTROLLER_STATE_ACTIVE);
		g_signal_emit_by_name (self, "activated");
	}
}


/**
 * The break's requirements have been satisfied. Start counting from
 * the beginning again.
 */
void break_controller_finish (BreakController* self) {
	gboolean was_active = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = break_controller_is_active (self);
	was_active = _tmp0_;
	break_controller_set_state (self, BREAK_CONTROLLER_STATE_WAITING);
	break_controller_set_activate_timestamp (self, NULL);
	g_signal_emit_by_name (self, "finished", BREAK_CONTROLLER_FINISHED_REASON_SATISFIED, was_active);
}


/**
 * We're skipping this break. The BreakController should act as if the
 * break has finished as usual, but we will send a different
 * FinishedReason to the "finished" signal. This way, its BreakView will
 * know to present this differently than if the break has actually been
 * satisfied.
 * @param forget_start true to reset the value returned by get_seconds_since_start
 */
void break_controller_skip (BreakController* self, gboolean forget_start) {
	gboolean was_active = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = break_controller_is_active (self);
	was_active = _tmp0_;
	break_controller_set_state (self, BREAK_CONTROLLER_STATE_WAITING);
	_tmp1_ = forget_start;
	if (_tmp1_) {
		break_controller_set_activate_timestamp (self, NULL);
	}
	_tmp2_ = was_active;
	g_signal_emit_by_name (self, "finished", BREAK_CONTROLLER_FINISHED_REASON_SKIPPED, _tmp2_);
}


BreakControllerState break_controller_get_state (BreakController* self) {
	BreakControllerState result;
	BreakControllerState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


static void break_controller_set_state (BreakController* self, BreakControllerState value) {
	BreakControllerState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_state = _tmp0_;
	g_object_notify ((GObject *) self, "state");
}


static gint64* break_controller_get_activate_timestamp (BreakController* self) {
	gint64* result;
	gint64* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_activate_timestamp;
	result = _tmp0_;
	return result;
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
	dup = g_new0 (gint64, 1);
	memcpy (dup, self, sizeof (gint64));
	return dup;
}


static gpointer __int64_dup0 (gpointer self) {
	return self ? _int64_dup (self) : NULL;
}


static void break_controller_set_activate_timestamp (BreakController* self, gint64* value) {
	gint64* _tmp0_ = NULL;
	gint64* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = __int64_dup0 (_tmp0_);
	_g_free0 (self->priv->_activate_timestamp);
	self->priv->_activate_timestamp = _tmp1_;
}


static void g_cclosure_user_marshal_VOID__ENUM_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__ENUM_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}


static void break_controller_class_init (BreakControllerClass * klass) {
	break_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (BreakControllerPrivate));
	((BreakControllerClass *) klass)->serialize = break_controller_real_serialize;
	((BreakControllerClass *) klass)->deserialize = break_controller_real_deserialize;
	G_OBJECT_CLASS (klass)->get_property = _vala_break_controller_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_break_controller_set_property;
	G_OBJECT_CLASS (klass)->finalize = break_controller_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BREAK_CONTROLLER_STATE, g_param_spec_enum ("state", "state", "state", BREAK_CONTROLLER_TYPE_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	/** The break has been enabled. It will monitor user activity and emit activated () or finished () signals until it is disabled. */
	g_signal_new ("enabled", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/** The break has been disabled. Its timers have been stopped and it will not do anything until it is enabled again. */
	g_signal_new ("disabled", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/** The break is going to happen soon */
	g_signal_new ("warned", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/** The break is no longer going to start soon */
	g_signal_new ("unwarned", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/** The break has been activated and is now counting down aggressively until it is satisfied. */
	g_signal_new ("activated", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/** The break has been satisfied. This can happen at any time, including while the break is waiting or after it has been activiated. */
	g_signal_new ("finished", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_BOOLEAN, G_TYPE_NONE, 2, BREAK_CONTROLLER_TYPE_FINISHED_REASON, G_TYPE_BOOLEAN);
	/** The break is active and it has progressed in some fashion (for example, remaining time has changed). */
	g_signal_new ("active_changed", TYPE_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void break_controller_instance_init (BreakController * self) {
	self->priv = BREAK_CONTROLLER_GET_PRIVATE (self);
}


static void break_controller_finalize (GObject* obj) {
	BreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BREAK_CONTROLLER, BreakController);
	_g_free0 (self->priv->_activate_timestamp);
	G_OBJECT_CLASS (break_controller_parent_class)->finalize (obj);
}


/**
 * Base class for a break's activity tracking functionality.
 * A break can be started or stopped, and once started it will be activated
 * and finished either manually or autonomously based on user activity, or
 * some related metric. The mechanism for activating a break and for
 * satisfying it is unique to each implementation.
 * This class provides mechanisms for tracking and directly setting the
 * break's state, which can be either WAITING, ACTIVE, or DISABLED.
 */
GType break_controller_get_type (void) {
	static volatile gsize break_controller_type_id__volatile = 0;
	if (g_once_init_enter (&break_controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BreakControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) break_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BreakController), 0, (GInstanceInitFunc) break_controller_instance_init, NULL };
		GType break_controller_type_id;
		break_controller_type_id = g_type_register_static (G_TYPE_OBJECT, "BreakController", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&break_controller_type_id__volatile, break_controller_type_id);
	}
	return break_controller_type_id__volatile;
}


static void _vala_break_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	BreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BREAK_CONTROLLER, BreakController);
	switch (property_id) {
		case BREAK_CONTROLLER_STATE:
		g_value_set_enum (value, break_controller_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_break_controller_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	BreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BREAK_CONTROLLER, BreakController);
	switch (property_id) {
		case BREAK_CONTROLLER_STATE:
		break_controller_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



