/* TimerBreakController.c generated by valac 0.32.1, the Vala compiler
 * generated from TimerBreakController.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <util.h>
#include <activity_monitor.h>


#define TYPE_BREAK_CONTROLLER (break_controller_get_type ())
#define BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BREAK_CONTROLLER, BreakController))
#define BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BREAK_CONTROLLER, BreakControllerClass))
#define IS_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BREAK_CONTROLLER))
#define IS_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BREAK_CONTROLLER))
#define BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BREAK_CONTROLLER, BreakControllerClass))

typedef struct _BreakController BreakController;
typedef struct _BreakControllerClass BreakControllerClass;
typedef struct _BreakControllerPrivate BreakControllerPrivate;

#define TYPE_TIMER_BREAK_CONTROLLER (timer_break_controller_get_type ())
#define TIMER_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController))
#define TIMER_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerClass))
#define IS_TIMER_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMER_BREAK_CONTROLLER))
#define IS_TIMER_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMER_BREAK_CONTROLLER))
#define TIMER_BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerClass))

typedef struct _TimerBreakController TimerBreakController;
typedef struct _TimerBreakControllerClass TimerBreakControllerClass;
typedef struct _TimerBreakControllerPrivate TimerBreakControllerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define BREAK_CONTROLLER_TYPE_STATE (break_controller_state_get_type ())

#define BREAK_CONTROLLER_TYPE_FINISHED_REASON (break_controller_finished_reason_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _BreakController {
	GObject parent_instance;
	BreakControllerPrivate * priv;
};

struct _BreakControllerClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (BreakController* self);
	void (*deserialize) (BreakController* self, JsonObject** json_root);
};

struct _TimerBreakController {
	BreakController parent_instance;
	TimerBreakControllerPrivate * priv;
	Countdown* interval_countdown;
	Countdown* duration_countdown;
	PausableTimeout* countdowns_timeout;
	gint fuzzy_seconds;
};

struct _TimerBreakControllerClass {
	BreakControllerClass parent_class;
};

struct _TimerBreakControllerPrivate {
	gint _interval;
	gint _duration;
	StatefulTimer* counting_timer;
	StatefulTimer* delayed_timer;
	gboolean is_warned;
};

typedef enum  {
	BREAK_CONTROLLER_STATE_WAITING,
	BREAK_CONTROLLER_STATE_ACTIVE,
	BREAK_CONTROLLER_STATE_DISABLED
} BreakControllerState;

typedef enum  {
	BREAK_CONTROLLER_FINISHED_REASON_DISABLED,
	BREAK_CONTROLLER_FINISHED_REASON_SKIPPED,
	BREAK_CONTROLLER_FINISHED_REASON_SATISFIED
} BreakControllerFinishedReason;


static gpointer timer_break_controller_parent_class = NULL;

GType break_controller_get_type (void) G_GNUC_CONST;
GType timer_break_controller_get_type (void) G_GNUC_CONST;
#define TIMER_BREAK_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerPrivate))
enum  {
	TIMER_BREAK_CONTROLLER_DUMMY_PROPERTY,
	TIMER_BREAK_CONTROLLER_INTERVAL,
	TIMER_BREAK_CONTROLLER_DURATION
};
TimerBreakController* timer_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor, gint fuzzy_seconds);
BreakController* break_controller_construct (GType object_type);
gint timer_break_controller_get_interval (TimerBreakController* self);
gint timer_break_controller_get_duration (TimerBreakController* self);
static void timer_break_controller_update_countdowns (TimerBreakController* self, PausableTimeout* timeout, gint delta_millisecs);
static void _timer_break_controller_update_countdowns_pausable_timeout_timeout_cb (PausableTimeout* timeout, gint delta_millisecs, gpointer self);
static void __lambda15_ (TimerBreakController* self, GObject* s, GParamSpec* p);
static void ___lambda15__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void __lambda16_ (TimerBreakController* self, GObject* s, GParamSpec* p);
GType break_controller_state_get_type (void) G_GNUC_CONST;
BreakControllerState break_controller_get_state (BreakController* self);
static void timer_break_controller_unwarn (TimerBreakController* self);
static void ___lambda16__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void timer_break_controller_detected_activity_cb (TimerBreakController* self, ActivityMonitorUserActivity* activity);
static void _timer_break_controller_detected_activity_cb_activity_monitor_detected_activity (ActivityMonitor* _sender, ActivityMonitorUserActivity* activity, gpointer self);
static void timer_break_controller_detected_idle_cb (TimerBreakController* self, ActivityMonitorUserActivity* activity);
static void _timer_break_controller_detected_idle_cb_activity_monitor_detected_idle (ActivityMonitor* _sender, ActivityMonitorUserActivity* activity, gpointer self);
static void timer_break_controller_enabled_cb (TimerBreakController* self);
static void _timer_break_controller_enabled_cb_break_controller_enabled (BreakController* _sender, gpointer self);
static void timer_break_controller_disabled_cb (TimerBreakController* self);
static void _timer_break_controller_disabled_cb_break_controller_disabled (BreakController* _sender, gpointer self);
static void timer_break_controller_activated_cb (TimerBreakController* self);
static void _timer_break_controller_activated_cb_break_controller_activated (BreakController* _sender, gpointer self);
GType break_controller_finished_reason_get_type (void) G_GNUC_CONST;
static void timer_break_controller_finished_cb (TimerBreakController* self, BreakControllerFinishedReason reason);
static void _timer_break_controller_finished_cb_break_controller_finished (BreakController* _sender, BreakControllerFinishedReason reason, gboolean was_active, gpointer self);
static JsonObject* timer_break_controller_real_serialize (BreakController* base);
JsonObject* break_controller_serialize (BreakController* self);
static void timer_break_controller_real_deserialize (BreakController* base, JsonObject** json_root);
void break_controller_deserialize (BreakController* self, JsonObject** json_root);
static void timer_break_controller_warn (TimerBreakController* self);
gint timer_break_controller_starts_in (TimerBreakController* self);
gint timer_break_controller_get_time_remaining (TimerBreakController* self);
void timer_break_controller_postpone (TimerBreakController* self, gint resume_after);
void break_controller_skip (BreakController* self, gboolean forget_start);
gint timer_break_controller_get_current_duration (TimerBreakController* self);
gboolean break_controller_is_enabled (BreakController* self);
void break_controller_finish (BreakController* self);
void break_controller_activate (BreakController* self);
void timer_break_controller_set_interval (TimerBreakController* self, gint value);
void timer_break_controller_set_duration (TimerBreakController* self, gint value);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void timer_break_controller_finalize (GObject* obj);
static void _vala_timer_break_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_timer_break_controller_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _timer_break_controller_update_countdowns_pausable_timeout_timeout_cb (PausableTimeout* timeout, gint delta_millisecs, gpointer self) {
	timer_break_controller_update_countdowns ((TimerBreakController*) self, timeout, delta_millisecs);
}


static void __lambda15_ (TimerBreakController* self, GObject* s, GParamSpec* p) {
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->interval_countdown;
	_tmp1_ = self->priv->_interval;
	countdown_set_base_duration (_tmp0_, _tmp1_);
}


static void ___lambda15__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda15_ ((TimerBreakController*) self, _sender, pspec);
}


static void __lambda16_ (TimerBreakController* self, GObject* s, GParamSpec* p) {
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	BreakControllerState _tmp2_ = 0;
	BreakControllerState _tmp3_ = 0;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->duration_countdown;
	_tmp1_ = self->priv->_duration;
	countdown_set_base_duration (_tmp0_, _tmp1_);
	_tmp2_ = break_controller_get_state ((BreakController*) self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ == BREAK_CONTROLLER_STATE_WAITING) {
		timer_break_controller_unwarn (self);
	}
}


static void ___lambda16__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda16_ ((TimerBreakController*) self, _sender, pspec);
}


static void _timer_break_controller_detected_activity_cb_activity_monitor_detected_activity (ActivityMonitor* _sender, ActivityMonitorUserActivity* activity, gpointer self) {
	timer_break_controller_detected_activity_cb ((TimerBreakController*) self, activity);
}


static void _timer_break_controller_detected_idle_cb_activity_monitor_detected_idle (ActivityMonitor* _sender, ActivityMonitorUserActivity* activity, gpointer self) {
	timer_break_controller_detected_idle_cb ((TimerBreakController*) self, activity);
}


static void _timer_break_controller_enabled_cb_break_controller_enabled (BreakController* _sender, gpointer self) {
	timer_break_controller_enabled_cb ((TimerBreakController*) self);
}


static void _timer_break_controller_disabled_cb_break_controller_disabled (BreakController* _sender, gpointer self) {
	timer_break_controller_disabled_cb ((TimerBreakController*) self);
}


static void _timer_break_controller_activated_cb_break_controller_activated (BreakController* _sender, gpointer self) {
	timer_break_controller_activated_cb ((TimerBreakController*) self);
}


static void _timer_break_controller_finished_cb_break_controller_finished (BreakController* _sender, BreakControllerFinishedReason reason, gboolean was_active, gpointer self) {
	timer_break_controller_finished_cb ((TimerBreakController*) self, reason);
}


TimerBreakController* timer_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor, gint fuzzy_seconds) {
	TimerBreakController * self = NULL;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Countdown* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	Countdown* _tmp4_ = NULL;
	PausableTimeout* _tmp5_ = NULL;
	ActivityMonitor* _tmp6_ = NULL;
	ActivityMonitor* _tmp7_ = NULL;
	g_return_val_if_fail (activity_monitor != NULL, NULL);
	self = (TimerBreakController*) break_controller_construct (object_type);
	_tmp0_ = fuzzy_seconds;
	self->fuzzy_seconds = _tmp0_;
	_tmp1_ = self->priv->_interval;
	_tmp2_ = countdown_new (_tmp1_);
	_g_object_unref0 (self->interval_countdown);
	self->interval_countdown = _tmp2_;
	_tmp3_ = self->priv->_duration;
	_tmp4_ = countdown_new (_tmp3_);
	_g_object_unref0 (self->duration_countdown);
	self->duration_countdown = _tmp4_;
	_tmp5_ = pausable_timeout_new (_timer_break_controller_update_countdowns_pausable_timeout_timeout_cb, self, 1);
	_g_object_unref0 (self->countdowns_timeout);
	self->countdowns_timeout = _tmp5_;
	g_signal_connect_object ((GObject*) self, "notify::interval", (GCallback) ___lambda15__g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::duration", (GCallback) ___lambda16__g_object_notify, self, 0);
	_tmp6_ = activity_monitor;
	g_signal_connect_object (_tmp6_, "detected-activity", (GCallback) _timer_break_controller_detected_activity_cb_activity_monitor_detected_activity, self, 0);
	_tmp7_ = activity_monitor;
	g_signal_connect_object (_tmp7_, "detected-idle", (GCallback) _timer_break_controller_detected_idle_cb_activity_monitor_detected_idle, self, 0);
	g_signal_connect_object ((BreakController*) self, "enabled", (GCallback) _timer_break_controller_enabled_cb_break_controller_enabled, self, 0);
	g_signal_connect_object ((BreakController*) self, "disabled", (GCallback) _timer_break_controller_disabled_cb_break_controller_disabled, self, 0);
	g_signal_connect_object ((BreakController*) self, "activated", (GCallback) _timer_break_controller_activated_cb_break_controller_activated, self, 0);
	g_signal_connect_object ((BreakController*) self, "finished", (GCallback) _timer_break_controller_finished_cb_break_controller_finished, self, 0);
	return self;
}


static JsonObject* timer_break_controller_real_serialize (BreakController* base) {
	TimerBreakController * self;
	JsonObject* result = NULL;
	JsonObject* json_root = NULL;
	JsonObject* _tmp0_ = NULL;
	Countdown* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	Countdown* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	PausableTimeout* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	StatefulTimer* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	StatefulTimer* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	self = (TimerBreakController*) base;
	_tmp0_ = BREAK_CONTROLLER_CLASS (timer_break_controller_parent_class)->serialize (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BREAK_CONTROLLER, BreakController));
	json_root = _tmp0_;
	_tmp1_ = self->interval_countdown;
	_tmp2_ = countdown_serialize (_tmp1_);
	_tmp3_ = _tmp2_;
	json_object_set_string_member (json_root, "interval_countdown", _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = self->duration_countdown;
	_tmp5_ = countdown_serialize (_tmp4_);
	_tmp6_ = _tmp5_;
	json_object_set_string_member (json_root, "duration_countdown", _tmp6_);
	_g_free0 (_tmp6_);
	_tmp7_ = self->countdowns_timeout;
	_tmp8_ = pausable_timeout_serialize (_tmp7_);
	_tmp9_ = _tmp8_;
	json_object_set_string_member (json_root, "countdowns_timeout", _tmp9_);
	_g_free0 (_tmp9_);
	_tmp10_ = self->priv->counting_timer;
	_tmp11_ = stateful_timer_serialize (_tmp10_);
	_tmp12_ = _tmp11_;
	json_object_set_string_member (json_root, "counting_timer", _tmp12_);
	_g_free0 (_tmp12_);
	_tmp13_ = self->priv->delayed_timer;
	_tmp14_ = stateful_timer_serialize (_tmp13_);
	_tmp15_ = _tmp14_;
	json_object_set_string_member (json_root, "delayed_timer", _tmp15_);
	_g_free0 (_tmp15_);
	result = json_root;
	return result;
}


static void timer_break_controller_real_deserialize (BreakController* base, JsonObject** json_root) {
	TimerBreakController * self;
	Countdown* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	Countdown* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	PausableTimeout* _tmp6_ = NULL;
	JsonObject* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	StatefulTimer* _tmp9_ = NULL;
	JsonObject* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	StatefulTimer* _tmp12_ = NULL;
	JsonObject* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	self = (TimerBreakController*) base;
	g_return_if_fail (*json_root != NULL);
	BREAK_CONTROLLER_CLASS (timer_break_controller_parent_class)->deserialize (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BREAK_CONTROLLER, BreakController), json_root);
	_tmp0_ = self->interval_countdown;
	_tmp1_ = *json_root;
	_tmp2_ = json_object_get_string_member (_tmp1_, "interval_countdown");
	countdown_deserialize (_tmp0_, _tmp2_, FALSE);
	_tmp3_ = self->duration_countdown;
	_tmp4_ = *json_root;
	_tmp5_ = json_object_get_string_member (_tmp4_, "duration_countdown");
	countdown_deserialize (_tmp3_, _tmp5_, FALSE);
	_tmp6_ = self->countdowns_timeout;
	_tmp7_ = *json_root;
	_tmp8_ = json_object_get_string_member (_tmp7_, "countdowns_timeout");
	pausable_timeout_deserialize (_tmp6_, _tmp8_);
	_tmp9_ = self->priv->counting_timer;
	_tmp10_ = *json_root;
	_tmp11_ = json_object_get_string_member (_tmp10_, "counting_timer");
	stateful_timer_deserialize (_tmp9_, _tmp11_);
	_tmp12_ = self->priv->delayed_timer;
	_tmp13_ = *json_root;
	_tmp14_ = json_object_get_string_member (_tmp13_, "delayed_timer");
	stateful_timer_deserialize (_tmp12_, _tmp14_);
}


static void timer_break_controller_enabled_cb (TimerBreakController* self) {
	Countdown* _tmp0_ = NULL;
	Countdown* _tmp1_ = NULL;
	PausableTimeout* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->interval_countdown;
	countdown_continue (_tmp0_);
	_tmp1_ = self->duration_countdown;
	countdown_pause (_tmp1_);
	_tmp2_ = self->countdowns_timeout;
	pausable_timeout_start (_tmp2_);
}


static void timer_break_controller_disabled_cb (TimerBreakController* self) {
	Countdown* _tmp0_ = NULL;
	Countdown* _tmp1_ = NULL;
	PausableTimeout* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->interval_countdown;
	countdown_pause (_tmp0_);
	_tmp1_ = self->duration_countdown;
	countdown_pause (_tmp1_);
	_tmp2_ = self->countdowns_timeout;
	pausable_timeout_stop (_tmp2_);
}


static void timer_break_controller_activated_cb (TimerBreakController* self) {
	Countdown* _tmp0_ = NULL;
	Countdown* _tmp1_ = NULL;
	StatefulTimer* _tmp2_ = NULL;
	StatefulTimer* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->interval_countdown;
	countdown_pause (_tmp0_);
	_tmp1_ = self->duration_countdown;
	countdown_continue (_tmp1_);
	_tmp2_ = self->priv->counting_timer;
	stateful_timer_reset (_tmp2_);
	_tmp3_ = self->priv->delayed_timer;
	stateful_timer_reset (_tmp3_);
}


static void timer_break_controller_finished_cb (TimerBreakController* self, BreakControllerFinishedReason reason) {
	BreakControllerFinishedReason _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = reason;
	if (_tmp0_ > BREAK_CONTROLLER_FINISHED_REASON_DISABLED) {
		Countdown* _tmp1_ = NULL;
		Countdown* _tmp2_ = NULL;
		StatefulTimer* _tmp3_ = NULL;
		StatefulTimer* _tmp4_ = NULL;
		_tmp1_ = self->interval_countdown;
		countdown_reset (_tmp1_);
		_tmp2_ = self->duration_countdown;
		countdown_reset (_tmp2_);
		_tmp3_ = self->priv->counting_timer;
		stateful_timer_reset (_tmp3_);
		_tmp4_ = self->priv->delayed_timer;
		stateful_timer_reset (_tmp4_);
	}
}


static void timer_break_controller_warn (TimerBreakController* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->is_warned;
	if (!_tmp0_) {
		self->priv->is_warned = TRUE;
		g_signal_emit_by_name ((BreakController*) self, "warned");
	}
}


static void timer_break_controller_unwarn (TimerBreakController* self) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->is_warned;
	if (_tmp0_) {
		self->priv->is_warned = FALSE;
		g_signal_emit_by_name ((BreakController*) self, "unwarned");
	}
}


/**
 * @return Time until the next scheduled break, in seconds.
 */
gint timer_break_controller_starts_in (TimerBreakController* self) {
	gint result = 0;
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->interval_countdown;
	_tmp1_ = countdown_get_time_remaining (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * @return Idle time remaining until the break is satisfied.
 */
gint timer_break_controller_get_time_remaining (TimerBreakController* self) {
	gint result = 0;
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->duration_countdown;
	_tmp1_ = countdown_get_time_remaining (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * Stops the break and starts it again at some point in the future.
 * @param resume_after the amount of time to postpone for
 */
void timer_break_controller_postpone (TimerBreakController* self, gint resume_after) {
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_if_fail (self != NULL);
	break_controller_skip ((BreakController*) self, FALSE);
	_tmp0_ = self->interval_countdown;
	_tmp1_ = resume_after;
	_tmp2_ = self->priv->_interval;
	countdown_continue_from (_tmp0_, _tmp1_ - _tmp2_);
}


/**
 * @return Total length of the break, taking into account extra time that
 *         may have been added outside of the break's settings.
 */
gint timer_break_controller_get_current_duration (TimerBreakController* self) {
	gint result = 0;
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->duration_countdown;
	_tmp1_ = countdown_get_duration (_tmp0_);
	result = _tmp1_;
	return result;
}


static void timer_break_controller_detected_idle_cb (TimerBreakController* self, ActivityMonitorUserActivity* activity) {
	gboolean _tmp0_ = FALSE;
	ActivityMonitorUserActivity _tmp1_ = {0};
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	ActivityMonitorUserActivity _tmp5_ = {0};
	gint _tmp6_ = 0;
	BreakControllerState _tmp10_ = 0;
	BreakControllerState _tmp11_ = 0;
	gint lap_time = 0;
	StatefulTimer* _tmp17_ = NULL;
	StatefulTimer* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	gint _tmp25_ = 0;
	StatefulTimer* _tmp26_ = NULL;
	gdouble _tmp27_ = 0.0;
	PausableTimeout* _tmp28_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (activity != NULL);
	_tmp0_ = break_controller_is_enabled ((BreakController*) self);
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = *activity;
	_tmp2_ = _tmp1_.time_since_active;
	_tmp3_ = self->fuzzy_seconds;
	if (_tmp2_ < _tmp3_) {
		ActivityMonitorUserActivity _tmp4_ = {0};
		_tmp4_ = *activity;
		timer_break_controller_detected_activity_cb (self, &_tmp4_);
		return;
	}
	_tmp5_ = *activity;
	_tmp6_ = _tmp5_.time_correction;
	if (_tmp6_ > 0) {
		Countdown* _tmp7_ = NULL;
		ActivityMonitorUserActivity _tmp8_ = {0};
		gint _tmp9_ = 0;
		_tmp7_ = self->duration_countdown;
		_tmp8_ = *activity;
		_tmp9_ = _tmp8_.time_correction;
		countdown_advance_time (_tmp7_, _tmp9_);
	}
	_tmp10_ = break_controller_get_state ((BreakController*) self);
	_tmp11_ = _tmp10_;
	if (_tmp11_ == BREAK_CONTROLLER_STATE_WAITING) {
		Countdown* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		Countdown* _tmp15_ = NULL;
		_tmp12_ = self->interval_countdown;
		_tmp13_ = countdown_get_time_elapsed (_tmp12_);
		if (_tmp13_ > 0) {
			Countdown* _tmp14_ = NULL;
			_tmp14_ = self->duration_countdown;
			countdown_continue (_tmp14_);
		}
		_tmp15_ = self->interval_countdown;
		countdown_pause (_tmp15_);
	} else {
		Countdown* _tmp16_ = NULL;
		_tmp16_ = self->duration_countdown;
		countdown_continue (_tmp16_);
	}
	_tmp17_ = self->priv->delayed_timer;
	stateful_timer_freeze (_tmp17_);
	_tmp18_ = self->priv->counting_timer;
	_tmp19_ = stateful_timer_is_stopped (_tmp18_);
	if (_tmp19_) {
		StatefulTimer* _tmp20_ = NULL;
		ActivityMonitorUserActivity _tmp21_ = {0};
		gint _tmp22_ = 0;
		_tmp20_ = self->priv->counting_timer;
		stateful_timer_start_lap (_tmp20_);
		_tmp21_ = *activity;
		_tmp22_ = _tmp21_.idle_time;
		lap_time = _tmp22_;
	} else {
		StatefulTimer* _tmp23_ = NULL;
		gdouble _tmp24_ = 0.0;
		_tmp23_ = self->priv->counting_timer;
		_tmp24_ = stateful_timer_lap_time (_tmp23_);
		lap_time = (gint) _tmp24_;
	}
	_tmp25_ = lap_time;
	_tmp26_ = self->priv->counting_timer;
	_tmp27_ = stateful_timer_elapsed (_tmp26_);
	g_signal_emit_by_name (self, "counting", _tmp25_, (gint) _tmp27_);
	_tmp28_ = self->countdowns_timeout;
	pausable_timeout_run_once (_tmp28_);
}


static void timer_break_controller_detected_activity_cb (TimerBreakController* self, ActivityMonitorUserActivity* activity) {
	gboolean _tmp0_ = FALSE;
	gint lap_time = 0;
	StatefulTimer* _tmp1_ = NULL;
	StatefulTimer* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	Countdown* _tmp7_ = NULL;
	BreakControllerState _tmp8_ = 0;
	BreakControllerState _tmp9_ = 0;
	gint _tmp11_ = 0;
	StatefulTimer* _tmp12_ = NULL;
	gdouble _tmp13_ = 0.0;
	PausableTimeout* _tmp14_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (activity != NULL);
	_tmp0_ = break_controller_is_enabled ((BreakController*) self);
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->counting_timer;
	stateful_timer_freeze (_tmp1_);
	_tmp2_ = self->priv->delayed_timer;
	_tmp3_ = stateful_timer_is_stopped (_tmp2_);
	if (_tmp3_) {
		StatefulTimer* _tmp4_ = NULL;
		_tmp4_ = self->priv->delayed_timer;
		stateful_timer_start_lap (_tmp4_);
		lap_time = 0;
	} else {
		StatefulTimer* _tmp5_ = NULL;
		gdouble _tmp6_ = 0.0;
		_tmp5_ = self->priv->delayed_timer;
		_tmp6_ = stateful_timer_lap_time (_tmp5_);
		lap_time = (gint) _tmp6_;
	}
	_tmp7_ = self->duration_countdown;
	countdown_pause (_tmp7_);
	_tmp8_ = break_controller_get_state ((BreakController*) self);
	_tmp9_ = _tmp8_;
	if (_tmp9_ == BREAK_CONTROLLER_STATE_WAITING) {
		Countdown* _tmp10_ = NULL;
		_tmp10_ = self->interval_countdown;
		countdown_continue (_tmp10_);
	}
	_tmp11_ = lap_time;
	_tmp12_ = self->priv->delayed_timer;
	_tmp13_ = stateful_timer_elapsed (_tmp12_);
	g_signal_emit_by_name (self, "delayed", _tmp11_, (gint) _tmp13_);
	_tmp14_ = self->countdowns_timeout;
	pausable_timeout_run_once (_tmp14_);
}


/**
 * Checks if it is time to activate the break. The break will activate as
 * soon as soon as interval_countdown reaches 0. The break's "warned"
 * signal is fired when the break is close (within its set duration) to
 * starting.
 */
static void timer_break_controller_update_countdowns (TimerBreakController* self, PausableTimeout* timeout, gint delta_millisecs) {
	Countdown* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (timeout != NULL);
	_tmp0_ = self->duration_countdown;
	_tmp1_ = countdown_is_finished (_tmp0_);
	if (_tmp1_) {
		Countdown* _tmp2_ = NULL;
		_tmp2_ = self->duration_countdown;
		countdown_reset (_tmp2_);
		break_controller_finish ((BreakController*) self);
	} else {
		BreakControllerState _tmp3_ = 0;
		BreakControllerState _tmp4_ = 0;
		_tmp3_ = break_controller_get_state ((BreakController*) self);
		_tmp4_ = _tmp3_;
		if (_tmp4_ == BREAK_CONTROLLER_STATE_WAITING) {
			gint _tmp5_ = 0;
			_tmp5_ = timer_break_controller_starts_in (self);
			if (_tmp5_ == 0) {
				break_controller_activate ((BreakController*) self);
			} else {
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				_tmp6_ = timer_break_controller_starts_in (self);
				_tmp7_ = self->priv->_duration;
				if (_tmp6_ <= _tmp7_) {
					timer_break_controller_warn (self);
				} else {
					timer_break_controller_unwarn (self);
				}
			}
		} else {
			BreakControllerState _tmp8_ = 0;
			BreakControllerState _tmp9_ = 0;
			_tmp8_ = break_controller_get_state ((BreakController*) self);
			_tmp9_ = _tmp8_;
			if (_tmp9_ == BREAK_CONTROLLER_STATE_ACTIVE) {
				g_signal_emit_by_name ((BreakController*) self, "active-changed");
			}
		}
	}
}


gint timer_break_controller_get_interval (TimerBreakController* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_interval;
	result = _tmp0_;
	return result;
}


void timer_break_controller_set_interval (TimerBreakController* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_interval = _tmp0_;
	g_object_notify ((GObject *) self, "interval");
}


gint timer_break_controller_get_duration (TimerBreakController* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_duration;
	result = _tmp0_;
	return result;
}


void timer_break_controller_set_duration (TimerBreakController* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_duration = _tmp0_;
	g_object_notify ((GObject *) self, "duration");
}


static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}


static void timer_break_controller_class_init (TimerBreakControllerClass * klass) {
	timer_break_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TimerBreakControllerPrivate));
	((BreakControllerClass *) klass)->serialize = timer_break_controller_real_serialize;
	((BreakControllerClass *) klass)->deserialize = timer_break_controller_real_deserialize;
	G_OBJECT_CLASS (klass)->get_property = _vala_timer_break_controller_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_timer_break_controller_set_property;
	G_OBJECT_CLASS (klass)->finalize = timer_break_controller_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TIMER_BREAK_CONTROLLER_INTERVAL, g_param_spec_int ("interval", "interval", "interval", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TIMER_BREAK_CONTROLLER_DURATION, g_param_spec_int ("duration", "duration", "duration", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** Fires continually, as long as the break is active and counting down. */
	g_signal_new ("counting", TYPE_TIMER_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
	/** Fires as long as the break is active but is not counting down. */
	g_signal_new ("delayed", TYPE_TIMER_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
}


static void timer_break_controller_instance_init (TimerBreakController * self) {
	StatefulTimer* _tmp0_ = NULL;
	StatefulTimer* _tmp1_ = NULL;
	self->priv = TIMER_BREAK_CONTROLLER_GET_PRIVATE (self);
	_tmp0_ = stateful_timer_new ();
	self->priv->counting_timer = _tmp0_;
	_tmp1_ = stateful_timer_new ();
	self->priv->delayed_timer = _tmp1_;
}


static void timer_break_controller_finalize (GObject* obj) {
	TimerBreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController);
	_g_object_unref0 (self->interval_countdown);
	_g_object_unref0 (self->duration_countdown);
	_g_object_unref0 (self->countdowns_timeout);
	_g_object_unref0 (self->priv->counting_timer);
	_g_object_unref0 (self->priv->delayed_timer);
	G_OBJECT_CLASS (timer_break_controller_parent_class)->finalize (obj);
}


/**
 * A type of break that times user activity. It activates after a particular
 * amount of uninterupted activity, and the break is finished after a
 * different amount of inactivity. The timer break has two timers: an interval
 * (time between breaks) and a duration (the length of each break). Once
 * started, the timer break continuously counts down for its interval, then
 * activates and counts down for its duration.
 */
GType timer_break_controller_get_type (void) {
	static volatile gsize timer_break_controller_type_id__volatile = 0;
	if (g_once_init_enter (&timer_break_controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TimerBreakControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) timer_break_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TimerBreakController), 0, (GInstanceInitFunc) timer_break_controller_instance_init, NULL };
		GType timer_break_controller_type_id;
		timer_break_controller_type_id = g_type_register_static (TYPE_BREAK_CONTROLLER, "TimerBreakController", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&timer_break_controller_type_id__volatile, timer_break_controller_type_id);
	}
	return timer_break_controller_type_id__volatile;
}


static void _vala_timer_break_controller_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TimerBreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController);
	switch (property_id) {
		case TIMER_BREAK_CONTROLLER_INTERVAL:
		g_value_set_int (value, timer_break_controller_get_interval (self));
		break;
		case TIMER_BREAK_CONTROLLER_DURATION:
		g_value_set_int (value, timer_break_controller_get_duration (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_timer_break_controller_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TimerBreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController);
	switch (property_id) {
		case TIMER_BREAK_CONTROLLER_INTERVAL:
		timer_break_controller_set_interval (self, g_value_get_int (value));
		break;
		case TIMER_BREAK_CONTROLLER_DURATION:
		timer_break_controller_set_duration (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



