/* MicroBreakController.c generated by valac 0.32.1, the Vala compiler
 * generated from MicroBreakController.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <util.h>
#include <activity_monitor.h>


#define TYPE_BREAK_CONTROLLER (break_controller_get_type ())
#define BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BREAK_CONTROLLER, BreakController))
#define BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BREAK_CONTROLLER, BreakControllerClass))
#define IS_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BREAK_CONTROLLER))
#define IS_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BREAK_CONTROLLER))
#define BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BREAK_CONTROLLER, BreakControllerClass))

typedef struct _BreakController BreakController;
typedef struct _BreakControllerClass BreakControllerClass;
typedef struct _BreakControllerPrivate BreakControllerPrivate;

#define TYPE_TIMER_BREAK_CONTROLLER (timer_break_controller_get_type ())
#define TIMER_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController))
#define TIMER_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerClass))
#define IS_TIMER_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMER_BREAK_CONTROLLER))
#define IS_TIMER_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMER_BREAK_CONTROLLER))
#define TIMER_BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerClass))

typedef struct _TimerBreakController TimerBreakController;
typedef struct _TimerBreakControllerClass TimerBreakControllerClass;
typedef struct _TimerBreakControllerPrivate TimerBreakControllerPrivate;

#define TYPE_MICRO_BREAK_CONTROLLER (micro_break_controller_get_type ())
#define MICRO_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MICRO_BREAK_CONTROLLER, MicroBreakController))
#define MICRO_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MICRO_BREAK_CONTROLLER, MicroBreakControllerClass))
#define IS_MICRO_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MICRO_BREAK_CONTROLLER))
#define IS_MICRO_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MICRO_BREAK_CONTROLLER))
#define MICRO_BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MICRO_BREAK_CONTROLLER, MicroBreakControllerClass))

typedef struct _MicroBreakController MicroBreakController;
typedef struct _MicroBreakControllerClass MicroBreakControllerClass;
typedef struct _MicroBreakControllerPrivate MicroBreakControllerPrivate;

struct _BreakController {
	GObject parent_instance;
	BreakControllerPrivate * priv;
};

struct _BreakControllerClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (BreakController* self);
	void (*deserialize) (BreakController* self, JsonObject** json_root);
};

struct _TimerBreakController {
	BreakController parent_instance;
	TimerBreakControllerPrivate * priv;
	Countdown* interval_countdown;
	Countdown* duration_countdown;
	PausableTimeout* countdowns_timeout;
	gint fuzzy_seconds;
};

struct _TimerBreakControllerClass {
	BreakControllerClass parent_class;
};

struct _MicroBreakController {
	TimerBreakController parent_instance;
	MicroBreakControllerPrivate * priv;
};

struct _MicroBreakControllerClass {
	TimerBreakControllerClass parent_class;
};


static gpointer micro_break_controller_parent_class = NULL;

GType break_controller_get_type (void) G_GNUC_CONST;
GType timer_break_controller_get_type (void) G_GNUC_CONST;
GType micro_break_controller_get_type (void) G_GNUC_CONST;
enum  {
	MICRO_BREAK_CONTROLLER_DUMMY_PROPERTY
};
MicroBreakController* micro_break_controller_new (ActivityMonitor* activity_monitor);
MicroBreakController* micro_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor);
TimerBreakController* timer_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor, gint fuzzy_seconds);
static void micro_break_controller_delayed_cb (MicroBreakController* self, gint lap_time, gint total_time);
static void _micro_break_controller_delayed_cb_timer_break_controller_delayed (TimerBreakController* _sender, gint lap_time, gint total_time, gpointer self);


static void _micro_break_controller_delayed_cb_timer_break_controller_delayed (TimerBreakController* _sender, gint lap_time, gint total_time, gpointer self) {
	micro_break_controller_delayed_cb ((MicroBreakController*) self, lap_time, total_time);
}


MicroBreakController* micro_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor) {
	MicroBreakController * self = NULL;
	ActivityMonitor* _tmp0_ = NULL;
	g_return_val_if_fail (activity_monitor != NULL, NULL);
	_tmp0_ = activity_monitor;
	self = (MicroBreakController*) timer_break_controller_construct (object_type, _tmp0_, 0);
	g_signal_connect_object ((TimerBreakController*) self, "delayed", (GCallback) _micro_break_controller_delayed_cb_timer_break_controller_delayed, self, 0);
	return self;
}


MicroBreakController* micro_break_controller_new (ActivityMonitor* activity_monitor) {
	return micro_break_controller_construct (TYPE_MICRO_BREAK_CONTROLLER, activity_monitor);
}


static void micro_break_controller_delayed_cb (MicroBreakController* self, gint lap_time, gint total_time) {
	Countdown* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = ((TimerBreakController*) self)->duration_countdown;
	countdown_reset (_tmp0_);
}


static void micro_break_controller_class_init (MicroBreakControllerClass * klass) {
	micro_break_controller_parent_class = g_type_class_peek_parent (klass);
}


static void micro_break_controller_instance_init (MicroBreakController * self) {
}


/**
 * A type of timer break that should activate frequently and for short
 * durations. Satisfied when the user is inactive for its entire duration,
 * and when it is active it restarts its countdown whenever the user types
 * or moves the mouse.
 */
GType micro_break_controller_get_type (void) {
	static volatile gsize micro_break_controller_type_id__volatile = 0;
	if (g_once_init_enter (&micro_break_controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MicroBreakControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) micro_break_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MicroBreakController), 0, (GInstanceInitFunc) micro_break_controller_instance_init, NULL };
		GType micro_break_controller_type_id;
		micro_break_controller_type_id = g_type_register_static (TYPE_TIMER_BREAK_CONTROLLER, "MicroBreakController", &g_define_type_info, 0);
		g_once_init_leave (&micro_break_controller_type_id__volatile, micro_break_controller_type_id);
	}
	return micro_break_controller_type_id__volatile;
}



