/* RestBreakController.c generated by valac 0.32.1, the Vala compiler
 * generated from RestBreakController.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <util.h>
#include <activity_monitor.h>


#define TYPE_BREAK_CONTROLLER (break_controller_get_type ())
#define BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BREAK_CONTROLLER, BreakController))
#define BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BREAK_CONTROLLER, BreakControllerClass))
#define IS_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BREAK_CONTROLLER))
#define IS_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BREAK_CONTROLLER))
#define BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BREAK_CONTROLLER, BreakControllerClass))

typedef struct _BreakController BreakController;
typedef struct _BreakControllerClass BreakControllerClass;
typedef struct _BreakControllerPrivate BreakControllerPrivate;

#define TYPE_TIMER_BREAK_CONTROLLER (timer_break_controller_get_type ())
#define TIMER_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController))
#define TIMER_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerClass))
#define IS_TIMER_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMER_BREAK_CONTROLLER))
#define IS_TIMER_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMER_BREAK_CONTROLLER))
#define TIMER_BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMER_BREAK_CONTROLLER, TimerBreakControllerClass))

typedef struct _TimerBreakController TimerBreakController;
typedef struct _TimerBreakControllerClass TimerBreakControllerClass;
typedef struct _TimerBreakControllerPrivate TimerBreakControllerPrivate;

#define TYPE_REST_BREAK_CONTROLLER (rest_break_controller_get_type ())
#define REST_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REST_BREAK_CONTROLLER, RestBreakController))
#define REST_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REST_BREAK_CONTROLLER, RestBreakControllerClass))
#define IS_REST_BREAK_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REST_BREAK_CONTROLLER))
#define IS_REST_BREAK_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REST_BREAK_CONTROLLER))
#define REST_BREAK_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REST_BREAK_CONTROLLER, RestBreakControllerClass))

typedef struct _RestBreakController RestBreakController;
typedef struct _RestBreakControllerClass RestBreakControllerClass;
typedef struct _RestBreakControllerPrivate RestBreakControllerPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

#define BREAK_CONTROLLER_TYPE_STATE (break_controller_state_get_type ())

struct _BreakController {
	GObject parent_instance;
	BreakControllerPrivate * priv;
};

struct _BreakControllerClass {
	GObjectClass parent_class;
	JsonObject* (*serialize) (BreakController* self);
	void (*deserialize) (BreakController* self, JsonObject** json_root);
};

struct _TimerBreakController {
	BreakController parent_instance;
	TimerBreakControllerPrivate * priv;
	Countdown* interval_countdown;
	Countdown* duration_countdown;
	PausableTimeout* countdowns_timeout;
	gint fuzzy_seconds;
};

struct _TimerBreakControllerClass {
	BreakControllerClass parent_class;
};

struct _RestBreakController {
	TimerBreakController parent_instance;
	RestBreakControllerPrivate * priv;
};

struct _RestBreakControllerClass {
	TimerBreakControllerClass parent_class;
};

struct _RestBreakControllerPrivate {
	Countdown* reminder_countdown;
};

typedef enum  {
	BREAK_CONTROLLER_STATE_WAITING,
	BREAK_CONTROLLER_STATE_ACTIVE,
	BREAK_CONTROLLER_STATE_DISABLED
} BreakControllerState;


static gpointer rest_break_controller_parent_class = NULL;

GType break_controller_get_type (void) G_GNUC_CONST;
GType timer_break_controller_get_type (void) G_GNUC_CONST;
GType rest_break_controller_get_type (void) G_GNUC_CONST;
#define REST_BREAK_CONTROLLER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_REST_BREAK_CONTROLLER, RestBreakControllerPrivate))
enum  {
	REST_BREAK_CONTROLLER_DUMMY_PROPERTY
};
RestBreakController* rest_break_controller_new (ActivityMonitor* activity_monitor);
RestBreakController* rest_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor);
TimerBreakController* timer_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor, gint fuzzy_seconds);
gint timer_break_controller_get_interval (TimerBreakController* self);
static void __lambda18_ (RestBreakController* self, GObject* s, GParamSpec* p);
static void ___lambda18__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void __lambda19_ (RestBreakController* self);
static void ___lambda19__break_controller_activated (BreakController* _sender, gpointer self);
static void rest_break_controller_counting_cb (RestBreakController* self, gint lap_time, gint total_time);
static void _rest_break_controller_counting_cb_timer_break_controller_counting (TimerBreakController* _sender, gint lap_time, gint total_time, gpointer self);
static void rest_break_controller_delayed_cb (RestBreakController* self, gint lap_time, gint total_time);
static void _rest_break_controller_delayed_cb_timer_break_controller_delayed (TimerBreakController* _sender, gint lap_time, gint total_time, gpointer self);
static JsonObject* rest_break_controller_real_serialize (BreakController* base);
JsonObject* break_controller_serialize (BreakController* self);
static void rest_break_controller_real_deserialize (BreakController* base, JsonObject** json_root);
void break_controller_deserialize (BreakController* self, JsonObject** json_root);
GType break_controller_state_get_type (void) G_GNUC_CONST;
BreakControllerState break_controller_get_state (BreakController* self);
gint timer_break_controller_get_duration (TimerBreakController* self);
static void rest_break_controller_finalize (GObject* obj);


static void __lambda18_ (RestBreakController* self, GObject* s, GParamSpec* p) {
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->reminder_countdown;
	_tmp1_ = timer_break_controller_get_interval ((TimerBreakController*) self);
	_tmp2_ = _tmp1_;
	countdown_set_base_duration (_tmp0_, _tmp2_ / 4);
}


static void ___lambda18__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda18_ ((RestBreakController*) self, _sender, pspec);
}


static void __lambda19_ (RestBreakController* self) {
	Countdown* _tmp0_ = NULL;
	_tmp0_ = self->priv->reminder_countdown;
	countdown_reset (_tmp0_);
}


static void ___lambda19__break_controller_activated (BreakController* _sender, gpointer self) {
	__lambda19_ ((RestBreakController*) self);
}


static void _rest_break_controller_counting_cb_timer_break_controller_counting (TimerBreakController* _sender, gint lap_time, gint total_time, gpointer self) {
	rest_break_controller_counting_cb ((RestBreakController*) self, lap_time, total_time);
}


static void _rest_break_controller_delayed_cb_timer_break_controller_delayed (TimerBreakController* _sender, gint lap_time, gint total_time, gpointer self) {
	rest_break_controller_delayed_cb ((RestBreakController*) self, lap_time, total_time);
}


RestBreakController* rest_break_controller_construct (GType object_type, ActivityMonitor* activity_monitor) {
	RestBreakController * self = NULL;
	ActivityMonitor* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Countdown* _tmp3_ = NULL;
	g_return_val_if_fail (activity_monitor != NULL, NULL);
	_tmp0_ = activity_monitor;
	self = (RestBreakController*) timer_break_controller_construct (object_type, _tmp0_, 5);
	_tmp1_ = timer_break_controller_get_interval ((TimerBreakController*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = countdown_new (_tmp2_ / 4);
	_g_object_unref0 (self->priv->reminder_countdown);
	self->priv->reminder_countdown = _tmp3_;
	g_signal_connect_object ((GObject*) self, "notify::interval", (GCallback) ___lambda18__g_object_notify, self, 0);
	g_signal_connect_object ((BreakController*) self, "activated", (GCallback) ___lambda19__break_controller_activated, self, 0);
	g_signal_connect_object ((TimerBreakController*) self, "counting", (GCallback) _rest_break_controller_counting_cb_timer_break_controller_counting, self, 0);
	g_signal_connect_object ((TimerBreakController*) self, "delayed", (GCallback) _rest_break_controller_delayed_cb_timer_break_controller_delayed, self, 0);
	return self;
}


RestBreakController* rest_break_controller_new (ActivityMonitor* activity_monitor) {
	return rest_break_controller_construct (TYPE_REST_BREAK_CONTROLLER, activity_monitor);
}


static JsonObject* rest_break_controller_real_serialize (BreakController* base) {
	RestBreakController * self;
	JsonObject* result = NULL;
	JsonObject* json_root = NULL;
	JsonObject* _tmp0_ = NULL;
	Countdown* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	self = (RestBreakController*) base;
	_tmp0_ = BREAK_CONTROLLER_CLASS (rest_break_controller_parent_class)->serialize ((BreakController*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController));
	json_root = _tmp0_;
	_tmp1_ = self->priv->reminder_countdown;
	_tmp2_ = countdown_serialize (_tmp1_);
	_tmp3_ = _tmp2_;
	json_object_set_string_member (json_root, "reminder_countdown", _tmp3_);
	_g_free0 (_tmp3_);
	result = json_root;
	return result;
}


static void rest_break_controller_real_deserialize (BreakController* base, JsonObject** json_root) {
	RestBreakController * self;
	Countdown* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	self = (RestBreakController*) base;
	g_return_if_fail (*json_root != NULL);
	BREAK_CONTROLLER_CLASS (rest_break_controller_parent_class)->deserialize ((BreakController*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_TIMER_BREAK_CONTROLLER, TimerBreakController), json_root);
	_tmp0_ = self->priv->reminder_countdown;
	_tmp1_ = *json_root;
	_tmp2_ = json_object_get_string_member (_tmp1_, "reminder_countdown");
	countdown_deserialize (_tmp0_, _tmp2_, FALSE);
}


static void rest_break_controller_counting_cb (RestBreakController* self, gint lap_time, gint total_time) {
	Countdown* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->reminder_countdown;
	countdown_pause (_tmp0_);
	_tmp1_ = lap_time;
	if (_tmp1_ > 60) {
		Countdown* _tmp2_ = NULL;
		_tmp2_ = self->priv->reminder_countdown;
		countdown_reset (_tmp2_);
	}
}


static void rest_break_controller_delayed_cb (RestBreakController* self, gint lap_time, gint total_time) {
	gboolean _tmp0_ = FALSE;
	BreakControllerState _tmp1_ = 0;
	BreakControllerState _tmp2_ = 0;
	Countdown* _tmp5_ = NULL;
	Countdown* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp1_ = break_controller_get_state ((BreakController*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == BREAK_CONTROLLER_STATE_WAITING) {
		gint _tmp3_ = 0;
		_tmp3_ = lap_time;
		_tmp0_ = _tmp3_ > 10;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		Countdown* _tmp4_ = NULL;
		_tmp4_ = ((TimerBreakController*) self)->duration_countdown;
		countdown_reset (_tmp4_);
	}
	_tmp5_ = self->priv->reminder_countdown;
	countdown_continue (_tmp5_);
	_tmp6_ = self->priv->reminder_countdown;
	_tmp7_ = countdown_is_finished (_tmp6_);
	if (_tmp7_) {
		gint new_penalty = 0;
		Countdown* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		Countdown* _tmp16_ = NULL;
		Countdown* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		Countdown* _tmp19_ = NULL;
		_tmp8_ = ((TimerBreakController*) self)->duration_countdown;
		_tmp9_ = countdown_get_penalty (_tmp8_);
		_tmp10_ = timer_break_controller_get_duration ((TimerBreakController*) self);
		_tmp11_ = _tmp10_;
		new_penalty = _tmp9_ + (_tmp11_ / 4);
		_tmp12_ = new_penalty;
		_tmp13_ = timer_break_controller_get_duration ((TimerBreakController*) self);
		_tmp14_ = _tmp13_;
		_tmp15_ = MIN (_tmp12_, _tmp14_ / 2);
		new_penalty = _tmp15_;
		_tmp16_ = ((TimerBreakController*) self)->duration_countdown;
		countdown_reset (_tmp16_);
		_tmp17_ = ((TimerBreakController*) self)->duration_countdown;
		_tmp18_ = new_penalty;
		countdown_set_penalty (_tmp17_, _tmp18_);
		g_signal_emit_by_name (self, "current-duration-changed");
		_tmp19_ = self->priv->reminder_countdown;
		countdown_start (_tmp19_);
	}
}


static void rest_break_controller_class_init (RestBreakControllerClass * klass) {
	rest_break_controller_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RestBreakControllerPrivate));
	((BreakControllerClass *) klass)->serialize = rest_break_controller_real_serialize;
	((BreakControllerClass *) klass)->deserialize = rest_break_controller_real_deserialize;
	G_OBJECT_CLASS (klass)->finalize = rest_break_controller_finalize;
	g_signal_new ("current_duration_changed", TYPE_REST_BREAK_CONTROLLER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void rest_break_controller_instance_init (RestBreakController * self) {
	self->priv = REST_BREAK_CONTROLLER_GET_PRIVATE (self);
}


static void rest_break_controller_finalize (GObject* obj) {
	RestBreakController * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_REST_BREAK_CONTROLLER, RestBreakController);
	_g_object_unref0 (self->priv->reminder_countdown);
	G_OBJECT_CLASS (rest_break_controller_parent_class)->finalize (obj);
}


/**
 * A type of timer break designed for longer durations. Satisfied when the user
 * is inactive for its entire duration, but allows the user to interact with
 * the computer while it counts down. The timer will stop until the user has
 * finished using the computer, and then it will start to count down again.
 */
GType rest_break_controller_get_type (void) {
	static volatile gsize rest_break_controller_type_id__volatile = 0;
	if (g_once_init_enter (&rest_break_controller_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RestBreakControllerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rest_break_controller_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RestBreakController), 0, (GInstanceInitFunc) rest_break_controller_instance_init, NULL };
		GType rest_break_controller_type_id;
		rest_break_controller_type_id = g_type_register_static (TYPE_TIMER_BREAK_CONTROLLER, "RestBreakController", &g_define_type_info, 0);
		g_once_init_leave (&rest_break_controller_type_id__volatile, rest_break_controller_type_id);
	}
	return rest_break_controller_type_id__volatile;
}



