/* Countdown.c generated by valac 0.32.1, the Vala compiler
 * generated from Countdown.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_COUNTDOWN (countdown_get_type ())
#define COUNTDOWN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COUNTDOWN, Countdown))
#define COUNTDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COUNTDOWN, CountdownClass))
#define IS_COUNTDOWN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COUNTDOWN))
#define IS_COUNTDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COUNTDOWN))
#define COUNTDOWN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COUNTDOWN, CountdownClass))

typedef struct _Countdown Countdown;
typedef struct _CountdownClass CountdownClass;
typedef struct _CountdownPrivate CountdownPrivate;

#define COUNTDOWN_TYPE_STATE (countdown_state_get_type ())

struct _Countdown {
	GObject parent_instance;
	CountdownPrivate * priv;
};

struct _CountdownClass {
	GObjectClass parent_class;
};

typedef enum  {
	COUNTDOWN_STATE_STOPPED,
	COUNTDOWN_STATE_PAUSED,
	COUNTDOWN_STATE_COUNTING
} CountdownState;

struct _CountdownPrivate {
	CountdownState state;
	gint base_duration;
	gint64 start_time;
	gint stop_time_elapsed;
	gint penalty;
};


static gpointer countdown_parent_class = NULL;

GType countdown_get_type (void) G_GNUC_CONST;
static GType countdown_state_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define COUNTDOWN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COUNTDOWN, CountdownPrivate))
enum  {
	COUNTDOWN_DUMMY_PROPERTY
};
Countdown* countdown_new (gint base_duration);
Countdown* countdown_construct (GType object_type, gint base_duration);
void countdown_reset (Countdown* self);
gchar* countdown_serialize (Countdown* self);
gint64 util_get_real_time_seconds (void);
void countdown_deserialize (Countdown* self, const gchar* data, gboolean persistent);
void countdown_pause (Countdown* self);
void countdown_start (Countdown* self);
void countdown_advance_time (Countdown* self, gint seconds_off);
void countdown_start_from (Countdown* self, gint start_offset);
void countdown_continue_from (Countdown* self, gint start_offset);
gint countdown_get_time_elapsed (Countdown* self);
void countdown_continue (Countdown* self);
void countdown_cancel_pause (Countdown* self);
void countdown_set_penalty (Countdown* self, gint penalty);
gint countdown_get_penalty (Countdown* self);
gboolean countdown_is_counting (Countdown* self);
void countdown_set_base_duration (Countdown* self, gint base_duration);
gint countdown_get_duration (Countdown* self);
gint countdown_get_time_remaining (Countdown* self);
gboolean countdown_is_finished (Countdown* self);
static void countdown_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static GType countdown_state_get_type (void) {
	static volatile gsize countdown_state_type_id__volatile = 0;
	if (g_once_init_enter (&countdown_state_type_id__volatile)) {
		static const GEnumValue values[] = {{COUNTDOWN_STATE_STOPPED, "COUNTDOWN_STATE_STOPPED", "stopped"}, {COUNTDOWN_STATE_PAUSED, "COUNTDOWN_STATE_PAUSED", "paused"}, {COUNTDOWN_STATE_COUNTING, "COUNTDOWN_STATE_COUNTING", "counting"}, {0, NULL, NULL}};
		GType countdown_state_type_id;
		countdown_state_type_id = g_enum_register_static ("CountdownState", values);
		g_once_init_leave (&countdown_state_type_id__volatile, countdown_state_type_id);
	}
	return countdown_state_type_id__volatile;
}


Countdown* countdown_construct (GType object_type, gint base_duration) {
	Countdown * self = NULL;
	gint _tmp0_ = 0;
	self = (Countdown*) g_object_new (object_type, NULL);
	_tmp0_ = base_duration;
	self->priv->base_duration = _tmp0_;
	countdown_reset (self);
	return self;
}


Countdown* countdown_new (gint base_duration) {
	return countdown_construct (TYPE_COUNTDOWN, base_duration);
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	_tmp0_ = separator;
	if (_tmp0_ == NULL) {
		separator = "";
	}
	_tmp3_ = str_array;
	_tmp3__length1 = str_array_length1;
	if (_tmp3_ != NULL) {
		_tmp2_ = TRUE;
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp4_ = str_array;
		_tmp4__length1 = str_array_length1;
		_tmp2_ = _tmp4__length1 > 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp6_ = str_array;
		_tmp6__length1 = str_array_length1;
		if (_tmp6__length1 == -1) {
			gchar** _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			const gchar* _tmp8_ = NULL;
			_tmp7_ = str_array;
			_tmp7__length1 = str_array_length1;
			_tmp8_ = _tmp7_[0];
			_tmp5_ = _tmp8_ != NULL;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gsize _tmp35_ = 0UL;
		const gchar* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		const gchar* res = NULL;
		gsize _tmp40_ = 0UL;
		void* _tmp41_ = NULL;
		void* ptr = NULL;
		const gchar* _tmp42_ = NULL;
		gchar** _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		const gchar* _tmp44_ = NULL;
		void* _tmp45_ = NULL;
		const gchar* _tmp62_ = NULL;
		len = (gsize) 1;
		{
			gboolean _tmp9_ = FALSE;
			i = 0;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp21_ = 0;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gsize _tmp30_ = 0UL;
				if (!_tmp9_) {
					gint _tmp10_ = 0;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp13_ = str_array;
				_tmp13__length1 = str_array_length1;
				if (_tmp13__length1 != -1) {
					gint _tmp14_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
					_tmp14_ = i;
					_tmp15_ = str_array;
					_tmp15__length1 = str_array_length1;
					_tmp12_ = _tmp14_ < _tmp15__length1;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					_tmp11_ = TRUE;
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
					_tmp17_ = str_array;
					_tmp17__length1 = str_array_length1;
					if (_tmp17__length1 == -1) {
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
						_tmp18_ = str_array;
						_tmp18__length1 = str_array_length1;
						_tmp19_ = i;
						_tmp20_ = _tmp18_[_tmp19_];
						_tmp16_ = _tmp20_ != NULL;
					} else {
						_tmp16_ = FALSE;
					}
					_tmp11_ = _tmp16_;
				}
				if (!_tmp11_) {
					break;
				}
				_tmp22_ = str_array;
				_tmp22__length1 = str_array_length1;
				_tmp23_ = i;
				_tmp24_ = _tmp22_[_tmp23_];
				if (_tmp24_ != NULL) {
					gchar** _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					gint _tmp29_ = 0;
					_tmp25_ = str_array;
					_tmp25__length1 = str_array_length1;
					_tmp26_ = i;
					_tmp27_ = _tmp25_[_tmp26_];
					_tmp28_ = strlen ((const gchar*) _tmp27_);
					_tmp29_ = _tmp28_;
					_tmp21_ = _tmp29_;
				} else {
					_tmp21_ = 0;
				}
				_tmp30_ = len;
				len = _tmp30_ + _tmp21_;
			}
		}
		_tmp31_ = i;
		if (_tmp31_ == 0) {
			gchar* _tmp32_ = NULL;
			_tmp32_ = g_strdup ("");
			result = _tmp32_;
			return result;
		}
		_tmp33_ = i;
		str_array_length1 = _tmp33_;
		_tmp34_ = str_array_length1;
		_tmp35_ = len;
		_tmp36_ = separator;
		_tmp37_ = strlen ((const gchar*) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = i;
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
		_tmp40_ = len;
		_tmp41_ = g_malloc (_tmp40_);
		res = _tmp41_;
		_tmp42_ = res;
		_tmp43_ = str_array;
		_tmp43__length1 = str_array_length1;
		_tmp44_ = _tmp43_[0];
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
		ptr = _tmp45_;
		{
			gboolean _tmp46_ = FALSE;
			i = 1;
			_tmp46_ = TRUE;
			while (TRUE) {
				gint _tmp48_ = 0;
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				void* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				void* _tmp52_ = NULL;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				const gchar* _tmp56_ = NULL;
				void* _tmp60_ = NULL;
				void* _tmp61_ = NULL;
				if (!_tmp46_) {
					gint _tmp47_ = 0;
					_tmp47_ = i;
					i = _tmp47_ + 1;
				}
				_tmp46_ = FALSE;
				_tmp48_ = i;
				_tmp49_ = str_array;
				_tmp49__length1 = str_array_length1;
				if (!(_tmp48_ < _tmp49__length1)) {
					break;
				}
				_tmp50_ = ptr;
				_tmp51_ = separator;
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
				ptr = _tmp52_;
				_tmp54_ = str_array;
				_tmp54__length1 = str_array_length1;
				_tmp55_ = i;
				_tmp56_ = _tmp54_[_tmp55_];
				if (_tmp56_ != NULL) {
					gchar** _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					const gchar* _tmp59_ = NULL;
					_tmp57_ = str_array;
					_tmp57__length1 = str_array_length1;
					_tmp58_ = i;
					_tmp59_ = _tmp57_[_tmp58_];
					_tmp53_ = (const gchar*) _tmp59_;
				} else {
					_tmp53_ = "";
				}
				_tmp60_ = ptr;
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
				ptr = _tmp61_;
			}
		}
		_tmp62_ = res;
		res = NULL;
		result = (gchar*) _tmp62_;
		return result;
	} else {
		gchar* _tmp63_ = NULL;
		_tmp63_ = g_strdup ("");
		result = _tmp63_;
		return result;
	}
}


gchar* countdown_serialize (Countdown* self) {
	gchar* result = NULL;
	gint serialized_time_counted = 0;
	gint64 _tmp0_ = 0LL;
	gint64 _tmp1_ = 0LL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	CountdownState _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gint64 _tmp6_ = 0LL;
	gchar* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gchar* _tmp13_ = NULL;
	gchar** _tmp14_ = NULL;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = util_get_real_time_seconds ();
	_tmp1_ = self->priv->start_time;
	serialized_time_counted = (gint) (_tmp0_ - _tmp1_);
	_tmp2_ = serialized_time_counted;
	_tmp3_ = MAX (0, _tmp2_);
	serialized_time_counted = _tmp3_;
	_tmp4_ = self->priv->state;
	_tmp5_ = g_strdup_printf ("%i", (gint) _tmp4_);
	_tmp6_ = self->priv->start_time;
	_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp6_);
	_tmp8_ = self->priv->stop_time_elapsed;
	_tmp9_ = g_strdup_printf ("%i", _tmp8_);
	_tmp10_ = self->priv->penalty;
	_tmp11_ = g_strdup_printf ("%i", _tmp10_);
	_tmp12_ = serialized_time_counted;
	_tmp13_ = g_strdup_printf ("%i", _tmp12_);
	_tmp14_ = g_new0 (gchar*, 5 + 1);
	_tmp14_[0] = _tmp5_;
	_tmp14_[1] = _tmp7_;
	_tmp14_[2] = _tmp9_;
	_tmp14_[3] = _tmp11_;
	_tmp14_[4] = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp15__length1 = 5;
	_tmp16_ = _vala_g_strjoinv (",", _tmp15_, 5);
	_tmp17_ = _tmp16_;
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
	result = _tmp17_;
	return result;
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	g_return_val_if_fail (str != NULL, 0LL);
	_tmp0_ = str;
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
	result = _tmp1_;
	return result;
}


void countdown_deserialize (Countdown* self, const gchar* data, gboolean persistent) {
	gchar** data_parts = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint data_parts_length1 = 0;
	gint _data_parts_size_ = 0;
	CountdownState serialized_state = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	CountdownState _tmp6_ = 0;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	const gchar* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	const gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gboolean _tmp13_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = data;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ",", 0);
	data_parts = _tmp2_;
	data_parts_length1 = _vala_array_length (_tmp1_);
	_data_parts_size_ = data_parts_length1;
	_tmp3_ = data_parts;
	_tmp3__length1 = data_parts_length1;
	_tmp4_ = _tmp3_[0];
	_tmp5_ = atoi (_tmp4_);
	serialized_state = (CountdownState) _tmp5_;
	_tmp6_ = serialized_state;
	switch (_tmp6_) {
		case COUNTDOWN_STATE_STOPPED:
		{
			countdown_reset (self);
			break;
		}
		case COUNTDOWN_STATE_PAUSED:
		{
			countdown_pause (self);
			break;
		}
		case COUNTDOWN_STATE_COUNTING:
		{
			countdown_start (self);
			break;
		}
		default:
		break;
	}
	_tmp7_ = data_parts;
	_tmp7__length1 = data_parts_length1;
	_tmp8_ = _tmp7_[2];
	_tmp9_ = atoi (_tmp8_);
	self->priv->stop_time_elapsed = _tmp9_;
	_tmp10_ = data_parts;
	_tmp10__length1 = data_parts_length1;
	_tmp11_ = _tmp10_[3];
	_tmp12_ = atoi (_tmp11_);
	self->priv->penalty = _tmp12_;
	_tmp13_ = persistent;
	if (_tmp13_) {
		gchar** _tmp14_ = NULL;
		gint _tmp14__length1 = 0;
		const gchar* _tmp15_ = NULL;
		gint64 _tmp16_ = 0LL;
		_tmp14_ = data_parts;
		_tmp14__length1 = data_parts_length1;
		_tmp15_ = _tmp14_[1];
		_tmp16_ = int64_parse (_tmp15_);
		self->priv->start_time = _tmp16_;
	} else {
		CountdownState _tmp17_ = 0;
		_tmp17_ = serialized_state;
		if (_tmp17_ == COUNTDOWN_STATE_COUNTING) {
			gint serialized_time_counted = 0;
			gchar** _tmp18_ = NULL;
			gint _tmp18__length1 = 0;
			const gchar* _tmp19_ = NULL;
			gint _tmp20_ = 0;
			gint _tmp21_ = 0;
			_tmp18_ = data_parts;
			_tmp18__length1 = data_parts_length1;
			_tmp19_ = _tmp18_[4];
			_tmp20_ = atoi (_tmp19_);
			serialized_time_counted = _tmp20_;
			_tmp21_ = serialized_time_counted;
			countdown_advance_time (self, _tmp21_);
		}
	}
	data_parts = (_vala_array_free (data_parts, data_parts_length1, (GDestroyNotify) g_free), NULL);
}


/**
 * Stop the countdown and forget its current position.
 * This is the same as calling Countdown.start (), except the countdown
 * will not advance.
 */
void countdown_reset (Countdown* self) {
	g_return_if_fail (self != NULL);
	self->priv->penalty = 0;
	self->priv->stop_time_elapsed = 0;
	self->priv->state = COUNTDOWN_STATE_STOPPED;
}


/**
 * Start counting down from the time set with set_base_duration.
 * This is the same as calling Countdown.stop () followed by
 * Countdown.continue ().
 */
void countdown_start (Countdown* self) {
	g_return_if_fail (self != NULL);
	countdown_start_from (self, 0);
}


/**
 * Start counting with the time offset by the given number of seconds.
 * Useful if the countdown should have started in the past.
 * @param start_offset the number of seconds to offset the start time,
 *                     where a negative value brings the countdown closer
 *                     to being finished.
 */
void countdown_start_from (Countdown* self, gint start_offset) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	countdown_reset (self);
	_tmp0_ = start_offset;
	countdown_continue_from (self, _tmp0_);
}


/**
 * Pause the countdown, keeping its current position.
 */
void countdown_pause (Countdown* self) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = countdown_get_time_elapsed (self);
	self->priv->stop_time_elapsed = _tmp0_;
	self->priv->state = COUNTDOWN_STATE_PAUSED;
}


/**
 * Start the countdown, continuing from the current position if
 * possible.
 */
void countdown_continue (Countdown* self) {
	CountdownState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state;
	if (_tmp0_ < COUNTDOWN_STATE_COUNTING) {
		countdown_continue_from (self, 0);
	}
}


/**
 * If not already counting, start counting with the time offset by the
 * given number of seconds. This is like start_from, but it never resets
 * the countdown.
 * @param start_offset the number of seconds to offset the start time,
 *                     where a negative value brings the countdown closer
 *                     to being finished.
 */
void countdown_continue_from (Countdown* self, gint start_offset) {
	CountdownState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state;
	if (_tmp0_ < COUNTDOWN_STATE_COUNTING) {
		gint64 now = 0LL;
		gint64 _tmp1_ = 0LL;
		gint64 _tmp2_ = 0LL;
		gint _tmp3_ = 0;
		_tmp1_ = util_get_real_time_seconds ();
		now = _tmp1_;
		_tmp2_ = now;
		_tmp3_ = start_offset;
		self->priv->start_time = _tmp2_ + _tmp3_;
		self->priv->state = COUNTDOWN_STATE_COUNTING;
	}
}


/**
 * If the countdown is paused, continue as if that never happened. This
 * has the effect of the countdown advancing by the time for which it was
 * paused.
 */
void countdown_cancel_pause (Countdown* self) {
	CountdownState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state;
	if (_tmp0_ == COUNTDOWN_STATE_PAUSED) {
		self->priv->stop_time_elapsed = 0;
		self->priv->state = COUNTDOWN_STATE_COUNTING;
	}
}


/**
 * Advance the countdown by the number of seconds, regardless of its
 * present state. If the countdown is currently paused, calling continue
 * will take into account the given offset.
 * @param seconds_off the number of seconds to advance the countdown,
 *                    where a positive value brings it closer to being
 *                    finished.
 */
void countdown_advance_time (Countdown* self, gint seconds_off) {
	gint64 now = 0LL;
	gint64 _tmp0_ = 0LL;
	CountdownState _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = util_get_real_time_seconds ();
	now = _tmp0_;
	_tmp1_ = self->priv->state;
	if (_tmp1_ == COUNTDOWN_STATE_COUNTING) {
		gint64 _tmp2_ = 0LL;
		gint _tmp3_ = 0;
		_tmp2_ = now;
		_tmp3_ = seconds_off;
		self->priv->start_time = _tmp2_ - _tmp3_;
	} else {
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		_tmp4_ = self->priv->stop_time_elapsed;
		_tmp5_ = seconds_off;
		self->priv->stop_time_elapsed = _tmp4_ + _tmp5_;
	}
}


/**
 * Sets a temporary time penalty. This increases the countdown's duration
 * until it is reset.
 * @param penalty the number of seconds extra the countdown will last.
 */
void countdown_set_penalty (Countdown* self, gint penalty) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = penalty;
	self->priv->penalty = _tmp0_;
}


/**
 * @return the current time penalty for the countdown.
 * @see set_penalty
 */
gint countdown_get_penalty (Countdown* self) {
	gint result = 0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->penalty;
	result = _tmp0_;
	return result;
}


/**
 * @return true if the countdown is currently counting, or false if it is
 *         either stopped or paused.
 */
gboolean countdown_is_counting (Countdown* self) {
	gboolean result = FALSE;
	CountdownState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->state;
	result = _tmp0_ == COUNTDOWN_STATE_COUNTING;
	return result;
}


/**
 * Sets the base duration for the countdown. This is how long the
 * countdown will last from when it is freshly started.
 * 
 * The base duration can be changed while the countdown is counting. The
 * elapsed time will not change, while the remaining time will increase or
 * decrease based on that elapsed time, the new base duration, and the
 * current penalty.
 * 
 * @param base_duration the new base duration for the countdown
 */
void countdown_set_base_duration (Countdown* self, gint base_duration) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = base_duration;
	self->priv->base_duration = _tmp0_;
}


/**
 * Returns the current duration for the countdown. This is not the same as
 * the base duration: it takes into account the penalty, as well. The
 * return value will change as the time penalty changes.
 * @return the countdown's duration
 */
gint countdown_get_duration (Countdown* self) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->base_duration;
	_tmp1_ = self->priv->penalty;
	_tmp2_ = MAX (0, _tmp0_ + _tmp1_);
	result = _tmp2_;
	return result;
}


/**
 * Returns the amount of time that the countdown has been counting, if at
 * all. If the countdown is paused, this will return the elapsed time from
 * the point when it was paused.
 * @return the countdown's current elapsed time, or 0
 */
gint countdown_get_time_elapsed (Countdown* self) {
	gint result = 0;
	gint time_elapsed = 0;
	gint _tmp0_ = 0;
	CountdownState _tmp1_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->stop_time_elapsed;
	time_elapsed = _tmp0_;
	_tmp1_ = self->priv->state;
	if (_tmp1_ == COUNTDOWN_STATE_COUNTING) {
		gint64 now = 0LL;
		gint64 _tmp2_ = 0LL;
		gint _tmp3_ = 0;
		gint64 _tmp4_ = 0LL;
		gint64 _tmp5_ = 0LL;
		_tmp2_ = util_get_real_time_seconds ();
		now = _tmp2_;
		_tmp3_ = time_elapsed;
		_tmp4_ = now;
		_tmp5_ = self->priv->start_time;
		time_elapsed = _tmp3_ + ((gint) (_tmp4_ - _tmp5_));
	}
	_tmp6_ = time_elapsed;
	_tmp7_ = MAX (0, _tmp6_);
	result = _tmp7_;
	return result;
}


/**
 * Returns the time remaining until the countdown will be finished, or 0
 * if the countdown is already finished. If the countdown is not counting,
 * this will return its current duration.
 * @return the time the countdown needs to count until it is finished
 */
gint countdown_get_time_remaining (Countdown* self) {
	gint result = 0;
	gint time_remaining = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = countdown_get_duration (self);
	_tmp1_ = countdown_get_time_elapsed (self);
	time_remaining = _tmp0_ - _tmp1_;
	_tmp2_ = MAX (0, time_remaining);
	result = _tmp2_;
	return result;
}


/**
 * Returns true if the countdown is finished; if its elapsed time meets or
 * exceeds its duration. This is equivalent to checking if the remaining
 * time is 0.
 * @return true if the countdown is finished.
 */
gboolean countdown_is_finished (Countdown* self) {
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = countdown_get_time_remaining (self);
	result = _tmp0_ == 0;
	return result;
}


static void countdown_class_init (CountdownClass * klass) {
	countdown_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CountdownPrivate));
	G_OBJECT_CLASS (klass)->finalize = countdown_finalize;
}


static void countdown_instance_init (Countdown * self) {
	self->priv = COUNTDOWN_GET_PRIVATE (self);
}


static void countdown_finalize (GObject* obj) {
	Countdown * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COUNTDOWN, Countdown);
	G_OBJECT_CLASS (countdown_parent_class)->finalize (obj);
}


/**
 * A countdown timer that counts seconds from a start time down to 0. Uses
 * "wall-clock" time instead of monotonic time, so it will count regardless
 * of system state. The countdown can be paused, and its duration can be
 * adjusted at any time using penalty and bonus time.
 */
GType countdown_get_type (void) {
	static volatile gsize countdown_type_id__volatile = 0;
	if (g_once_init_enter (&countdown_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CountdownClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) countdown_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Countdown), 0, (GInstanceInitFunc) countdown_instance_init, NULL };
		GType countdown_type_id;
		countdown_type_id = g_type_register_static (G_TYPE_OBJECT, "Countdown", &g_define_type_info, 0);
		g_once_init_leave (&countdown_type_id__volatile, countdown_type_id);
	}
	return countdown_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



