/* SimpleFocusManager.c generated by valac 0.32.1, the Vala compiler
 * generated from SimpleFocusManager.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>


#define TYPE_IFOCUSABLE (ifocusable_get_type ())
#define IFOCUSABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IFOCUSABLE, IFocusable))
#define IS_IFOCUSABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IFOCUSABLE))
#define IFOCUSABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_IFOCUSABLE, IFocusableIface))

typedef struct _IFocusable IFocusable;
typedef struct _IFocusableIface IFocusableIface;

#define TYPE_FOCUS_PRIORITY (focus_priority_get_type ())

#define TYPE_SIMPLE_FOCUS_MANAGER (simple_focus_manager_get_type ())
#define SIMPLE_FOCUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SIMPLE_FOCUS_MANAGER, SimpleFocusManager))
#define SIMPLE_FOCUS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SIMPLE_FOCUS_MANAGER, SimpleFocusManagerClass))
#define IS_SIMPLE_FOCUS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SIMPLE_FOCUS_MANAGER))
#define IS_SIMPLE_FOCUS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SIMPLE_FOCUS_MANAGER))
#define SIMPLE_FOCUS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SIMPLE_FOCUS_MANAGER, SimpleFocusManagerClass))

typedef struct _SimpleFocusManager SimpleFocusManager;
typedef struct _SimpleFocusManagerClass SimpleFocusManagerClass;
typedef struct _SimpleFocusManagerPrivate SimpleFocusManagerPrivate;

#define SIMPLE_FOCUS_MANAGER_TYPE_REQUEST (simple_focus_manager_request_get_type ())
#define SIMPLE_FOCUS_MANAGER_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIMPLE_FOCUS_MANAGER_TYPE_REQUEST, SimpleFocusManagerRequest))
#define SIMPLE_FOCUS_MANAGER_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIMPLE_FOCUS_MANAGER_TYPE_REQUEST, SimpleFocusManagerRequestClass))
#define SIMPLE_FOCUS_MANAGER_IS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIMPLE_FOCUS_MANAGER_TYPE_REQUEST))
#define SIMPLE_FOCUS_MANAGER_IS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIMPLE_FOCUS_MANAGER_TYPE_REQUEST))
#define SIMPLE_FOCUS_MANAGER_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIMPLE_FOCUS_MANAGER_TYPE_REQUEST, SimpleFocusManagerRequestClass))

typedef struct _SimpleFocusManagerRequest SimpleFocusManagerRequest;
typedef struct _SimpleFocusManagerRequestClass SimpleFocusManagerRequestClass;
#define __g_slist_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_object_unref0_ (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SimpleFocusManagerRequestPrivate SimpleFocusManagerRequestPrivate;

struct _IFocusableIface {
	GTypeInterface parent_iface;
	void (*focus_started) (IFocusable* self);
	void (*focus_stopped) (IFocusable* self);
};

typedef enum  {
	FOCUS_PRIORITY_NONE,
	FOCUS_PRIORITY_LOW,
	FOCUS_PRIORITY_HIGH
} FocusPriority;

struct _SimpleFocusManager {
	GObject parent_instance;
	SimpleFocusManagerPrivate * priv;
};

struct _SimpleFocusManagerClass {
	GObjectClass parent_class;
};

struct _SimpleFocusManagerPrivate {
	GSList* focus_requests;
	SimpleFocusManagerRequest* current_focus;
};

struct _SimpleFocusManagerRequest {
	GObject parent_instance;
	SimpleFocusManagerRequestPrivate * priv;
	IFocusable* owner;
	FocusPriority priority;
};

struct _SimpleFocusManagerRequestClass {
	GObjectClass parent_class;
};


static gpointer simple_focus_manager_parent_class = NULL;
static gpointer simple_focus_manager_request_parent_class = NULL;

GType ifocusable_get_type (void) G_GNUC_CONST;
void ifocusable_focus_started (IFocusable* self);
void ifocusable_focus_stopped (IFocusable* self);
GType focus_priority_get_type (void) G_GNUC_CONST;
GType simple_focus_manager_get_type (void) G_GNUC_CONST;
static GType simple_focus_manager_request_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define SIMPLE_FOCUS_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SIMPLE_FOCUS_MANAGER, SimpleFocusManagerPrivate))
enum  {
	SIMPLE_FOCUS_MANAGER_DUMMY_PROPERTY
};
static void _g_object_unref0_ (gpointer var);
static void _g_slist_free__g_object_unref0_ (GSList* self);
SimpleFocusManager* simple_focus_manager_new (void);
SimpleFocusManager* simple_focus_manager_construct (GType object_type);
static void simple_focus_manager_set_focus (SimpleFocusManager* self, SimpleFocusManagerRequest* new_focus);
static void simple_focus_manager_update_focus (SimpleFocusManager* self);
static gboolean simple_focus_manager_focus_requested (SimpleFocusManager* self, IFocusable* focusable);
void simple_focus_manager_request_focus (SimpleFocusManager* self, IFocusable* focusable, FocusPriority priority);
static SimpleFocusManagerRequest* simple_focus_manager_request_new (void);
static SimpleFocusManagerRequest* simple_focus_manager_request_construct (GType object_type);
static gint simple_focus_manager_request_priority_compare_func (SimpleFocusManagerRequest* a, SimpleFocusManagerRequest* b);
static gint _simple_focus_manager_request_priority_compare_func_gcompare_func (gconstpointer a, gconstpointer b);
void simple_focus_manager_release_focus (SimpleFocusManager* self, IFocusable* focusable);
gboolean simple_focus_manager_is_focusing (SimpleFocusManager* self, IFocusable* focusable);
enum  {
	SIMPLE_FOCUS_MANAGER_REQUEST_DUMMY_PROPERTY
};
static void simple_focus_manager_request_finalize (GObject* obj);
static void simple_focus_manager_finalize (GObject* obj);


void ifocusable_focus_started (IFocusable* self) {
	g_return_if_fail (self != NULL);
	IFOCUSABLE_GET_INTERFACE (self)->focus_started (self);
}


void ifocusable_focus_stopped (IFocusable* self) {
	g_return_if_fail (self != NULL);
	IFOCUSABLE_GET_INTERFACE (self)->focus_stopped (self);
}


static void ifocusable_base_init (IFocusableIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType ifocusable_get_type (void) {
	static volatile gsize ifocusable_type_id__volatile = 0;
	if (g_once_init_enter (&ifocusable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IFocusableIface), (GBaseInitFunc) ifocusable_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType ifocusable_type_id;
		ifocusable_type_id = g_type_register_static (G_TYPE_INTERFACE, "IFocusable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (ifocusable_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&ifocusable_type_id__volatile, ifocusable_type_id);
	}
	return ifocusable_type_id__volatile;
}


GType focus_priority_get_type (void) {
	static volatile gsize focus_priority_type_id__volatile = 0;
	if (g_once_init_enter (&focus_priority_type_id__volatile)) {
		static const GEnumValue values[] = {{FOCUS_PRIORITY_NONE, "FOCUS_PRIORITY_NONE", "none"}, {FOCUS_PRIORITY_LOW, "FOCUS_PRIORITY_LOW", "low"}, {FOCUS_PRIORITY_HIGH, "FOCUS_PRIORITY_HIGH", "high"}, {0, NULL, NULL}};
		GType focus_priority_type_id;
		focus_priority_type_id = g_enum_register_static ("FocusPriority", values);
		g_once_init_leave (&focus_priority_type_id__volatile, focus_priority_type_id);
	}
	return focus_priority_type_id__volatile;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_slist_free__g_object_unref0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_slist_free (self);
}


SimpleFocusManager* simple_focus_manager_construct (GType object_type) {
	SimpleFocusManager * self = NULL;
	self = (SimpleFocusManager*) g_object_new (object_type, NULL);
	__g_slist_free__g_object_unref0_0 (self->priv->focus_requests);
	self->priv->focus_requests = NULL;
	_g_object_unref0 (self->priv->current_focus);
	self->priv->current_focus = NULL;
	return self;
}


SimpleFocusManager* simple_focus_manager_new (void) {
	return simple_focus_manager_construct (TYPE_SIMPLE_FOCUS_MANAGER);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void simple_focus_manager_set_focus (SimpleFocusManager* self, SimpleFocusManagerRequest* new_focus) {
	SimpleFocusManagerRequest* old_focus = NULL;
	SimpleFocusManagerRequest* _tmp0_ = NULL;
	SimpleFocusManagerRequest* _tmp1_ = NULL;
	SimpleFocusManagerRequest* _tmp2_ = NULL;
	SimpleFocusManagerRequest* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->current_focus;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	old_focus = _tmp1_;
	_tmp2_ = new_focus;
	_tmp3_ = old_focus;
	if (_tmp2_ != _tmp3_) {
		SimpleFocusManagerRequest* _tmp4_ = NULL;
		SimpleFocusManagerRequest* _tmp5_ = NULL;
		SimpleFocusManagerRequest* _tmp6_ = NULL;
		SimpleFocusManagerRequest* _tmp9_ = NULL;
		_tmp4_ = new_focus;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_g_object_unref0 (self->priv->current_focus);
		self->priv->current_focus = _tmp5_;
		_tmp6_ = new_focus;
		if (_tmp6_ != NULL) {
			SimpleFocusManagerRequest* _tmp7_ = NULL;
			IFocusable* _tmp8_ = NULL;
			_tmp7_ = new_focus;
			_tmp8_ = _tmp7_->owner;
			ifocusable_focus_started (_tmp8_);
		}
		_tmp9_ = old_focus;
		if (_tmp9_ != NULL) {
			SimpleFocusManagerRequest* _tmp10_ = NULL;
			IFocusable* _tmp11_ = NULL;
			_tmp10_ = old_focus;
			_tmp11_ = _tmp10_->owner;
			ifocusable_focus_stopped (_tmp11_);
		}
	}
	_g_object_unref0 (old_focus);
}


static void simple_focus_manager_update_focus (SimpleFocusManager* self) {
	SimpleFocusManagerRequest* new_focus = NULL;
	GSList* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	SimpleFocusManagerRequest* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	new_focus = NULL;
	_tmp0_ = self->priv->focus_requests;
	_tmp1_ = g_slist_length (_tmp0_);
	if (_tmp1_ > ((guint) 0)) {
		GSList* _tmp2_ = NULL;
		GSList* _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		SimpleFocusManagerRequest* _tmp5_ = NULL;
		_tmp2_ = self->priv->focus_requests;
		_tmp3_ = g_slist_last (_tmp2_);
		_tmp4_ = _tmp3_->data;
		_tmp5_ = _g_object_ref0 ((SimpleFocusManagerRequest*) _tmp4_);
		_g_object_unref0 (new_focus);
		new_focus = _tmp5_;
	}
	_tmp6_ = new_focus;
	simple_focus_manager_set_focus (self, _tmp6_);
	_g_object_unref0 (new_focus);
}


static gboolean simple_focus_manager_focus_requested (SimpleFocusManager* self, IFocusable* focusable) {
	gboolean result = FALSE;
	GSList* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (focusable != NULL, FALSE);
	_tmp0_ = self->priv->focus_requests;
	{
		GSList* request_collection = NULL;
		GSList* request_it = NULL;
		request_collection = _tmp0_;
		for (request_it = request_collection; request_it != NULL; request_it = request_it->next) {
			SimpleFocusManagerRequest* _tmp1_ = NULL;
			SimpleFocusManagerRequest* request = NULL;
			_tmp1_ = _g_object_ref0 ((SimpleFocusManagerRequest*) request_it->data);
			request = _tmp1_;
			{
				SimpleFocusManagerRequest* _tmp2_ = NULL;
				IFocusable* _tmp3_ = NULL;
				IFocusable* _tmp4_ = NULL;
				_tmp2_ = request;
				_tmp3_ = _tmp2_->owner;
				_tmp4_ = focusable;
				if (_tmp3_ == _tmp4_) {
					result = TRUE;
					_g_object_unref0 (request);
					return result;
				}
				_g_object_unref0 (request);
			}
		}
	}
	result = FALSE;
	return result;
}


static gint _simple_focus_manager_request_priority_compare_func_gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = simple_focus_manager_request_priority_compare_func ((SimpleFocusManagerRequest*) a, (SimpleFocusManagerRequest*) b);
	return result;
}


void simple_focus_manager_request_focus (SimpleFocusManager* self, IFocusable* focusable, FocusPriority priority) {
	IFocusable* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (focusable != NULL);
	_tmp0_ = focusable;
	_tmp1_ = simple_focus_manager_focus_requested (self, _tmp0_);
	if (!_tmp1_) {
		SimpleFocusManagerRequest* request = NULL;
		SimpleFocusManagerRequest* _tmp2_ = NULL;
		SimpleFocusManagerRequest* _tmp3_ = NULL;
		IFocusable* _tmp4_ = NULL;
		IFocusable* _tmp5_ = NULL;
		SimpleFocusManagerRequest* _tmp6_ = NULL;
		FocusPriority _tmp7_ = 0;
		SimpleFocusManagerRequest* _tmp8_ = NULL;
		SimpleFocusManagerRequest* _tmp9_ = NULL;
		_tmp2_ = simple_focus_manager_request_new ();
		request = _tmp2_;
		_tmp3_ = request;
		_tmp4_ = focusable;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_g_object_unref0 (_tmp3_->owner);
		_tmp3_->owner = _tmp5_;
		_tmp6_ = request;
		_tmp7_ = priority;
		_tmp6_->priority = _tmp7_;
		_tmp8_ = request;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		self->priv->focus_requests = g_slist_insert_sorted (self->priv->focus_requests, _tmp9_, _simple_focus_manager_request_priority_compare_func_gcompare_func);
		simple_focus_manager_update_focus (self);
		_g_object_unref0 (request);
	}
}


void simple_focus_manager_release_focus (SimpleFocusManager* self, IFocusable* focusable) {
	GSList* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (focusable != NULL);
	_tmp0_ = self->priv->focus_requests;
	{
		GSList* request_collection = NULL;
		GSList* request_it = NULL;
		request_collection = _tmp0_;
		for (request_it = request_collection; request_it != NULL; request_it = request_it->next) {
			SimpleFocusManagerRequest* _tmp1_ = NULL;
			SimpleFocusManagerRequest* request = NULL;
			_tmp1_ = _g_object_ref0 ((SimpleFocusManagerRequest*) request_it->data);
			request = _tmp1_;
			{
				SimpleFocusManagerRequest* _tmp2_ = NULL;
				IFocusable* _tmp3_ = NULL;
				IFocusable* _tmp4_ = NULL;
				_tmp2_ = request;
				_tmp3_ = _tmp2_->owner;
				_tmp4_ = focusable;
				if (_tmp3_ == _tmp4_) {
					SimpleFocusManagerRequest* _tmp5_ = NULL;
					_tmp5_ = request;
					self->priv->focus_requests = g_slist_remove (self->priv->focus_requests, _tmp5_);
				}
				_g_object_unref0 (request);
			}
		}
	}
	simple_focus_manager_update_focus (self);
}


gboolean simple_focus_manager_is_focusing (SimpleFocusManager* self, IFocusable* focusable) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	SimpleFocusManagerRequest* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (focusable != NULL, FALSE);
	_tmp1_ = self->priv->current_focus;
	if (_tmp1_ != NULL) {
		SimpleFocusManagerRequest* _tmp2_ = NULL;
		IFocusable* _tmp3_ = NULL;
		IFocusable* _tmp4_ = NULL;
		_tmp2_ = self->priv->current_focus;
		_tmp3_ = _tmp2_->owner;
		_tmp4_ = focusable;
		_tmp0_ = _tmp3_ == _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


static gint simple_focus_manager_request_priority_compare_func (SimpleFocusManagerRequest* a, SimpleFocusManagerRequest* b) {
	gint result = 0;
	SimpleFocusManagerRequest* _tmp0_ = NULL;
	FocusPriority _tmp1_ = 0;
	SimpleFocusManagerRequest* _tmp2_ = NULL;
	FocusPriority _tmp3_ = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = a;
	_tmp1_ = _tmp0_->priority;
	_tmp2_ = b;
	_tmp3_ = _tmp2_->priority;
	if (_tmp1_ < _tmp3_) {
		result = -1;
		return result;
	} else {
		SimpleFocusManagerRequest* _tmp4_ = NULL;
		FocusPriority _tmp5_ = 0;
		SimpleFocusManagerRequest* _tmp6_ = NULL;
		FocusPriority _tmp7_ = 0;
		_tmp4_ = a;
		_tmp5_ = _tmp4_->priority;
		_tmp6_ = b;
		_tmp7_ = _tmp6_->priority;
		if (_tmp5_ == _tmp7_) {
			result = 0;
			return result;
		} else {
			result = 1;
			return result;
		}
	}
}


static SimpleFocusManagerRequest* simple_focus_manager_request_construct (GType object_type) {
	SimpleFocusManagerRequest * self = NULL;
	self = (SimpleFocusManagerRequest*) g_object_new (object_type, NULL);
	return self;
}


static SimpleFocusManagerRequest* simple_focus_manager_request_new (void) {
	return simple_focus_manager_request_construct (SIMPLE_FOCUS_MANAGER_TYPE_REQUEST);
}


static void simple_focus_manager_request_class_init (SimpleFocusManagerRequestClass * klass) {
	simple_focus_manager_request_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = simple_focus_manager_request_finalize;
}


static void simple_focus_manager_request_instance_init (SimpleFocusManagerRequest * self) {
}


static void simple_focus_manager_request_finalize (GObject* obj) {
	SimpleFocusManagerRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIMPLE_FOCUS_MANAGER_TYPE_REQUEST, SimpleFocusManagerRequest);
	_g_object_unref0 (self->owner);
	G_OBJECT_CLASS (simple_focus_manager_request_parent_class)->finalize (obj);
}


static GType simple_focus_manager_request_get_type (void) {
	static volatile gsize simple_focus_manager_request_type_id__volatile = 0;
	if (g_once_init_enter (&simple_focus_manager_request_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SimpleFocusManagerRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) simple_focus_manager_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SimpleFocusManagerRequest), 0, (GInstanceInitFunc) simple_focus_manager_request_instance_init, NULL };
		GType simple_focus_manager_request_type_id;
		simple_focus_manager_request_type_id = g_type_register_static (G_TYPE_OBJECT, "SimpleFocusManagerRequest", &g_define_type_info, 0);
		g_once_init_leave (&simple_focus_manager_request_type_id__volatile, simple_focus_manager_request_type_id);
	}
	return simple_focus_manager_request_type_id__volatile;
}


static void simple_focus_manager_class_init (SimpleFocusManagerClass * klass) {
	simple_focus_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SimpleFocusManagerPrivate));
	G_OBJECT_CLASS (klass)->finalize = simple_focus_manager_finalize;
}


static void simple_focus_manager_instance_init (SimpleFocusManager * self) {
	self->priv = SIMPLE_FOCUS_MANAGER_GET_PRIVATE (self);
}


static void simple_focus_manager_finalize (GObject* obj) {
	SimpleFocusManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SIMPLE_FOCUS_MANAGER, SimpleFocusManager);
	__g_slist_free__g_object_unref0_0 (self->priv->focus_requests);
	_g_object_unref0 (self->priv->current_focus);
	G_OBJECT_CLASS (simple_focus_manager_parent_class)->finalize (obj);
}


/**
 * Keeps track of focus requests, ensuring that only a single Focusable object
 * will have focus at a given time. Any object that implements the IFocusable
 * interface may request focus, and the most recent request with the highest
 * priority will be given focus. Focus can change at any time as other objects
 * request or release focus.
 */
GType simple_focus_manager_get_type (void) {
	static volatile gsize simple_focus_manager_type_id__volatile = 0;
	if (g_once_init_enter (&simple_focus_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SimpleFocusManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) simple_focus_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SimpleFocusManager), 0, (GInstanceInitFunc) simple_focus_manager_instance_init, NULL };
		GType simple_focus_manager_type_id;
		simple_focus_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SimpleFocusManager", &g_define_type_info, 0);
		g_once_init_leave (&simple_focus_manager_type_id__volatile, simple_focus_manager_type_id);
	}
	return simple_focus_manager_type_id__volatile;
}



