/* StatefulTimer.c generated by valac 0.32.1, the Vala compiler
 * generated from StatefulTimer.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_STATEFUL_TIMER (stateful_timer_get_type ())
#define STATEFUL_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STATEFUL_TIMER, StatefulTimer))
#define STATEFUL_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STATEFUL_TIMER, StatefulTimerClass))
#define IS_STATEFUL_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STATEFUL_TIMER))
#define IS_STATEFUL_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STATEFUL_TIMER))
#define STATEFUL_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STATEFUL_TIMER, StatefulTimerClass))

typedef struct _StatefulTimer StatefulTimer;
typedef struct _StatefulTimerClass StatefulTimerClass;
typedef struct _StatefulTimerPrivate StatefulTimerPrivate;

#define STATEFUL_TIMER_TYPE_STATE (stateful_timer_state_get_type ())
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))

struct _StatefulTimer {
	GObject parent_instance;
	StatefulTimerPrivate * priv;
};

struct _StatefulTimerClass {
	GObjectClass parent_class;
};

typedef enum  {
	STATEFUL_TIMER_STATE_STOPPED,
	STATEFUL_TIMER_STATE_COUNTING
} StatefulTimerState;

struct _StatefulTimerPrivate {
	StatefulTimerState _state;
	GTimer* timer;
	gdouble timer_error;
	gdouble lap_start;
};


static gpointer stateful_timer_parent_class = NULL;

GType stateful_timer_get_type (void) G_GNUC_CONST;
GType stateful_timer_state_get_type (void) G_GNUC_CONST;
#define STATEFUL_TIMER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STATEFUL_TIMER, StatefulTimerPrivate))
enum  {
	STATEFUL_TIMER_DUMMY_PROPERTY,
	STATEFUL_TIMER_STATE
};
StatefulTimer* stateful_timer_new (void);
StatefulTimer* stateful_timer_construct (GType object_type);
static void stateful_timer_set_state (StatefulTimer* self, StatefulTimerState value);
gchar* stateful_timer_serialize (StatefulTimer* self);
StatefulTimerState stateful_timer_get_state (StatefulTimer* self);
gdouble stateful_timer_elapsed (StatefulTimer* self);
void stateful_timer_deserialize (StatefulTimer* self, const gchar* data);
void stateful_timer_stop (StatefulTimer* self);
void stateful_timer_start (StatefulTimer* self);
gboolean stateful_timer_is_stopped (StatefulTimer* self);
gboolean stateful_timer_is_counting (StatefulTimer* self);
void stateful_timer_continue (StatefulTimer* self);
void stateful_timer_reset (StatefulTimer* self);
void stateful_timer_start_lap (StatefulTimer* self);
gdouble stateful_timer_lap_time (StatefulTimer* self);
void stateful_timer_freeze (StatefulTimer* self);
static void stateful_timer_finalize (GObject* obj);
static void _vala_stateful_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_stateful_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType stateful_timer_state_get_type (void) {
	static volatile gsize stateful_timer_state_type_id__volatile = 0;
	if (g_once_init_enter (&stateful_timer_state_type_id__volatile)) {
		static const GEnumValue values[] = {{STATEFUL_TIMER_STATE_STOPPED, "STATEFUL_TIMER_STATE_STOPPED", "stopped"}, {STATEFUL_TIMER_STATE_COUNTING, "STATEFUL_TIMER_STATE_COUNTING", "counting"}, {0, NULL, NULL}};
		GType stateful_timer_state_type_id;
		stateful_timer_state_type_id = g_enum_register_static ("StatefulTimerState", values);
		g_once_init_leave (&stateful_timer_state_type_id__volatile, stateful_timer_state_type_id);
	}
	return stateful_timer_state_type_id__volatile;
}


StatefulTimer* stateful_timer_construct (GType object_type) {
	StatefulTimer * self = NULL;
	GTimer* _tmp0_ = NULL;
	self = (StatefulTimer*) g_object_new (object_type, NULL);
	_tmp0_ = g_timer_new ();
	_g_timer_destroy0 (self->priv->timer);
	self->priv->timer = _tmp0_;
	stateful_timer_set_state (self, STATEFUL_TIMER_STATE_COUNTING);
	return self;
}


StatefulTimer* stateful_timer_new (void) {
	return stateful_timer_construct (TYPE_STATEFUL_TIMER);
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	_tmp0_ = separator;
	if (_tmp0_ == NULL) {
		separator = "";
	}
	_tmp3_ = str_array;
	_tmp3__length1 = str_array_length1;
	if (_tmp3_ != NULL) {
		_tmp2_ = TRUE;
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp4_ = str_array;
		_tmp4__length1 = str_array_length1;
		_tmp2_ = _tmp4__length1 > 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		_tmp6_ = str_array;
		_tmp6__length1 = str_array_length1;
		if (_tmp6__length1 == -1) {
			gchar** _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			const gchar* _tmp8_ = NULL;
			_tmp7_ = str_array;
			_tmp7__length1 = str_array_length1;
			_tmp8_ = _tmp7_[0];
			_tmp5_ = _tmp8_ != NULL;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp1_ = _tmp5_;
	}
	if (_tmp1_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gsize _tmp35_ = 0UL;
		const gchar* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		const gchar* res = NULL;
		gsize _tmp40_ = 0UL;
		void* _tmp41_ = NULL;
		void* ptr = NULL;
		const gchar* _tmp42_ = NULL;
		gchar** _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		const gchar* _tmp44_ = NULL;
		void* _tmp45_ = NULL;
		const gchar* _tmp62_ = NULL;
		len = (gsize) 1;
		{
			gboolean _tmp9_ = FALSE;
			i = 0;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp21_ = 0;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gsize _tmp30_ = 0UL;
				if (!_tmp9_) {
					gint _tmp10_ = 0;
					_tmp10_ = i;
					i = _tmp10_ + 1;
				}
				_tmp9_ = FALSE;
				_tmp13_ = str_array;
				_tmp13__length1 = str_array_length1;
				if (_tmp13__length1 != -1) {
					gint _tmp14_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
					_tmp14_ = i;
					_tmp15_ = str_array;
					_tmp15__length1 = str_array_length1;
					_tmp12_ = _tmp14_ < _tmp15__length1;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					_tmp11_ = TRUE;
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
					_tmp17_ = str_array;
					_tmp17__length1 = str_array_length1;
					if (_tmp17__length1 == -1) {
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
						_tmp18_ = str_array;
						_tmp18__length1 = str_array_length1;
						_tmp19_ = i;
						_tmp20_ = _tmp18_[_tmp19_];
						_tmp16_ = _tmp20_ != NULL;
					} else {
						_tmp16_ = FALSE;
					}
					_tmp11_ = _tmp16_;
				}
				if (!_tmp11_) {
					break;
				}
				_tmp22_ = str_array;
				_tmp22__length1 = str_array_length1;
				_tmp23_ = i;
				_tmp24_ = _tmp22_[_tmp23_];
				if (_tmp24_ != NULL) {
					gchar** _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					gint _tmp29_ = 0;
					_tmp25_ = str_array;
					_tmp25__length1 = str_array_length1;
					_tmp26_ = i;
					_tmp27_ = _tmp25_[_tmp26_];
					_tmp28_ = strlen ((const gchar*) _tmp27_);
					_tmp29_ = _tmp28_;
					_tmp21_ = _tmp29_;
				} else {
					_tmp21_ = 0;
				}
				_tmp30_ = len;
				len = _tmp30_ + _tmp21_;
			}
		}
		_tmp31_ = i;
		if (_tmp31_ == 0) {
			gchar* _tmp32_ = NULL;
			_tmp32_ = g_strdup ("");
			result = _tmp32_;
			return result;
		}
		_tmp33_ = i;
		str_array_length1 = _tmp33_;
		_tmp34_ = str_array_length1;
		_tmp35_ = len;
		_tmp36_ = separator;
		_tmp37_ = strlen ((const gchar*) _tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = i;
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
		_tmp40_ = len;
		_tmp41_ = g_malloc (_tmp40_);
		res = _tmp41_;
		_tmp42_ = res;
		_tmp43_ = str_array;
		_tmp43__length1 = str_array_length1;
		_tmp44_ = _tmp43_[0];
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
		ptr = _tmp45_;
		{
			gboolean _tmp46_ = FALSE;
			i = 1;
			_tmp46_ = TRUE;
			while (TRUE) {
				gint _tmp48_ = 0;
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				void* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				void* _tmp52_ = NULL;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				const gchar* _tmp56_ = NULL;
				void* _tmp60_ = NULL;
				void* _tmp61_ = NULL;
				if (!_tmp46_) {
					gint _tmp47_ = 0;
					_tmp47_ = i;
					i = _tmp47_ + 1;
				}
				_tmp46_ = FALSE;
				_tmp48_ = i;
				_tmp49_ = str_array;
				_tmp49__length1 = str_array_length1;
				if (!(_tmp48_ < _tmp49__length1)) {
					break;
				}
				_tmp50_ = ptr;
				_tmp51_ = separator;
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
				ptr = _tmp52_;
				_tmp54_ = str_array;
				_tmp54__length1 = str_array_length1;
				_tmp55_ = i;
				_tmp56_ = _tmp54_[_tmp55_];
				if (_tmp56_ != NULL) {
					gchar** _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					const gchar* _tmp59_ = NULL;
					_tmp57_ = str_array;
					_tmp57__length1 = str_array_length1;
					_tmp58_ = i;
					_tmp59_ = _tmp57_[_tmp58_];
					_tmp53_ = (const gchar*) _tmp59_;
				} else {
					_tmp53_ = "";
				}
				_tmp60_ = ptr;
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
				ptr = _tmp61_;
			}
		}
		_tmp62_ = res;
		res = NULL;
		result = (gchar*) _tmp62_;
		return result;
	} else {
		gchar* _tmp63_ = NULL;
		_tmp63_ = g_strdup ("");
		result = _tmp63_;
		return result;
	}
}


static gchar* double_to_string (gdouble self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
	_tmp3_ = g_strdup (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	result = _tmp4_;
	return result;
}


gchar* stateful_timer_serialize (StatefulTimer* self) {
	gchar* result = NULL;
	StatefulTimerState _tmp0_ = 0;
	gchar* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gchar* _tmp3_ = NULL;
	gdouble _tmp4_ = 0.0;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_ = NULL;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_state;
	_tmp1_ = g_strdup_printf ("%i", (gint) _tmp0_);
	_tmp2_ = stateful_timer_elapsed (self);
	_tmp3_ = double_to_string (_tmp2_);
	_tmp4_ = self->priv->lap_start;
	_tmp5_ = double_to_string (_tmp4_);
	_tmp6_ = g_new0 (gchar*, 3 + 1);
	_tmp6_[0] = _tmp1_;
	_tmp6_[1] = _tmp3_;
	_tmp6_[2] = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp7__length1 = 3;
	_tmp8_ = _vala_g_strjoinv (",", _tmp7_, 3);
	_tmp9_ = _tmp8_;
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
	result = _tmp9_;
	return result;
}


static gdouble double_parse (const gchar* str) {
	gdouble result = 0.0;
	const gchar* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	_tmp0_ = str;
	_tmp1_ = g_ascii_strtod (_tmp0_, NULL);
	result = _tmp1_;
	return result;
}


void stateful_timer_deserialize (StatefulTimer* self, const gchar* data) {
	gchar** data_parts = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint data_parts_length1 = 0;
	gint _data_parts_size_ = 0;
	StatefulTimerState old_state = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gdouble old_elapsed = 0.0;
	gchar** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	const gchar* _tmp7_ = NULL;
	gdouble _tmp8_ = 0.0;
	gdouble old_lap_start = 0.0;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	const gchar* _tmp10_ = NULL;
	gdouble _tmp11_ = 0.0;
	StatefulTimerState _tmp12_ = 0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (data != NULL);
	_tmp0_ = data;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ",", 0);
	data_parts = _tmp2_;
	data_parts_length1 = _vala_array_length (_tmp1_);
	_data_parts_size_ = data_parts_length1;
	_tmp3_ = data_parts;
	_tmp3__length1 = data_parts_length1;
	_tmp4_ = _tmp3_[0];
	_tmp5_ = atoi (_tmp4_);
	old_state = (StatefulTimerState) _tmp5_;
	_tmp6_ = data_parts;
	_tmp6__length1 = data_parts_length1;
	_tmp7_ = _tmp6_[1];
	_tmp8_ = double_parse (_tmp7_);
	old_elapsed = _tmp8_;
	_tmp9_ = data_parts;
	_tmp9__length1 = data_parts_length1;
	_tmp10_ = _tmp9_[2];
	_tmp11_ = double_parse (_tmp10_);
	old_lap_start = _tmp11_;
	_tmp12_ = old_state;
	if (_tmp12_ == STATEFUL_TIMER_STATE_STOPPED) {
		stateful_timer_stop (self);
	} else {
		StatefulTimerState _tmp13_ = 0;
		_tmp13_ = old_state;
		if (_tmp13_ == STATEFUL_TIMER_STATE_COUNTING) {
			stateful_timer_start (self);
		}
	}
	_tmp14_ = stateful_timer_elapsed (self);
	_tmp15_ = old_elapsed;
	self->priv->timer_error = _tmp14_ - _tmp15_;
	_tmp16_ = old_lap_start;
	self->priv->lap_start = _tmp16_;
	data_parts = (_vala_array_free (data_parts, data_parts_length1, (GDestroyNotify) g_free), NULL);
}


inline gboolean stateful_timer_is_stopped (StatefulTimer* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = stateful_timer_is_counting (self);
	result = !_tmp0_;
	return result;
}


gboolean stateful_timer_is_counting (StatefulTimer* self) {
	gboolean result = FALSE;
	StatefulTimerState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_state;
	result = _tmp0_ == STATEFUL_TIMER_STATE_COUNTING;
	return result;
}


void stateful_timer_start (StatefulTimer* self) {
	GTimer* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timer;
	g_timer_start (_tmp0_);
	stateful_timer_set_state (self, STATEFUL_TIMER_STATE_COUNTING);
	self->priv->timer_error = (gdouble) 0;
	self->priv->lap_start = (gdouble) 0;
}


void stateful_timer_stop (StatefulTimer* self) {
	GTimer* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timer;
	g_timer_stop (_tmp0_);
	stateful_timer_set_state (self, STATEFUL_TIMER_STATE_STOPPED);
}


void stateful_timer_continue (StatefulTimer* self) {
	GTimer* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timer;
	g_timer_continue (_tmp0_);
	stateful_timer_set_state (self, STATEFUL_TIMER_STATE_COUNTING);
}


gdouble stateful_timer_elapsed (StatefulTimer* self) {
	gdouble result = 0.0;
	GTimer* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->timer;
	_tmp1_ = g_timer_elapsed (_tmp0_, NULL);
	_tmp2_ = self->priv->timer_error;
	result = _tmp1_ - _tmp2_;
	return result;
}


void stateful_timer_reset (StatefulTimer* self) {
	g_return_if_fail (self != NULL);
	stateful_timer_start (self);
}


/**
 * Starts counting a new lap, and continues the timer if it is not
 * already counting.
 */
void stateful_timer_start_lap (StatefulTimer* self) {
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = stateful_timer_is_stopped (self);
	if (_tmp0_) {
		stateful_timer_continue (self);
	}
	_tmp1_ = stateful_timer_elapsed (self);
	self->priv->lap_start = _tmp1_;
}


/**
 * Returns the time since the last lap was created, or the elapsed time if
 * no laps have been created.
 * @see start_lap
 */
gdouble stateful_timer_lap_time (StatefulTimer* self) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = stateful_timer_elapsed (self);
	_tmp1_ = self->priv->lap_start;
	result = _tmp0_ - _tmp1_;
	return result;
}


/**
 * Stops the timer, but does not advance the end time if if is already
 * stopped.
 */
void stateful_timer_freeze (StatefulTimer* self) {
	StatefulTimerState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_state;
	if (_tmp0_ > STATEFUL_TIMER_STATE_STOPPED) {
		stateful_timer_stop (self);
	}
}


StatefulTimerState stateful_timer_get_state (StatefulTimer* self) {
	StatefulTimerState result;
	StatefulTimerState _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_state;
	result = _tmp0_;
	return result;
}


static void stateful_timer_set_state (StatefulTimer* self, StatefulTimerState value) {
	StatefulTimerState _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_state = _tmp0_;
	g_object_notify ((GObject *) self, "state");
}


static void stateful_timer_class_init (StatefulTimerClass * klass) {
	stateful_timer_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StatefulTimerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_stateful_timer_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_stateful_timer_set_property;
	G_OBJECT_CLASS (klass)->finalize = stateful_timer_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STATEFUL_TIMER_STATE, g_param_spec_enum ("state", "state", "state", STATEFUL_TIMER_TYPE_STATE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void stateful_timer_instance_init (StatefulTimer * self) {
	self->priv = STATEFUL_TIMER_GET_PRIVATE (self);
}


static void stateful_timer_finalize (GObject* obj) {
	StatefulTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STATEFUL_TIMER, StatefulTimer);
	_g_timer_destroy0 (self->priv->timer);
	G_OBJECT_CLASS (stateful_timer_parent_class)->finalize (obj);
}


/**
 * A simple GTimer lookalike that keeps track of its own state.
 * This is implemented using the GTimer API, internally, so it behaves
 * exactly as described in the GTimer documentation, with two additions:
 *  - a state property to keep track of whether the timer is stopped.
 *  - a "lap" feature (start_lap, lap_time) to measure smaller time intervals
 */
GType stateful_timer_get_type (void) {
	static volatile gsize stateful_timer_type_id__volatile = 0;
	if (g_once_init_enter (&stateful_timer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StatefulTimerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) stateful_timer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StatefulTimer), 0, (GInstanceInitFunc) stateful_timer_instance_init, NULL };
		GType stateful_timer_type_id;
		stateful_timer_type_id = g_type_register_static (G_TYPE_OBJECT, "StatefulTimer", &g_define_type_info, 0);
		g_once_init_leave (&stateful_timer_type_id__volatile, stateful_timer_type_id);
	}
	return stateful_timer_type_id__volatile;
}


static void _vala_stateful_timer_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	StatefulTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STATEFUL_TIMER, StatefulTimer);
	switch (property_id) {
		case STATEFUL_TIMER_STATE:
		g_value_set_enum (value, stateful_timer_get_state (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_stateful_timer_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	StatefulTimer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STATEFUL_TIMER, StatefulTimer);
	switch (property_id) {
		case STATEFUL_TIMER_STATE:
		stateful_timer_set_state (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



