/* CircleCounter.c generated by valac 0.32.1, the Vala compiler
 * generated from CircleCounter.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */
/* TODO: Share code with gnome-clocks, instead of duplicating effort*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <gdk/gdk.h>


#define TYPE_CIRCLE_COUNTER (circle_counter_get_type ())
#define CIRCLE_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CIRCLE_COUNTER, CircleCounter))
#define CIRCLE_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CIRCLE_COUNTER, CircleCounterClass))
#define IS_CIRCLE_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CIRCLE_COUNTER))
#define IS_CIRCLE_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CIRCLE_COUNTER))
#define CIRCLE_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CIRCLE_COUNTER, CircleCounterClass))

typedef struct _CircleCounter CircleCounter;
typedef struct _CircleCounterClass CircleCounterClass;
typedef struct _CircleCounterPrivate CircleCounterPrivate;

#define CIRCLE_COUNTER_TYPE_DIRECTION (circle_counter_direction_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CircleCounter {
	GtkWidget parent_instance;
	CircleCounterPrivate * priv;
};

struct _CircleCounterClass {
	GtkWidgetClass parent_class;
};

typedef enum  {
	CIRCLE_COUNTER_DIRECTION_COUNT_DOWN,
	CIRCLE_COUNTER_DIRECTION_COUNT_UP
} CircleCounterDirection;

struct _CircleCounterPrivate {
	CircleCounterDirection _direction;
	gdouble _progress;
};


static gpointer circle_counter_parent_class = NULL;

GType circle_counter_get_type (void) G_GNUC_CONST;
GType circle_counter_direction_get_type (void) G_GNUC_CONST;
#define CIRCLE_COUNTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CIRCLE_COUNTER, CircleCounterPrivate))
enum  {
	CIRCLE_COUNTER_DUMMY_PROPERTY,
	CIRCLE_COUNTER_DIRECTION,
	CIRCLE_COUNTER_PROGRESS
};
#define CIRCLE_COUNTER_LINE_WIDTH 5.0
#define CIRCLE_COUNTER_DEFAULT_RADIUS 48
#define CIRCLE_COUNTER_SNAP_INCREMENT ((G_PI * 2) / 60.0)
CircleCounter* circle_counter_new (void);
CircleCounter* circle_counter_construct (GType object_type);
static void __lambda5_ (CircleCounter* self, GObject* s, GParamSpec* p);
static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static gboolean circle_counter_real_draw (GtkWidget* base, cairo_t* cr);
gdouble circle_counter_get_progress (CircleCounter* self);
CircleCounterDirection circle_counter_get_direction (CircleCounter* self);
static void circle_counter_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width);
static gint circle_counter_calculate_diameter (CircleCounter* self);
static void circle_counter_real_get_preferred_height (GtkWidget* base, gint* minimum_height, gint* natural_height);
static void circle_counter_real_size_allocate (GtkWidget* base, GtkAllocation* allocation);
void circle_counter_set_direction (CircleCounter* self, CircleCounterDirection value);
void circle_counter_set_progress (CircleCounter* self, gdouble value);
static void circle_counter_finalize (GObject* obj);
static void _vala_circle_counter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_circle_counter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType circle_counter_direction_get_type (void) {
	static volatile gsize circle_counter_direction_type_id__volatile = 0;
	if (g_once_init_enter (&circle_counter_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{CIRCLE_COUNTER_DIRECTION_COUNT_DOWN, "CIRCLE_COUNTER_DIRECTION_COUNT_DOWN", "count-down"}, {CIRCLE_COUNTER_DIRECTION_COUNT_UP, "CIRCLE_COUNTER_DIRECTION_COUNT_UP", "count-up"}, {0, NULL, NULL}};
		GType circle_counter_direction_type_id;
		circle_counter_direction_type_id = g_enum_register_static ("CircleCounterDirection", values);
		g_once_init_leave (&circle_counter_direction_type_id__volatile, circle_counter_direction_type_id);
	}
	return circle_counter_direction_type_id__volatile;
}


static void __lambda5_ (CircleCounter* self, GObject* s, GParamSpec* p) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda5_ ((CircleCounter*) self, _sender, pspec);
}


CircleCounter* circle_counter_construct (GType object_type) {
	CircleCounter * self = NULL;
	GtkStyleContext* _tmp0_ = NULL;
	self = (CircleCounter*) g_object_new (object_type, NULL);
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "_circle-counter");
	g_signal_connect_object ((GObject*) self, "notify::progress", (GCallback) ___lambda5__g_object_notify, self, 0);
	return self;
}


CircleCounter* circle_counter_new (void) {
	return circle_counter_construct (TYPE_CIRCLE_COUNTER);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gboolean circle_counter_real_draw (GtkWidget* base, cairo_t* cr) {
	CircleCounter * self;
	gboolean result = FALSE;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_ = NULL;
	GtkStyleContext* _tmp1_ = NULL;
	GtkStateFlags state = 0;
	GtkStateFlags _tmp2_ = 0;
	GtkAllocation allocation = {0};
	GtkAllocation _tmp3_ = {0};
	gint center_x = 0;
	GtkAllocation _tmp4_ = {0};
	gint _tmp5_ = 0;
	gint center_y = 0;
	GtkAllocation _tmp6_ = {0};
	gint _tmp7_ = 0;
	gint radius = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gdouble arc_radius = 0.0;
	gint _tmp11_ = 0;
	GdkRGBA trough_color = {0};
	GtkStyleContext* _tmp12_ = NULL;
	GtkStateFlags _tmp13_ = 0;
	GdkRGBA _tmp14_ = {0};
	GdkRGBA base_color = {0};
	GtkStyleContext* _tmp15_ = NULL;
	GtkStateFlags _tmp16_ = 0;
	GdkRGBA _tmp17_ = {0};
	cairo_t* _tmp18_ = NULL;
	GdkRGBA _tmp19_ = {0};
	cairo_t* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gdouble _tmp23_ = 0.0;
	cairo_t* _tmp24_ = NULL;
	cairo_t* _tmp25_ = NULL;
	gdouble start_angle = 0.0;
	gdouble progress_angle = 0.0;
	gdouble _tmp26_ = 0.0;
	gdouble _tmp27_ = 0.0;
	CircleCounterDirection _tmp28_ = 0;
	cairo_t* _tmp51_ = NULL;
	GdkRGBA _tmp52_ = {0};
	cairo_t* _tmp53_ = NULL;
	cairo_t* _tmp54_ = NULL;
	cairo_t* _tmp55_ = NULL;
	self = (CircleCounter*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	style_context = _tmp1_;
	_tmp2_ = gtk_widget_get_state_flags ((GtkWidget*) self);
	state = _tmp2_;
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp3_);
	allocation = _tmp3_;
	_tmp4_ = allocation;
	_tmp5_ = _tmp4_.width;
	center_x = _tmp5_ / 2;
	_tmp6_ = allocation;
	_tmp7_ = _tmp6_.height;
	center_y = _tmp7_ / 2;
	_tmp8_ = center_x;
	_tmp9_ = center_y;
	_tmp10_ = MIN (_tmp8_, _tmp9_);
	radius = _tmp10_;
	_tmp11_ = radius;
	arc_radius = _tmp11_ - (CIRCLE_COUNTER_LINE_WIDTH / 2);
	_tmp12_ = style_context;
	_tmp13_ = state;
	gtk_style_context_get_background_color (_tmp12_, _tmp13_, &_tmp14_);
	trough_color = _tmp14_;
	_tmp15_ = style_context;
	_tmp16_ = state;
	gtk_style_context_get_color (_tmp15_, _tmp16_, &_tmp17_);
	base_color = _tmp17_;
	_tmp18_ = cr;
	_tmp19_ = trough_color;
	gdk_cairo_set_source_rgba (_tmp18_, &_tmp19_);
	_tmp20_ = cr;
	_tmp21_ = center_x;
	_tmp22_ = center_y;
	_tmp23_ = arc_radius;
	cairo_arc (_tmp20_, (gdouble) _tmp21_, (gdouble) _tmp22_, _tmp23_, (gdouble) 0, G_PI * 2.0);
	_tmp24_ = cr;
	cairo_set_line_width (_tmp24_, CIRCLE_COUNTER_LINE_WIDTH);
	_tmp25_ = cr;
	cairo_stroke (_tmp25_);
	start_angle = 1.5 * G_PI;
	_tmp26_ = self->priv->_progress;
	progress_angle = (_tmp26_ * G_PI) * 2.0;
	_tmp27_ = progress_angle;
	progress_angle = ((gint) (_tmp27_ / CIRCLE_COUNTER_SNAP_INCREMENT)) * CIRCLE_COUNTER_SNAP_INCREMENT;
	_tmp28_ = self->priv->_direction;
	if (_tmp28_ == CIRCLE_COUNTER_DIRECTION_COUNT_DOWN) {
		gdouble _tmp29_ = 0.0;
		_tmp29_ = progress_angle;
		if (_tmp29_ > ((gdouble) 0)) {
			cairo_t* _tmp30_ = NULL;
			gint _tmp31_ = 0;
			gint _tmp32_ = 0;
			gdouble _tmp33_ = 0.0;
			gdouble _tmp34_ = 0.0;
			gdouble _tmp35_ = 0.0;
			gdouble _tmp36_ = 0.0;
			_tmp30_ = cr;
			_tmp31_ = center_x;
			_tmp32_ = center_y;
			_tmp33_ = arc_radius;
			_tmp34_ = start_angle;
			_tmp35_ = start_angle;
			_tmp36_ = progress_angle;
			cairo_arc (_tmp30_, (gdouble) _tmp31_, (gdouble) _tmp32_, _tmp33_, _tmp34_, _tmp35_ - _tmp36_);
		} else {
			cairo_t* _tmp37_ = NULL;
			gint _tmp38_ = 0;
			gint _tmp39_ = 0;
			gdouble _tmp40_ = 0.0;
			gdouble _tmp41_ = 0.0;
			gdouble _tmp42_ = 0.0;
			_tmp37_ = cr;
			_tmp38_ = center_x;
			_tmp39_ = center_y;
			_tmp40_ = arc_radius;
			_tmp41_ = start_angle;
			_tmp42_ = start_angle;
			cairo_arc (_tmp37_, (gdouble) _tmp38_, (gdouble) _tmp39_, _tmp40_, _tmp41_, _tmp42_ + (G_PI * 2.0));
		}
	} else {
		gdouble _tmp43_ = 0.0;
		_tmp43_ = progress_angle;
		if (_tmp43_ > ((gdouble) 0)) {
			cairo_t* _tmp44_ = NULL;
			gint _tmp45_ = 0;
			gint _tmp46_ = 0;
			gdouble _tmp47_ = 0.0;
			gdouble _tmp48_ = 0.0;
			gdouble _tmp49_ = 0.0;
			gdouble _tmp50_ = 0.0;
			_tmp44_ = cr;
			_tmp45_ = center_x;
			_tmp46_ = center_y;
			_tmp47_ = arc_radius;
			_tmp48_ = start_angle;
			_tmp49_ = start_angle;
			_tmp50_ = progress_angle;
			cairo_arc_negative (_tmp44_, (gdouble) _tmp45_, (gdouble) _tmp46_, _tmp47_, _tmp48_, _tmp49_ - _tmp50_);
		}
	}
	_tmp51_ = cr;
	_tmp52_ = base_color;
	gdk_cairo_set_source_rgba (_tmp51_, &_tmp52_);
	_tmp53_ = cr;
	cairo_set_line_width (_tmp53_, CIRCLE_COUNTER_LINE_WIDTH);
	_tmp54_ = cr;
	cairo_set_line_cap (_tmp54_, CAIRO_LINE_CAP_ROUND);
	_tmp55_ = cr;
	cairo_stroke (_tmp55_);
	result = TRUE;
	_g_object_unref0 (style_context);
	return result;
}


static void circle_counter_real_get_preferred_width (GtkWidget* base, gint* minimum_width, gint* natural_width) {
	CircleCounter * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gint diameter = 0;
	gint _tmp0_ = 0;
	self = (CircleCounter*) base;
	_tmp0_ = circle_counter_calculate_diameter (self);
	diameter = _tmp0_;
	_vala_minimum_width = diameter;
	_vala_natural_width = diameter;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}


static void circle_counter_real_get_preferred_height (GtkWidget* base, gint* minimum_height, gint* natural_height) {
	CircleCounter * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gint diameter = 0;
	gint _tmp0_ = 0;
	self = (CircleCounter*) base;
	_tmp0_ = circle_counter_calculate_diameter (self);
	diameter = _tmp0_;
	_vala_minimum_height = diameter;
	_vala_natural_height = diameter;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}


static void circle_counter_real_size_allocate (GtkWidget* base, GtkAllocation* allocation) {
	CircleCounter * self;
	GtkAllocation _tmp0_ = {0};
	self = (CircleCounter*) base;
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	GTK_WIDGET_CLASS (circle_counter_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), &_tmp0_);
}


static gint circle_counter_calculate_diameter (CircleCounter* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = 2 * CIRCLE_COUNTER_DEFAULT_RADIUS;
	return result;
}


CircleCounterDirection circle_counter_get_direction (CircleCounter* self) {
	CircleCounterDirection result;
	CircleCounterDirection _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_direction;
	result = _tmp0_;
	return result;
}


void circle_counter_set_direction (CircleCounter* self, CircleCounterDirection value) {
	CircleCounterDirection _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_direction = _tmp0_;
	g_object_notify ((GObject *) self, "direction");
}


gdouble circle_counter_get_progress (CircleCounter* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_progress;
	result = _tmp0_;
	return result;
}


void circle_counter_set_progress (CircleCounter* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_progress = _tmp0_;
	g_object_notify ((GObject *) self, "progress");
}


static void circle_counter_class_init (CircleCounterClass * klass) {
	circle_counter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CircleCounterPrivate));
	((GtkWidgetClass *) klass)->draw = circle_counter_real_draw;
	((GtkWidgetClass *) klass)->get_preferred_width = circle_counter_real_get_preferred_width;
	((GtkWidgetClass *) klass)->get_preferred_height = circle_counter_real_get_preferred_height;
	((GtkWidgetClass *) klass)->size_allocate = circle_counter_real_size_allocate;
	G_OBJECT_CLASS (klass)->get_property = _vala_circle_counter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_circle_counter_set_property;
	G_OBJECT_CLASS (klass)->finalize = circle_counter_finalize;
	/**
	 * The direction of the countdown.
	 * COUNT_DOWN: a full circle that disappears as progress increases
	 * COUNT_UP: a circle gradually appears as progress increases
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CIRCLE_COUNTER_DIRECTION, g_param_spec_enum ("direction", "direction", "direction", CIRCLE_COUNTER_TYPE_DIRECTION, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * A value from 0.0 to 1.0, where 1.0 means the count is finished. The
	 * circle will be filled by this amount according to the direction
	 * property.
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), CIRCLE_COUNTER_PROGRESS, g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void circle_counter_instance_init (CircleCounter * self) {
	self->priv = CIRCLE_COUNTER_GET_PRIVATE (self);
}


static void circle_counter_finalize (GObject* obj) {
	CircleCounter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CIRCLE_COUNTER, CircleCounter);
	G_OBJECT_CLASS (circle_counter_parent_class)->finalize (obj);
}


/**
 * Displays a countdown using a circle, reminiscent of a countdown timer.
 * This widget can either count down or up, and it can switch between either
 * direction at any time.
 */
GType circle_counter_get_type (void) {
	static volatile gsize circle_counter_type_id__volatile = 0;
	if (g_once_init_enter (&circle_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CircleCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) circle_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CircleCounter), 0, (GInstanceInitFunc) circle_counter_instance_init, NULL };
		GType circle_counter_type_id;
		circle_counter_type_id = g_type_register_static (gtk_widget_get_type (), "CircleCounter", &g_define_type_info, 0);
		g_once_init_leave (&circle_counter_type_id__volatile, circle_counter_type_id);
	}
	return circle_counter_type_id__volatile;
}


static void _vala_circle_counter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CircleCounter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CIRCLE_COUNTER, CircleCounter);
	switch (property_id) {
		case CIRCLE_COUNTER_DIRECTION:
		g_value_set_enum (value, circle_counter_get_direction (self));
		break;
		case CIRCLE_COUNTER_PROGRESS:
		g_value_set_double (value, circle_counter_get_progress (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_circle_counter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CircleCounter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CIRCLE_COUNTER, CircleCounter);
	switch (property_id) {
		case CIRCLE_COUNTER_DIRECTION:
		circle_counter_set_direction (self, g_value_get_enum (value));
		break;
		case CIRCLE_COUNTER_PROGRESS:
		circle_counter_set_progress (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



