/* OverlayArrow.c generated by valac 0.32.1, the Vala compiler
 * generated from OverlayArrow.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */
/* FIXME: This widget is stealing clicks when it is used in an overlay */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_OVERLAY_ARROW (overlay_arrow_get_type ())
#define OVERLAY_ARROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OVERLAY_ARROW, OverlayArrow))
#define OVERLAY_ARROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OVERLAY_ARROW, OverlayArrowClass))
#define IS_OVERLAY_ARROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OVERLAY_ARROW))
#define IS_OVERLAY_ARROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OVERLAY_ARROW))
#define OVERLAY_ARROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OVERLAY_ARROW, OverlayArrowClass))

typedef struct _OverlayArrow OverlayArrow;
typedef struct _OverlayArrowClass OverlayArrowClass;
typedef struct _OverlayArrowPrivate OverlayArrowPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _OverlayArrow {
	GtkWidget parent_instance;
	OverlayArrowPrivate * priv;
};

struct _OverlayArrowClass {
	GtkWidgetClass parent_class;
};

struct _OverlayArrowPrivate {
	GtkWidget* from_widget;
	GtkWidget* to_widget;
};


static gpointer overlay_arrow_parent_class = NULL;

GType overlay_arrow_get_type (void) G_GNUC_CONST;
#define OVERLAY_ARROW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_OVERLAY_ARROW, OverlayArrowPrivate))
enum  {
	OVERLAY_ARROW_DUMMY_PROPERTY
};
OverlayArrow* overlay_arrow_new (GtkWidget* from_widget, GtkWidget* to_widget);
OverlayArrow* overlay_arrow_construct (GType object_type, GtkWidget* from_widget, GtkWidget* to_widget);
static gboolean overlay_arrow_real_draw (GtkWidget* base, cairo_t* cr);
static void overlay_arrow_get_from_coordinates (OverlayArrow* self, gint* from_x, gint* from_y);
static void overlay_arrow_get_to_coordinates (OverlayArrow* self, gint* to_x, gint* to_y);
static void overlay_arrow_real_size_allocate (GtkWidget* base, GtkAllocation* allocation);
static void overlay_arrow_get_points_offset (OverlayArrow* self, gint* offset_x, gint* offset_y);
static void overlay_arrow_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


OverlayArrow* overlay_arrow_construct (GType object_type, GtkWidget* from_widget, GtkWidget* to_widget) {
	OverlayArrow * self = NULL;
	GtkWidget* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	GtkWidget* _tmp3_ = NULL;
	g_return_val_if_fail (from_widget != NULL, NULL);
	g_return_val_if_fail (to_widget != NULL, NULL);
	self = (OverlayArrow*) g_object_new (object_type, NULL);
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
	_tmp0_ = from_widget;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->from_widget);
	self->priv->from_widget = _tmp1_;
	_tmp2_ = to_widget;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (self->priv->to_widget);
	self->priv->to_widget = _tmp3_;
	return self;
}


OverlayArrow* overlay_arrow_new (GtkWidget* from_widget, GtkWidget* to_widget) {
	return overlay_arrow_construct (TYPE_OVERLAY_ARROW, from_widget, to_widget);
}


static gboolean overlay_arrow_real_draw (GtkWidget* base, cairo_t* cr) {
	OverlayArrow * self;
	gboolean result = FALSE;
	gint max_width = 0;
	gint _tmp0_ = 0;
	gint max_height = 0;
	gint _tmp1_ = 0;
	gint from_x = 0;
	gint from_y = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint to_x = 0;
	gint to_y = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	GtkStateFlags state = 0;
	GtkStateFlags _tmp14_ = 0;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp15_ = NULL;
	GtkStyleContext* _tmp16_ = NULL;
	GdkRGBA color = {0};
	GdkRGBA _tmp17_ = {0};
	cairo_t* _tmp18_ = NULL;
	GdkRGBA _tmp19_ = {0};
	cairo_t* _tmp20_ = NULL;
	cairo_t* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gint _tmp23_ = 0;
	gdouble curve_x = 0.0;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	gdouble curve_y = 0.0;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	cairo_t* _tmp28_ = NULL;
	cairo_t* _tmp29_ = NULL;
	cairo_t* _tmp30_ = NULL;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	cairo_t* _tmp33_ = NULL;
	cairo_t* _tmp34_ = NULL;
	cairo_t* _tmp35_ = NULL;
	cairo_t* _tmp36_ = NULL;
	cairo_t* _tmp37_ = NULL;
	cairo_t* _tmp38_ = NULL;
	self = (OverlayArrow*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	_tmp0_ = gtk_widget_get_allocated_width ((GtkWidget*) self);
	max_width = _tmp0_;
	_tmp1_ = gtk_widget_get_allocated_height ((GtkWidget*) self);
	max_height = _tmp1_;
	overlay_arrow_get_from_coordinates (self, &_tmp2_, &_tmp3_);
	from_x = _tmp2_;
	from_y = _tmp3_;
	_tmp4_ = from_x;
	_tmp5_ = CLAMP (_tmp4_, 0, max_width);
	from_x = _tmp5_;
	_tmp6_ = from_y;
	_tmp7_ = CLAMP (_tmp6_, 0, max_height);
	from_y = _tmp7_;
	overlay_arrow_get_to_coordinates (self, &_tmp8_, &_tmp9_);
	to_x = _tmp8_;
	to_y = _tmp9_;
	_tmp10_ = to_x;
	_tmp11_ = CLAMP (_tmp10_, 0, max_width);
	to_x = _tmp11_;
	_tmp12_ = to_y;
	_tmp13_ = CLAMP (_tmp12_, 0, max_height);
	to_y = _tmp13_;
	_tmp14_ = gtk_widget_get_state_flags ((GtkWidget*) self);
	state = _tmp14_;
	_tmp15_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp16_ = _g_object_ref0 (_tmp15_);
	style_context = _tmp16_;
	gtk_style_context_get_color (style_context, state, &_tmp17_);
	color = _tmp17_;
	_tmp18_ = cr;
	_tmp19_ = color;
	gdk_cairo_set_source_rgba (_tmp18_, &_tmp19_);
	_tmp20_ = cr;
	cairo_set_line_width (_tmp20_, 1.0);
	_tmp21_ = cr;
	_tmp22_ = from_x;
	_tmp23_ = from_y;
	cairo_move_to (_tmp21_, (gdouble) _tmp22_, (gdouble) _tmp23_);
	_tmp24_ = to_x;
	_tmp25_ = from_x;
	curve_x = (gdouble) (_tmp24_ - _tmp25_);
	_tmp26_ = to_y;
	_tmp27_ = from_y;
	curve_y = (gdouble) ((_tmp26_ + 8) - _tmp27_);
	_tmp28_ = cr;
	cairo_rel_curve_to (_tmp28_, curve_x / 3.0, (gdouble) 0, curve_x, curve_y / 3.0, curve_x, curve_y);
	_tmp29_ = cr;
	cairo_stroke (_tmp29_);
	_tmp30_ = cr;
	_tmp31_ = to_x;
	_tmp32_ = to_y;
	cairo_move_to (_tmp30_, (gdouble) _tmp31_, (gdouble) (_tmp32_ + 8));
	_tmp33_ = cr;
	cairo_rel_line_to (_tmp33_, (gdouble) -4, (gdouble) 0);
	_tmp34_ = cr;
	cairo_rel_line_to (_tmp34_, (gdouble) 4, (gdouble) -6);
	_tmp35_ = cr;
	cairo_rel_line_to (_tmp35_, (gdouble) 4, (gdouble) 6);
	_tmp36_ = cr;
	cairo_close_path (_tmp36_);
	_tmp37_ = cr;
	cairo_fill_preserve (_tmp37_);
	_tmp38_ = cr;
	cairo_stroke (_tmp38_);
	result = TRUE;
	_g_object_unref0 (style_context);
	return result;
}


static void overlay_arrow_real_size_allocate (GtkWidget* base, GtkAllocation* allocation) {
	OverlayArrow * self;
	GtkAllocation _tmp0_ = {0};
	self = (OverlayArrow*) base;
	g_return_if_fail (allocation != NULL);
	_tmp0_ = *allocation;
	GTK_WIDGET_CLASS (overlay_arrow_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), &_tmp0_);
}


static void overlay_arrow_get_points_offset (OverlayArrow* self, gint* offset_x, gint* offset_y) {
	gint _vala_offset_x = 0;
	gint _vala_offset_y = 0;
	GtkAllocation to_allocation = {0};
	GtkWidget* _tmp0_ = NULL;
	GtkAllocation _tmp1_ = {0};
	GtkWidget* _tmp2_ = NULL;
	GtkWidget* _tmp3_ = NULL;
	GtkAllocation _tmp4_ = {0};
	gint _tmp5_ = 0;
	GtkAllocation _tmp6_ = {0};
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_widget;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	to_allocation = _tmp1_;
	_tmp2_ = self->priv->from_widget;
	_tmp3_ = self->priv->to_widget;
	_tmp4_ = to_allocation;
	_tmp5_ = _tmp4_.width;
	_tmp6_ = to_allocation;
	_tmp7_ = _tmp6_.width;
	gtk_widget_translate_coordinates (_tmp2_, _tmp3_, _tmp5_ / 2, _tmp7_ / 2, &_tmp8_, &_tmp9_);
	_vala_offset_x = _tmp8_;
	_vala_offset_y = _tmp9_;
	if (offset_x) {
		*offset_x = _vala_offset_x;
	}
	if (offset_y) {
		*offset_y = _vala_offset_y;
	}
}


static void overlay_arrow_get_from_coordinates (OverlayArrow* self, gint* from_x, gint* from_y) {
	gint _vala_from_x = 0;
	gint _vala_from_y = 0;
	GtkAllocation from_allocation = {0};
	GtkWidget* _tmp0_ = NULL;
	GtkAllocation _tmp1_ = {0};
	gint offset_x = 0;
	gint offset_y = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint from_local_x = 0;
	gint from_local_y = 0;
	gint _tmp4_ = 0;
	GtkWidget* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->from_widget;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	from_allocation = _tmp1_;
	overlay_arrow_get_points_offset (self, &_tmp2_, &_tmp3_);
	offset_x = _tmp2_;
	offset_y = _tmp3_;
	_tmp4_ = offset_x;
	if (_tmp4_ > 0) {
		GtkAllocation _tmp5_ = {0};
		gint _tmp6_ = 0;
		from_local_x = 0;
		_tmp5_ = from_allocation;
		_tmp6_ = _tmp5_.height;
		from_local_y = _tmp6_ / 2;
	} else {
		GtkAllocation _tmp7_ = {0};
		gint _tmp8_ = 0;
		GtkAllocation _tmp9_ = {0};
		gint _tmp10_ = 0;
		_tmp7_ = from_allocation;
		_tmp8_ = _tmp7_.width;
		from_local_x = _tmp8_;
		_tmp9_ = from_allocation;
		_tmp10_ = _tmp9_.height;
		from_local_y = _tmp10_ / 2;
	}
	_tmp11_ = self->priv->from_widget;
	_tmp12_ = from_local_x;
	_tmp13_ = from_local_y;
	gtk_widget_translate_coordinates (_tmp11_, (GtkWidget*) self, _tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
	_vala_from_x = _tmp14_;
	_vala_from_y = _tmp15_;
	if (from_x) {
		*from_x = _vala_from_x;
	}
	if (from_y) {
		*from_y = _vala_from_y;
	}
}


static void overlay_arrow_get_to_coordinates (OverlayArrow* self, gint* to_x, gint* to_y) {
	gint _vala_to_x = 0;
	gint _vala_to_y = 0;
	GtkAllocation to_allocation = {0};
	GtkWidget* _tmp0_ = NULL;
	GtkAllocation _tmp1_ = {0};
	gint offset_x = 0;
	gint offset_y = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint to_local_x = 0;
	gint to_local_y = 0;
	gint _tmp4_ = 0;
	GtkWidget* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gint _tmp13_ = 0;
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->to_widget;
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
	to_allocation = _tmp1_;
	overlay_arrow_get_points_offset (self, &_tmp2_, &_tmp3_);
	offset_x = _tmp2_;
	offset_y = _tmp3_;
	_tmp4_ = offset_y;
	if (_tmp4_ > 0) {
		GtkAllocation _tmp5_ = {0};
		gint _tmp6_ = 0;
		GtkAllocation _tmp7_ = {0};
		gint _tmp8_ = 0;
		_tmp5_ = to_allocation;
		_tmp6_ = _tmp5_.width;
		to_local_x = _tmp6_ / 2;
		_tmp7_ = to_allocation;
		_tmp8_ = _tmp7_.height;
		to_local_y = _tmp8_;
	} else {
		GtkAllocation _tmp9_ = {0};
		gint _tmp10_ = 0;
		_tmp9_ = to_allocation;
		_tmp10_ = _tmp9_.width;
		to_local_x = _tmp10_ / 2;
		to_local_y = 0;
	}
	_tmp11_ = self->priv->to_widget;
	_tmp12_ = to_local_x;
	_tmp13_ = to_local_y;
	gtk_widget_translate_coordinates (_tmp11_, (GtkWidget*) self, _tmp12_, _tmp13_, &_tmp14_, &_tmp15_);
	_vala_to_x = _tmp14_;
	_vala_to_y = _tmp15_;
	if (to_x) {
		*to_x = _vala_to_x;
	}
	if (to_y) {
		*to_y = _vala_to_y;
	}
}


static void overlay_arrow_class_init (OverlayArrowClass * klass) {
	overlay_arrow_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (OverlayArrowPrivate));
	((GtkWidgetClass *) klass)->draw = overlay_arrow_real_draw;
	((GtkWidgetClass *) klass)->size_allocate = overlay_arrow_real_size_allocate;
	G_OBJECT_CLASS (klass)->finalize = overlay_arrow_finalize;
}


static void overlay_arrow_instance_init (OverlayArrow * self) {
	self->priv = OVERLAY_ARROW_GET_PRIVATE (self);
}


static void overlay_arrow_finalize (GObject* obj) {
	OverlayArrow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_OVERLAY_ARROW, OverlayArrow);
	_g_object_unref0 (self->priv->from_widget);
	_g_object_unref0 (self->priv->to_widget);
	G_OBJECT_CLASS (overlay_arrow_parent_class)->finalize (obj);
}


GType overlay_arrow_get_type (void) {
	static volatile gsize overlay_arrow_type_id__volatile = 0;
	if (g_once_init_enter (&overlay_arrow_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OverlayArrowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) overlay_arrow_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OverlayArrow), 0, (GInstanceInitFunc) overlay_arrow_instance_init, NULL };
		GType overlay_arrow_type_id;
		overlay_arrow_type_id = g_type_register_static (gtk_widget_get_type (), "OverlayArrow", &g_define_type_info, 0);
		g_once_init_leave (&overlay_arrow_type_id__volatile, overlay_arrow_type_id);
	}
	return overlay_arrow_type_id__volatile;
}



