/* SettingsApplication.c generated by valac 0.32.1, the Vala compiler
 * generated from SettingsApplication.vala, do not modify */

/*
 * This file is part of GNOME Break Timer.
 * 
 * GNOME Break Timer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * GNOME Break Timer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNOME Break Timer.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <common.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>


#define TYPE_SETTINGS_APPLICATION (settings_application_get_type ())
#define SETTINGS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS_APPLICATION, SettingsApplication))
#define SETTINGS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS_APPLICATION, SettingsApplicationClass))
#define IS_SETTINGS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS_APPLICATION))
#define IS_SETTINGS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS_APPLICATION))
#define SETTINGS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS_APPLICATION, SettingsApplicationClass))

typedef struct _SettingsApplication SettingsApplication;
typedef struct _SettingsApplicationClass SettingsApplicationClass;
typedef struct _SettingsApplicationPrivate SettingsApplicationPrivate;

#define TYPE_BREAK_MANAGER (break_manager_get_type ())
#define BREAK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BREAK_MANAGER, BreakManager))
#define BREAK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BREAK_MANAGER, BreakManagerClass))
#define IS_BREAK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BREAK_MANAGER))
#define IS_BREAK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BREAK_MANAGER))
#define BREAK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BREAK_MANAGER, BreakManagerClass))

typedef struct _BreakManager BreakManager;
typedef struct _BreakManagerClass BreakManagerClass;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SettingsApplication {
	GtkApplication parent_instance;
	SettingsApplicationPrivate * priv;
};

struct _SettingsApplicationClass {
	GtkApplicationClass parent_class;
};

struct _SettingsApplicationPrivate {
	BreakManager* break_manager;
	MainWindow* main_window;
	guint delay_start_timeout_id;
};


static gpointer settings_application_parent_class = NULL;

GType settings_application_get_type (void) G_GNUC_CONST;
GType break_manager_get_type (void) G_GNUC_CONST;
GType main_window_get_type (void) G_GNUC_CONST;
#define SETTINGS_APPLICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SETTINGS_APPLICATION, SettingsApplicationPrivate))
enum  {
	SETTINGS_APPLICATION_DUMMY_PROPERTY
};
#define SETTINGS_APPLICATION_app_id HELPER_BUS_NAME ".Settings"
#define SETTINGS_APPLICATION_STYLE_DATA "\n" \
"\t\t._settings-title {\n" \
"\t\t\tfont-weight:bold;\n" \
"\t\t}\n" \
"\n" \
"\t\t._break-info {\n" \
"\t\t}\n" \
"\n" \
"\t\t._break-info-heading {\n" \
"\t\t\tfont-size: xx-large;\n" \
"\t\t}\n" \
"\n" \
"\t\t._break-status-heading {\n" \
"\t\t\tfont-size: larger;\n" \
"\t\t}\n" \
"\n" \
"\t\t._break-status-body {\n" \
"\t\t}\n" \
"\n" \
"\t\t._break-status-hint {\n" \
"\t\t\tfont-size: small;\n" \
"\t\t}\n" \
"\n" \
"\t\t._break-status-icon {\n" \
"\t\t\topacity: 0.2;\n" \
"\t\t}\n" \
"\n" \
"\t\t._circle-counter {\n" \
"\t\t\tcolor: @scrollbar_slider_prelight;\n" \
"\t\t\tbackground-color: @scrollbar_trough;\n" \
"\t\t}\n" \
"\t\t"
SettingsApplication* settings_application_new (void);
SettingsApplication* settings_application_construct (GType object_type);
static void settings_application_real_activate (GApplication* base);
gboolean break_manager_is_working (BreakManager* self);
static void settings_application_delayed_start (SettingsApplication* self);
static void settings_application_real_startup (GApplication* base);
static void settings_application_on_about_activate_cb (SettingsApplication* self);
static void _settings_application_on_about_activate_cb_g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self);
static void _g_application_quit_g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self);
BreakManager* break_manager_new (SettingsApplication* application);
BreakManager* break_manager_construct (GType object_type, SettingsApplication* application);
MainWindow* main_window_new (SettingsApplication* application, BreakManager* break_manager);
MainWindow* main_window_construct (GType object_type, SettingsApplication* application, BreakManager* break_manager);
void break_manager_load_breaks (BreakManager* self);
static void settings_application_delayed_start_cb (SettingsApplication* self);
static void _settings_application_delayed_start_cb_break_manager_break_status_available (BreakManager* _sender, gpointer self);
static gboolean __lambda8_ (SettingsApplication* self);
static gboolean ___lambda8__gsource_func (gpointer self);
void main_window_show_about_dialog (MainWindow* self);
static void settings_application_finalize (GObject* obj);


SettingsApplication* settings_application_construct (GType object_type) {
	SettingsApplication * self = NULL;
	self = (SettingsApplication*) g_object_new (object_type, "application-id", SETTINGS_APPLICATION_app_id, "flags", G_APPLICATION_FLAGS_NONE, NULL);
	return self;
}


SettingsApplication* settings_application_new (void) {
	return settings_application_construct (TYPE_SETTINGS_APPLICATION);
}


static void settings_application_real_activate (GApplication* base) {
	SettingsApplication * self;
	BreakManager* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	self = (SettingsApplication*) base;
	G_APPLICATION_CLASS (settings_application_parent_class)->activate ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
	_tmp0_ = self->priv->break_manager;
	_tmp1_ = break_manager_is_working (_tmp0_);
	if (_tmp1_) {
		MainWindow* _tmp2_ = NULL;
		_tmp2_ = self->priv->main_window;
		gtk_window_present ((GtkWindow*) _tmp2_);
	} else {
		settings_application_delayed_start (self);
	}
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _settings_application_on_about_activate_cb_g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self) {
	settings_application_on_about_activate_cb ((SettingsApplication*) self);
}


static void _g_application_quit_g_simple_action_activate (GSimpleAction* _sender, GVariant* parameter, gpointer self) {
	g_application_quit ((GApplication*) self);
}


static void settings_application_real_startup (GApplication* base) {
	SettingsApplication * self;
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_ = NULL;
	GdkScreen* _tmp1_ = NULL;
	GtkCssProvider* style_provider = NULL;
	GtkCssProvider* _tmp2_ = NULL;
	GSimpleAction* about_action = NULL;
	GSimpleAction* _tmp6_ = NULL;
	GSimpleAction* quit_action = NULL;
	GSimpleAction* _tmp7_ = NULL;
	GMenu* app_menu = NULL;
	GMenu* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	BreakManager* _tmp11_ = NULL;
	BreakManager* _tmp12_ = NULL;
	MainWindow* _tmp13_ = NULL;
	BreakManager* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	self = (SettingsApplication*) base;
	G_APPLICATION_CLASS (settings_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
	_tmp0_ = gdk_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = gtk_css_provider_new ();
	style_provider = _tmp2_;
	{
		gtk_css_provider_load_from_data (style_provider, SETTINGS_APPLICATION_STYLE_DATA, (gssize) -1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* _error_ = NULL;
		FILE* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = stderr;
		_tmp4_ = _error_;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp3_, "Error loading style data: %s\n", _tmp5_);
		_g_error_free0 (_error_);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (style_provider);
		_g_object_unref0 (screen);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) style_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	_tmp6_ = g_simple_action_new ("about", NULL);
	about_action = _tmp6_;
	g_action_map_add_action ((GActionMap*) self, (GAction*) about_action);
	g_signal_connect_object (about_action, "activate", (GCallback) _settings_application_on_about_activate_cb_g_simple_action_activate, self, 0);
	_tmp7_ = g_simple_action_new ("quit", NULL);
	quit_action = _tmp7_;
	g_action_map_add_action ((GActionMap*) self, (GAction*) quit_action);
	g_signal_connect_object (quit_action, "activate", (GCallback) _g_application_quit_g_simple_action_activate, (GApplication*) self, 0);
	_tmp8_ = g_menu_new ();
	app_menu = _tmp8_;
	_tmp9_ = _ ("About");
	g_menu_append (app_menu, _tmp9_, "app.about");
	_tmp10_ = _ ("Quit");
	g_menu_append (app_menu, _tmp10_, "app.quit");
	gtk_application_set_app_menu ((GtkApplication*) self, (GMenuModel*) app_menu);
	_tmp11_ = break_manager_new (self);
	_g_object_unref0 (self->priv->break_manager);
	self->priv->break_manager = _tmp11_;
	_tmp12_ = self->priv->break_manager;
	_tmp13_ = main_window_new (self, _tmp12_);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->main_window);
	self->priv->main_window = _tmp13_;
	_tmp14_ = self->priv->break_manager;
	break_manager_load_breaks (_tmp14_);
	_g_object_unref0 (app_menu);
	_g_object_unref0 (quit_action);
	_g_object_unref0 (about_action);
	_g_object_unref0 (style_provider);
	_g_object_unref0 (screen);
}


static void _settings_application_delayed_start_cb_break_manager_break_status_available (BreakManager* _sender, gpointer self) {
	settings_application_delayed_start_cb ((SettingsApplication*) self);
}


static gboolean __lambda8_ (SettingsApplication* self) {
	gboolean result = FALSE;
	settings_application_delayed_start_cb (self);
	result = FALSE;
	return result;
}


static gboolean ___lambda8__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda8_ ((SettingsApplication*) self);
	return result;
}


static void settings_application_delayed_start (SettingsApplication* self) {
	BreakManager* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->break_manager;
	g_signal_connect_object (_tmp0_, "break-status-available", (GCallback) _settings_application_delayed_start_cb_break_manager_break_status_available, self, 0);
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ___lambda8__gsource_func, g_object_ref (self), g_object_unref);
}


static void settings_application_delayed_start_cb (SettingsApplication* self) {
	BreakManager* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	MainWindow* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->break_manager;
	g_signal_parse_name ("break-status-available", TYPE_BREAK_MANAGER, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _settings_application_delayed_start_cb_break_manager_break_status_available, self);
	_tmp2_ = self->priv->main_window;
	_tmp3_ = gtk_widget_is_visible ((GtkWidget*) _tmp2_);
	if (!_tmp3_) {
		MainWindow* _tmp4_ = NULL;
		_tmp4_ = self->priv->main_window;
		gtk_window_present ((GtkWindow*) _tmp4_);
	}
}


static void settings_application_on_about_activate_cb (SettingsApplication* self) {
	MainWindow* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->main_window;
	main_window_show_about_dialog (_tmp0_);
}


static void settings_application_class_init (SettingsApplicationClass * klass) {
	settings_application_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SettingsApplicationPrivate));
	((GApplicationClass *) klass)->activate = settings_application_real_activate;
	((GApplicationClass *) klass)->startup = settings_application_real_startup;
	G_OBJECT_CLASS (klass)->finalize = settings_application_finalize;
}


static void settings_application_instance_init (SettingsApplication * self) {
	self->priv = SETTINGS_APPLICATION_GET_PRIVATE (self);
}


static void settings_application_finalize (GObject* obj) {
	SettingsApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS_APPLICATION, SettingsApplication);
	_g_object_unref0 (self->priv->break_manager);
	_g_object_unref0 (self->priv->main_window);
	G_OBJECT_CLASS (settings_application_parent_class)->finalize (obj);
}


GType settings_application_get_type (void) {
	static volatile gsize settings_application_type_id__volatile = 0;
	if (g_once_init_enter (&settings_application_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SettingsApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SettingsApplication), 0, (GInstanceInitFunc) settings_application_instance_init, NULL };
		GType settings_application_type_id;
		settings_application_type_id = g_type_register_static (gtk_application_get_type (), "SettingsApplication", &g_define_type_info, 0);
		g_once_init_leave (&settings_application_type_id__volatile, settings_application_type_id);
	}
	return settings_application_type_id__volatile;
}



